package com.perforce.hws.p4base;

import com.perforce.p4java.server.IServer;

import java.util.List;
import java.util.function.Supplier;
import java.util.regex.Matcher;
import java.util.regex.Pattern;

/**
 * Created by tjuricek on 1/18/16.
 */
public interface ChangelistMethods extends P4Methods {

    Pattern CHANGE_CREATED_RE = Pattern.compile("^Change (\\d+)");

    default String createChangelist(Supplier<IServer> serverSupplier,
                                    String description) {
        List<ResultMap> results = exec(serverSupplier, "change", "-o");
        ResultMap change = results.get(0);

        if (description == null) {
            description = "";
        }

        change.put("Description", description);

        List<ResultMap> createResults =
                execInput(serverSupplier, change, "change", "-i");

        Matcher matcher = CHANGE_CREATED_RE.matcher((String)createResults.get(0).get("change"));

        if (matcher.matches()) {
            return matcher.group(1);
        } else {
            throw new IllegalStateException("Could not detect changelist in results");
        }
    }
}
