package com.perforce.hws.p4base;

/**
 * Mostly captures errors that are from P4Java, but are not related to actual
 * server responses.
 * <p>
 * In many cases, structured exception handling might cause many developers to
 * "swallow" these exceptions. (For example, to provide a simpler interface.)
 * We want you to just wrap those exceptions with this class and note it.
 */
public class P4JavaRuntimeException extends RuntimeException {

    public P4JavaRuntimeException() {
        super();
    }

    public P4JavaRuntimeException(Throwable cause) {
        super(cause);
    }

    public P4JavaRuntimeException(String message) {
        super(message);
    }

    public P4JavaRuntimeException(String message, Throwable cause) {
        super(message, cause);
    }

    protected P4JavaRuntimeException(String message, Throwable cause, boolean enableSuppression, boolean writableStackTrace) {
        super(message, cause, enableSuppression, writableStackTrace);
    }
}
