package com.perforce.hws.p4base;

import com.perforce.p4java.exception.MessageGenericCode;
import com.perforce.p4java.exception.MessageSeverityCode;
import com.perforce.p4java.exception.MessageSubsystemCode;

/**
 * Created by tjuricek on 12/7/15.
 */

public class ErrorIds {

    private static final String ID_REL="12.1";
    // subsystems
    private static final int ES_SERVER = MessageSubsystemCode.ES_SERVER;
    private static final int ES_DM = MessageSubsystemCode.ES_DM;
    private static final int ES_RPC = MessageSubsystemCode.ES_RPC;
    private static final int ES_SUPP = MessageSubsystemCode.ES_SUPP;
    private static final int ES_DB = MessageSubsystemCode.ES_DB;
    private static final int ES_LBR = MessageSubsystemCode.ES_LBR;
    private static final int ES_CLIENT = MessageSubsystemCode.ES_CLIENT;
    private static final int ES_OS = MessageSubsystemCode.ES_OS;

    // severities
    private static final int E_FAILED = MessageSeverityCode.E_FAILED;
    private static final int E_INFO = MessageSeverityCode.E_INFO;
    private static final int E_WARN = MessageSeverityCode.E_WARN;
    private static final int E_FATAL = MessageSeverityCode.E_FATAL;


    // generics
    private static final int EV_FAULT = MessageGenericCode.EV_FAULT;
    private static final int EV_EMPTY = MessageGenericCode.EV_EMPTY;
    private static final int EV_CONFIG = MessageGenericCode.EV_CONFIG;
    private static final int EV_UPGRADE = MessageGenericCode.EV_UPGRADE;
    private static final int EV_ILLEGAL= MessageGenericCode.EV_ILLEGAL;
    private static final int EV_NONE = MessageGenericCode.EV_NONE;
    private static final int EV_UNKNOWN = MessageGenericCode.EV_UNKNOWN;
    private static final int EV_USAGE = MessageGenericCode.EV_USAGE;

    private static final int EV_COMM = MessageGenericCode.EV_COMM;
    private static final int EV_ADMIN = MessageGenericCode.EV_ADMIN;
    private static final int EV_NOTYET = MessageGenericCode.EV_NOTYET;
    private static final int EV_PROTECT = MessageGenericCode.EV_PROTECT;
    private static final int EV_CONTEXT = MessageGenericCode.EV_CONTEXT;
    private static final int EV_TOOBIG = MessageGenericCode.EV_TOOBIG;
    private static final int EV_CLIENT = MessageGenericCode.EV_CLIENT;


    // helper, not really needed by keeps the server file format roughly the
    // same
    public static ErrorId ErrorOf(int sub, int cod, int sev, int gen, int args, String code) {
        return new ErrorId(sub, cod, sev, gen, args, (String) null);
    }

    // these come out of various server message files; build a similar object
    // for each error.
//    public static final ErrorId MsgDm_ChangeUpdated           = new ErrorId( ErrorOf( ES_DM, 201, E_INFO, 0, 5 ), "%change% updated[, adding %workCount% file(s)][, removing %workCount2% file(s)][, adding %jobCount% fix(es)][, removing %jobCount2% fix(es)]." ) ;
//    public static final ErrorId MsgDm_LockAlready             = new ErrorId( ErrorOf( ES_DM, 277, E_INFO, 0, 1 ), "%depotFile% - already locked" );
//    public static final ErrorId MsgDm_LockAlreadyOther        = new ErrorId( ErrorOf( ES_DM, 278, E_INFO, 0, 3 ), "%depotFile% - already locked by %user%@%client%" );
//    public static final ErrorId MsgDm_LockNoPermission        = new ErrorId( ErrorOf( ES_DM, 279, E_INFO, 0, 1 ), "%depotFile% - no permission to lock file" );
//    public static final ErrorId MsgDm_OpenXOpened             = new ErrorId( ErrorOf( ES_DM, 286, E_INFO, 0, 2 ), "%depotFile% - can't %action% exclusive file already opened" ) ;
//    public static final ErrorId MsgDm_LockBadUnicode          = new ErrorId( ErrorOf( ES_DM, 525, E_INFO, 0, 1 ), "%depotFile% - cannot submit unicode type file using non-unicode server" );
//    public static final ErrorId MsgDm_LockUtf16NotSupp        = new ErrorId( ErrorOf( ES_DM, 526, E_INFO, 0, 1 ), "%depotFile% - utf16 files can not be submitted by pre-2007.2 clients" );
//    public static final ErrorId MsgDm_ExFILE                  = new ErrorId( ErrorOf( ES_DM, 375, E_WARN, EV_EMPTY, 1 ), "[%argc% - no|No] such file(s)." );
//    public static final ErrorId MsgDm_ExVIEW                  = new ErrorId( ErrorOf( ES_DM, 367, E_WARN, EV_EMPTY, 1 ), "[%argc% - file(s)|File(s)] not in client view." ) ;
//
//    public static final ErrorId MsgServer_Password982         = new ErrorId( ErrorOf( ES_SERVER, 20, E_FAILED, EV_UPGRADE, 0 ), "You need a 98.2 or newer client to access as a password-protected user." );
//    public static final ErrorId MsgServer_BadPassword         = new ErrorId( ErrorOf( ES_SERVER, 21, E_FAILED, EV_CONFIG, 0 ), "Perforce password (P4PASSWD) invalid or unset." );
//    public static final ErrorId MsgServer_WeakPassword        = new ErrorId( ErrorOf( ES_SERVER, 321, E_FAILED, EV_USAGE, 0 ), "The security level of this server requires the password to be reset." );
//    public static final ErrorId MsgServer_PasswordExpired     = new ErrorId( ErrorOf( ES_SERVER, 455, E_FAILED, EV_ILLEGAL, 0 ), "Your password has expired, please change your password." );
//    public static final ErrorId MsgServer_LoginNotRequired    = new ErrorId( ErrorOf( ES_SERVER, 313, E_INFO, EV_NONE, 0 ), "'login' not necessary, no password set for this user." );
//    public static final ErrorId MsgServer_LoginNoTicket       = new ErrorId( ErrorOf( ES_SERVER, 327, E_INFO, EV_NONE, 4 ), "User %user% was authenticated by password not ticket." );
//    public static final ErrorId MsgServer_CantChangeOther     = new ErrorId( ErrorOf( ES_SERVER, 336, E_FAILED, EV_ILLEGAL, 0 ), "Cannot change password for another user with external authentication." );
//    public static final ErrorId MsgServer_AdminPasswordNoSuchUser = new ErrorId( ErrorOf( ES_SERVER, 618, E_FAILED, EV_UNKNOWN, 1 ), "%user% - no such user, or user does not have a password." );

    // Following are generated code from p4 .h and .cc files.

    public static final ErrorId MsgClient_BadFlag             	= new ErrorId( ErrorOf( ES_CLIENT, 3, E_FAILED, EV_USAGE, 0 , "805380099"),  "Unknown flag.  Try ? for help."  ) ;
    public static final ErrorId MsgClient_BadMarshalInput     	= new ErrorId( ErrorOf( ES_CLIENT, 29, E_FAILED, EV_CLIENT, 0 , "807542813"),  "Invalid marshalled data supplied as input."  ) ;
    public static final ErrorId MsgClient_BadSignature        	= new ErrorId( ErrorOf( ES_CLIENT, 16, E_FATAL, EV_CLIENT, 0 , "1075978256"),  "EDITOR_SIGNATURE must be 4 characters exactly!"  ) ;
    public static final ErrorId MsgClient_CantEdit            	= new ErrorId( ErrorOf( ES_CLIENT, 7, E_FAILED, EV_CLIENT, 1 , "824320007"),  "%type% - can't edit this type of file!"  ) ;
    public static final ErrorId MsgClient_CantFindApp         	= new ErrorId( ErrorOf( ES_CLIENT, 15, E_FATAL, EV_CLIENT, 0 , "1075978255"),  "Could not find application!"  ) ;
    public static final ErrorId MsgClient_CheckFileAssume     	= new ErrorId( ErrorOf( ES_CLIENT, 30, E_INFO, EV_CLIENT, 3 , "321003550"),  "%file% - %type%, assuming %type2%."  ) ;
    public static final ErrorId MsgClient_CheckFileAssumeWild 	= new ErrorId( ErrorOf( ES_CLIENT, 41, E_INFO, EV_CLIENT, 4 , "337780777"),  "%file% - %type%, assuming %type2% (%modified%)."  ) ;
    public static final ErrorId MsgClient_CheckFileCant       	= new ErrorId( ErrorOf( ES_CLIENT, 32, E_INFO, EV_CLIENT, 2 , "304226336"),  "%file% - %type% file can't be added."  ) ;
    public static final ErrorId MsgClient_CheckFileSubst      	= new ErrorId( ErrorOf( ES_CLIENT, 31, E_INFO, EV_CLIENT, 3 , "321003551"),  "%file% - using %type% instead of %type2%"  ) ;
    public static final ErrorId MsgClient_ClobberFile         	= new ErrorId( ErrorOf( ES_CLIENT, 4, E_FAILED, EV_CLIENT, 1 , "824320004"),  "Can't clobber writable file %file%"  ) ;
    public static final ErrorId MsgClient_Confirm             	= new ErrorId( ErrorOf( ES_CLIENT, 25, E_INFO, EV_CLIENT, 0 , "270671897"),  "This overrides your changes: confirm accept (y/n)? "  ) ;
    public static final ErrorId MsgClient_ConfirmEdit         	= new ErrorId( ErrorOf( ES_CLIENT, 24, E_INFO, EV_CLIENT, 0 , "270671896"),  "Use 'ae' to indicate original edits: confirm accept merge (y/n)? "  ) ;
    public static final ErrorId MsgClient_ConfirmMarkers      	= new ErrorId( ErrorOf( ES_CLIENT, 23, E_INFO, EV_CLIENT, 0 , "270671895"),  "There are still change markers: confirm accept (y/n)? "  ) ;
    public static final ErrorId MsgClient_Connect             	= new ErrorId( ErrorOf( ES_CLIENT, 1, E_FAILED, EV_COMM, 0 , "807804929"),  "Connect to server failed; check $P4PORT."  ) ;
    public static final ErrorId MsgClient_DigestMisMatch      	= new ErrorId( ErrorOf( ES_CLIENT, 37, E_FAILED, EV_CLIENT, 3 , "857874469"),  "%clientFile% corrupted during transfer (or bad on the server) %clientDigest% vs %serverDigest%"  ) ;
    public static final ErrorId MsgClient_Eof                 	= new ErrorId( ErrorOf( ES_CLIENT, 6, E_FAILED, EV_CLIENT, 0 , "807542790"),  "EOF reading terminal."  ) ;
    public static final ErrorId MsgClient_Fatal               	= new ErrorId( ErrorOf( ES_CLIENT, 2, E_FATAL, EV_CLIENT, 0 , "1075978242"),  "Fatal client error; disconnecting!"  ) ;
    public static final ErrorId MsgClient_FileExists          	= new ErrorId( ErrorOf( ES_CLIENT, 34, E_FAILED, EV_CLIENT, 1 , "824320034"),  "%file% - can't overwrite existing file."  ) ;
    public static final ErrorId MsgClient_FileOpenError       	= new ErrorId( ErrorOf( ES_CLIENT, 40, E_FAILED, EV_CLIENT, 0 , "807542824"),  "Error opening file."  ) ;
    public static final ErrorId MsgClient_LineTooLong         	= new ErrorId( ErrorOf( ES_CLIENT, 39, E_FAILED, EV_CLIENT, 1 , "824320039"),  "Command line too long. Maximum length is %maxLineLen%. This length can be increased by setting filesys.bufsize in P4CONFIG or using -v."  ) ;
    public static final ErrorId MsgClient_LoginPrintTicket    	= new ErrorId( ErrorOf( ES_CLIENT, 36, E_INFO, EV_NONE, 1 , "285220900"),  "%ticket%"  ) ;
    public static final ErrorId MsgClient_Memory              	= new ErrorId( ErrorOf( ES_CLIENT, 14, E_FATAL, EV_CLIENT, 0 , "1075978254"),  "Out of memory!"  ) ;
    public static final ErrorId MsgClient_MergeMsg2           	= new ErrorId( ErrorOf( ES_CLIENT, 28, E_INFO, EV_CLIENT, 4 , "337780764"),  "Non-text diff: %yours% yours + %theirs% theirs + %both% both + %conflicting% conflicting"  ) ;
    public static final ErrorId MsgClient_MergeMsg3           	= new ErrorId( ErrorOf( ES_CLIENT, 20, E_INFO, EV_CLIENT, 4 , "337780756"),  "Diff chunks: %yours% yours + %theirs% theirs + %both% both + %conflicting% conflicting"  ) ;
    public static final ErrorId MsgClient_MergeMsg32          	= new ErrorId( ErrorOf( ES_CLIENT, 21, E_INFO, EV_CLIENT, 1 , "287449109"),  "Diff chunks: %chunks% between yours and theirs (no common base)"  ) ;
    public static final ErrorId MsgClient_MergePrompt         	= new ErrorId( ErrorOf( ES_CLIENT, 22, E_INFO, EV_CLIENT, 1 , "287449110"),  "Accept(a) Edit(e) Diff(d) Merge (m) Skip(s) Help(?) [%mergeDefault%]: "  ) ;
    public static final ErrorId MsgClient_MergePrompt2        	= new ErrorId( ErrorOf( ES_CLIENT, 26, E_INFO, EV_CLIENT, 1 , "287449114"),  "Accept (at/ay) Skip (s) Help (?) [%mergeDefault%]: "  ) ;
    public static final ErrorId MsgClient_MergePrompt2Edit    	= new ErrorId( ErrorOf( ES_CLIENT, 27, E_INFO, EV_CLIENT, 1 , "287449115"),  "Accept (at/ay) Edit (et/ey) Skip (s) Help (?) [%mergeDefault%]: "  ) ;
    public static final ErrorId MsgClient_MkDir               	= new ErrorId( ErrorOf( ES_CLIENT, 5, E_FAILED, EV_CLIENT, 1 , "824320005"),  "can't create directory for %file%"  ) ;
    public static final ErrorId MsgClient_NoMerger            	= new ErrorId( ErrorOf( ES_CLIENT, 8, E_FAILED, EV_CLIENT, 0 , "807542792"),  "No merge program specified with $P4MERGE or $MERGE."  ) ;
    public static final ErrorId MsgClient_NoSuchFile          	= new ErrorId( ErrorOf( ES_CLIENT, 35, E_FAILED, EV_CLIENT, 1 , "824320035"),  "%file% - file does not exist."  ) ;
    public static final ErrorId MsgClient_NonTextFileMerge    	= new ErrorId( ErrorOf( ES_CLIENT, 19, E_INFO, EV_CLIENT, 0 , "270671891"),  "Non-text file merge."  ) ;
    public static final ErrorId MsgClient_NotUnderPath        	= new ErrorId( ErrorOf( ES_CLIENT, 38, E_FAILED, EV_CLIENT, 2 , "841097254"),  "File %clientFile% is not inside permitted filesystem path %clientPath%"  ) ;
    public static final ErrorId MsgClient_ResolveManually     	= new ErrorId( ErrorOf( ES_CLIENT, 18, E_INFO, EV_CLIENT, 0 , "270671890"),  "Must resolve manually."  ) ;
    public static final ErrorId MsgClient_ToolCmdCreate       	= new ErrorId( ErrorOf( ES_CLIENT, 12, E_FAILED, EV_CLIENT, 0 , "807542796"),  "Could not create command to send to ToolServer."  ) ;
    public static final ErrorId MsgClient_ToolCmdSend         	= new ErrorId( ErrorOf( ES_CLIENT, 13, E_FAILED, EV_CLIENT, 0 , "807542797"),  "Could not send command to ToolServer."  ) ;
    public static final ErrorId MsgClient_ToolServer          	= new ErrorId( ErrorOf( ES_CLIENT, 11, E_FAILED, EV_CLIENT, 0 , "807542795"),  "Could not start ToolServer."  ) ;
    public static final ErrorId MsgClient_ToolServer2         	= new ErrorId( ErrorOf( ES_CLIENT, 10, E_FAILED, EV_CLIENT, 0 , "807542794"),  "Could not start another ToolServer.  Tool is running under ToolServer."  ) ;
    public static final ErrorId MsgClient_ZCResolve           	= new ErrorId( ErrorOf( ES_CLIENT, 33, E_FAILED, EV_COMM, 0 , "807804961"),  "Zeroconf resolved '%name%' to '%port%'."  ) ;
    public static final ErrorId MsgDb_AddressChanged          	= new ErrorId( ErrorOf( ES_DB, 75, E_FAILED, EV_ADMIN, 0 , "807604299"),  "Server license IPaddress changed, cannot proceed."  ) ;
    public static final ErrorId MsgDb_BadIPservice            	= new ErrorId( ErrorOf( ES_DB, 88, E_FAILED, EV_ADMIN, 1 , "824381528"),  "Licensed client service cannot be localhost (127.0.0.1 or ::1)"  ) ;
    public static final ErrorId MsgDb_CaseMismatch	       	= new ErrorId( ErrorOf( ES_DB, 77, E_FATAL, EV_FAULT, 0 , "1075908685"),  "BTree Case Order Mismatch! Check p4d -Cx flag usage."  ) ;
    public static final ErrorId MsgDb_CheckpointNoOverwrite   	= new ErrorId( ErrorOf( ES_DB, 90, E_FATAL, 0, 0 , "1073746010"),  "A full checkpoint should not be replayed into a non-empty database. Please remove the existing db.* files and retry the operation. The '-jrF' flag can be specified to bypass this check."  ) ;
    public static final ErrorId MsgDb_Checksum                	= new ErrorId( ErrorOf( ES_DB, 56, E_FAILED, EV_ADMIN, 0 , "807604280"),  "Invalid checksum string."  ) ;
    public static final ErrorId MsgDb_ClientGone              	= new ErrorId( ErrorOf( ES_DB, 62, E_FATAL, EV_ADMIN, 0 , "1076039742"),  "Client has dropped connection, terminating request."  ) ;
    public static final ErrorId MsgDb_CommandCancelled        	= new ErrorId( ErrorOf( ES_DB, 62, E_FATAL, EV_ADMIN, 0 , "1076039742"),  "Command has been cancelled, terminating request."  ) ;
    public static final ErrorId MsgDb_DbOpen                  	= new ErrorId( ErrorOf( ES_DB, 15, E_FATAL, EV_ADMIN, 1 , "1092816911"),  "Database open error on %table%!"  ) ;
    public static final ErrorId MsgDb_DbStat                  	= new ErrorId( ErrorOf( ES_DB, 65, E_INFO, 0, 4 , "335548481"),  "--- %table% pos %position% get %get% scan %scan%"  ) ;
    public static final ErrorId MsgDb_DelNoLock               	= new ErrorId( ErrorOf( ES_DB, 25, E_FATAL, EV_FAULT, 1 , "1092685849"),  "dbdel %table%: no write lock!"  ) ;
    public static final ErrorId MsgDb_Delete                  	= new ErrorId( ErrorOf( ES_DB, 26, E_FATAL, EV_FAULT, 1 , "1092685850"),  "Database delete error on %table%!"  ) ;
    public static final ErrorId MsgDb_Duplicate               	= new ErrorId( ErrorOf( ES_DB, 37, E_FAILED, EV_USAGE, 1 , "822153253"),  "Duplicate wildcards in '%arg%'."  ) ;
    public static final ErrorId MsgDb_EndXact                 	= new ErrorId( ErrorOf( ES_DB, 28, E_FATAL, EV_FAULT, 1 , "1092685852"),  "End xact with %table% still locked!"  ) ;
    public static final ErrorId MsgDb_ExtraDots               	= new ErrorId( ErrorOf( ES_DB, 35, E_FAILED, EV_USAGE, 1 , "822153251"),  "Only three ... permitted in '%arg%'."  ) ;
    public static final ErrorId MsgDb_ExtraStars              	= new ErrorId( ErrorOf( ES_DB, 36, E_FAILED, EV_USAGE, 1 , "822153252"),  "Too many *'s in '%arg%'."  ) ;
    public static final ErrorId MsgDb_Field2Many              	= new ErrorId( ErrorOf( ES_DB, 42, E_FAILED, EV_USAGE, 1 , "822153258"),  "Too many entries for field '%field%'."  ) ;
    public static final ErrorId MsgDb_FieldBadIndex           	= new ErrorId( ErrorOf( ES_DB, 46, E_FAILED, EV_USAGE, 0 , "805376046"),  "Can't find numbered field in spec."  ) ;
    public static final ErrorId MsgDb_FieldBadVal             	= new ErrorId( ErrorOf( ES_DB, 43, E_FAILED, EV_USAGE, 2 , "838930475"),  "Value for field '%field%' must be one of %text%."  ) ;
    public static final ErrorId MsgDb_FieldMissing            	= new ErrorId( ErrorOf( ES_DB, 45, E_FAILED, EV_USAGE, 1 , "822153261"),  "Missing required field '%field%'."  ) ;
    public static final ErrorId MsgDb_FieldOptBad             	= new ErrorId( ErrorOf( ES_DB, 49, E_FAILED, EV_USAGE, 2 , "838930481"),  "Unknown option '%option%' for field '%field%'."  ) ;
    public static final ErrorId MsgDb_FieldTypeBad            	= new ErrorId( ErrorOf( ES_DB, 48, E_FAILED, EV_USAGE, 2 , "838930480"),  "Unknown type '%type%' for field '%field%'."  ) ;
    public static final ErrorId MsgDb_FieldUnknown            	= new ErrorId( ErrorOf( ES_DB, 47, E_FAILED, EV_USAGE, 1 , "822153263"),  "Unknown field name '%field%'."  ) ;
    public static final ErrorId MsgDb_FieldWords              	= new ErrorId( ErrorOf( ES_DB, 44, E_FAILED, EV_USAGE, 1 , "822153260"),  "Wrong number of words for field '%field%'."  ) ;
    public static final ErrorId MsgDb_GetFormat               	= new ErrorId( ErrorOf( ES_DB, 21, E_FATAL, EV_FAULT, 2 , "1109463061"),  "dbget: %table% record format %level% unsupported!"  ) ;
    public static final ErrorId MsgDb_GetNoGet                	= new ErrorId( ErrorOf( ES_DB, 64, E_FATAL, EV_FAULT, 1 , "1092685888"),  "GetDb of %table% without prior get!"  ) ;
    public static final ErrorId MsgDb_InternalUsage	       	= new ErrorId( ErrorOf( ES_DB, 68, E_FATAL, EV_FAULT, 0 , "1075908676"),  "Internal BTree usage is not supported!"  ) ;
    public static final ErrorId MsgDb_JnlBadMarker            	= new ErrorId( ErrorOf( ES_DB, 76, E_FATAL, EV_ADMIN, 0 , "1076039756"),  "Bad transaction marker!"  ) ;
    public static final ErrorId MsgDb_JnlBadVers              	= new ErrorId( ErrorOf( ES_DB, 11, E_FATAL, EV_ADMIN, 0 , "1076039691"),  "Record version not known in journal record!"  ) ;
    public static final ErrorId MsgDb_JnlCaseUsageBad         	= new ErrorId( ErrorOf( ES_DB, 80, E_FATAL, EV_ADMIN, 2 , "1109594192"),  "Case-handling mismatch: server uses %caseUsage% but journal flags are %flags%!"  ) ;
    public static final ErrorId MsgDb_JnlDeleteFailed         	= new ErrorId( ErrorOf( ES_DB, 89, E_FATAL, EV_ADMIN, 2 , "1109594201"),  "In table %tableName%, the following row was not present or could not be deleted. It may be possible to use the '-f' flag to proceed beyond this point. Row data: \"%rowData%\""  ) ;
    public static final ErrorId MsgDb_JnlEnd                  	= new ErrorId( ErrorOf( ES_DB, 1, E_FATAL, EV_ADMIN, 0 , "1076039681"),  "End of input in middle of word!"  ) ;
    public static final ErrorId MsgDb_JnlFileBad              	= new ErrorId( ErrorOf( ES_DB, 14, E_FATAL, EV_ADMIN, 2 , "1109594126"),  "Journal file '%file%' replay failed at line %line%!"  ) ;
    public static final ErrorId MsgDb_JnlNoName               	= new ErrorId( ErrorOf( ES_DB, 9, E_FATAL, EV_ADMIN, 0 , "1076039689"),  "Missing table name in journal record!"  ) ;
    public static final ErrorId MsgDb_JnlNoTVers              	= new ErrorId( ErrorOf( ES_DB, 10, E_FATAL, EV_ADMIN, 0 , "1076039690"),  "Missing table version in journal record!"  ) ;
    public static final ErrorId MsgDb_JnlNoVers               	= new ErrorId( ErrorOf( ES_DB, 8, E_FATAL, EV_ADMIN, 0 , "1076039688"),  "Missing version number in journal record!"  ) ;
    public static final ErrorId MsgDb_JnlNum2Big              	= new ErrorId( ErrorOf( ES_DB, 5, E_FATAL, EV_ADMIN, 0 , "1076039685"),  "Word too big for a number!"  ) ;
    public static final ErrorId MsgDb_JnlOct2Long             	= new ErrorId( ErrorOf( ES_DB, 3, E_FATAL, EV_ADMIN, 0 , "1076039683"),  "Octet stream too long!"  ) ;
    public static final ErrorId MsgDb_JnlOctSize              	= new ErrorId( ErrorOf( ES_DB, 4, E_FATAL, EV_ADMIN, 0 , "1076039684"),  "Octet stream size mismatch!"  ) ;
    public static final ErrorId MsgDb_JnlOpcode               	= new ErrorId( ErrorOf( ES_DB, 7, E_FATAL, EV_ADMIN, 1 , "1092816903"),  "Bad opcode '%operation%' journal record!"  ) ;
    public static final ErrorId MsgDb_JnlQuoting              	= new ErrorId( ErrorOf( ES_DB, 6, E_FATAL, EV_ADMIN, 1 , "1092816902"),  "Bad quoting in journal file at line %line%!"  ) ;
    public static final ErrorId MsgDb_JnlReplay               	= new ErrorId( ErrorOf( ES_DB, 12, E_FATAL, EV_ADMIN, 0 , "1076039692"),  "Journal record replay failed!"  ) ;
    public static final ErrorId MsgDb_JnlSeqBad               	= new ErrorId( ErrorOf( ES_DB, 13, E_WARN, EV_ADMIN, 1 , "555945997"),  "Journal file '%file%' skipped (out of sequence)."  ) ;
    public static final ErrorId MsgDb_JnlVersionError         	= new ErrorId( ErrorOf( ES_DB, 82, E_FAILED, 0, 2 , "838864978"),  "Server version %serverVersion% cannot replay a version %journalVersion% journal/checkpoint."  ) ;
    public static final ErrorId MsgDb_JnlVersionMismatch      	= new ErrorId( ErrorOf( ES_DB, 81, E_INFO, 0, 2 , "301994065"),  "Server version %serverVersion% is replaying a version %journalVersion% journal/checkpoint."  ) ;
    public static final ErrorId MsgDb_JnlWord2Big             	= new ErrorId( ErrorOf( ES_DB, 2, E_FATAL, EV_ADMIN, 0 , "1076039682"),  "Word too big for buffer!"  ) ;
    public static final ErrorId MsgDb_Juxtaposed              	= new ErrorId( ErrorOf( ES_DB, 74, E_FAILED, EV_TOOBIG, 0 , "807866442"),  "Senseless juxtaposition of wildcards in '%arg%'."  ) ;
    public static final ErrorId MsgDb_KeyTooBig               	= new ErrorId( ErrorOf( ES_DB, 34, E_FATAL, EV_FAULT, 0 , "1075908642"),  "Record key exceeds max size!"  ) ;
    public static final ErrorId MsgDb_LicenseBad              	= new ErrorId( ErrorOf( ES_DB, 60, E_FAILED, EV_ADMIN, 0 , "807604284"),  "License file invalid."  ) ;
    public static final ErrorId MsgDb_LicenseExp              	= new ErrorId( ErrorOf( ES_DB, 52, E_FAILED, EV_ADMIN, 0 , "807604276"),  "License expired."  ) ;
    public static final ErrorId MsgDb_LicenseNeedsApplication 	= new ErrorId( ErrorOf( ES_DB, 83, E_FAILED, EV_ADMIN, 0 , "807604307"),  "License needs an application."  ) ;
    public static final ErrorId MsgDb_LicenseRead             	= new ErrorId( ErrorOf( ES_DB, 59, E_FAILED, EV_ADMIN, 0 , "807604283"),  "Error reading license file."  ) ;
    public static final ErrorId MsgDb_LineNo                  	= new ErrorId( ErrorOf( ES_DB, 51, E_FAILED, EV_USAGE, 1 , "822153267"),  "Error detected at line %line%."  ) ;
    public static final ErrorId MsgDb_LockOrder               	= new ErrorId( ErrorOf( ES_DB, 30, E_FATAL, EV_FAULT, 2 , "1109463070"),  "Locking failure: %table% locked after %table2%!"  ) ;
    public static final ErrorId MsgDb_LockUpgrade             	= new ErrorId( ErrorOf( ES_DB, 31, E_FATAL, EV_FAULT, 1 , "1092685855"),  "Locking failure: no upgrading %table%'s lock!"  ) ;
    public static final ErrorId MsgDb_Locking                 	= new ErrorId( ErrorOf( ES_DB, 27, E_FATAL, EV_FAULT, 1 , "1092685851"),  "Database locking error on %table%!"  ) ;
    public static final ErrorId MsgDb_MapCheckFail	       	= new ErrorId( ErrorOf( ES_DB, 72, E_FAILED, EV_TOOBIG, 0 , "807866440"),  "MapCheck rejected too many rows."  ) ;
    public static final ErrorId MsgDb_MaxMemory               	= new ErrorId( ErrorOf( ES_DB, 33, E_FATAL, EV_TOOBIG, 1 , "1093079073"),  "Request too large for server memory (try later?)."  ) ;
    public static final ErrorId MsgDb_MaxResults              	= new ErrorId( ErrorOf( ES_DB, 32, E_FAILED, EV_ADMIN, 1 , "824381472"),  "Request too large (over %maxResults%); see 'p4 help maxresults'."  ) ;
    public static final ErrorId MsgDb_MaxScanRows             	= new ErrorId( ErrorOf( ES_DB, 61, E_FAILED, EV_ADMIN, 1 , "824381501"),  "Too many rows scanned (over %maxScanRows%); see 'p4 help maxscanrows'."  ) ;
    public static final ErrorId MsgDb_MustExpire              	= new ErrorId( ErrorOf( ES_DB, 55, E_FAILED, EV_ADMIN, 0 , "807604279"),  "License must expire."  ) ;
    public static final ErrorId MsgDb_NoEndQuote              	= new ErrorId( ErrorOf( ES_DB, 63, E_FAILED, EV_USAGE, 1 , "822153279"),  "No matching end quote in '%value%'."  ) ;
    public static final ErrorId MsgDb_NotUnderClient          	= new ErrorId( ErrorOf( ES_DB, 40, E_FAILED, EV_CONTEXT, 2 , "839061544"),  "Path '%path%' is not under client '%client%'."  ) ;
    public static final ErrorId MsgDb_NotUnderRoot            	= new ErrorId( ErrorOf( ES_DB, 39, E_FAILED, EV_CONTEXT, 2 , "839061543"),  "Path '%path%' is not under client's root '%root%'."  ) ;
    public static final ErrorId MsgDb_ParseErr                	= new ErrorId( ErrorOf( ES_DB, 41, E_FAILED, EV_USAGE, 1 , "822153257"),  "Expression parse error at '%line%'."  ) ;
    public static final ErrorId MsgDb_PlatPre972              	= new ErrorId( ErrorOf( ES_DB, 58, E_FAILED, EV_UPGRADE, 0 , "807735354"),  "Can't have platforms for pre-97.2 servers."  ) ;
    public static final ErrorId MsgDb_Read                    	= new ErrorId( ErrorOf( ES_DB, 19, E_FATAL, EV_FAULT, 1 , "1092685843"),  "Database get error on %table%!"  ) ;
    public static final ErrorId MsgDb_ReadNoLock              	= new ErrorId( ErrorOf( ES_DB, 18, E_FATAL, EV_FAULT, 1 , "1092685842"),  "dbget %table%: no read lock!"  ) ;
    public static final ErrorId MsgDb_Scan                    	= new ErrorId( ErrorOf( ES_DB, 23, E_FATAL, EV_FAULT, 1 , "1092685847"),  "Database scan error on %table%!"  ) ;
    public static final ErrorId MsgDb_ScanFormat              	= new ErrorId( ErrorOf( ES_DB, 24, E_FATAL, EV_FAULT, 2 , "1109463064"),  "dbscan: %table% record format %level% unsupported!"  ) ;
    public static final ErrorId MsgDb_ScanNoLock              	= new ErrorId( ErrorOf( ES_DB, 22, E_FATAL, EV_FAULT, 1 , "1092685846"),  "dbscan %table%: no read lock!"  ) ;
    public static final ErrorId MsgDb_ServerTooNew            	= new ErrorId( ErrorOf( ES_DB, 54, E_FAILED, EV_ADMIN, 0 , "807604278"),  "Server newer than current date."  ) ;
    public static final ErrorId MsgDb_Stumblebum              	= new ErrorId( ErrorOf( ES_DB, 20, E_FATAL, EV_ADMIN, 0 , "1076039700"),  "Database must be 98.1 through " +ID_REL+ " format."  ) ;
    public static final ErrorId MsgDb_SupportExp              	= new ErrorId( ErrorOf( ES_DB, 53, E_FAILED, EV_ADMIN, 0 , "807604277"),  "Support expired."  ) ;
    public static final ErrorId MsgDb_Syntax                  	= new ErrorId( ErrorOf( ES_DB, 50, E_FAILED, EV_USAGE, 1 , "822153266"),  "Syntax error in '%value%'."  ) ;
    public static final ErrorId MsgDb_TableCheckSum           	= new ErrorId( ErrorOf( ES_DB, 84, E_INFO, 0, 6 , "369102932"),  "Table %table% checksums %result%. %when% version %tableVersion%: expected %expected%, actual %actual%."  ) ;
    public static final ErrorId MsgDb_TableObsolete           	= new ErrorId( ErrorOf( ES_DB, 78, E_FAILED, EV_USAGE, 1 , "822153294"),  "Table %table% is obsolete."  ) ;
    public static final ErrorId MsgDb_TableUnknown            	= new ErrorId( ErrorOf( ES_DB, 29, E_FAILED, EV_USAGE, 1 , "822153245"),  "Table %table% not known."  ) ;
    public static final ErrorId MsgDb_TooWild                 	= new ErrorId( ErrorOf( ES_DB, 73, E_FAILED, EV_TOOBIG, 0 , "807866441"),  "Excessive combinations of wildcard ... in path and maps."  ) ;
    public static final ErrorId MsgDb_TooWild2                 	= new ErrorId( ErrorOf( ES_DB, 79, E_FAILED, EV_TOOBIG, 0 , "807866447"),  "Excessive combinations of wildcards in path and maps."  ) ;
    public static final ErrorId MsgDb_TreeAllocation	       	= new ErrorId( ErrorOf( ES_DB, 69, E_FATAL, EV_FAULT, 0 , "1075908677"),  "Allocation failure in db!"  ) ;
    public static final ErrorId MsgDb_TreeAlreadyUpgraded     	= new ErrorId( ErrorOf( ES_DB, 87, E_FATAL, EV_FAULT, 0 , "1075908695"),  "BTree has already been accessed by a later version of the Perforce server!"  ) ;
    public static final ErrorId MsgDb_TreeCorrupt	       	= new ErrorId( ErrorOf( ES_DB, 66, E_FATAL, EV_FAULT, 0 , "1075908674"),  "BTree is corrupt!"  ) ;
    public static final ErrorId MsgDb_TreeInternal	       	= new ErrorId( ErrorOf( ES_DB, 71, E_FATAL, EV_FAULT, 0 , "1075908679"),  "Internal BTree system failure!"  ) ;
    public static final ErrorId MsgDb_TreeNotOpened	       	= new ErrorId( ErrorOf( ES_DB, 67, E_FATAL, EV_FAULT, 0 , "1075908675"),  "BTree could not be opened or created!"  ) ;
    public static final ErrorId MsgDb_TreeNotSupported	       	= new ErrorId( ErrorOf( ES_DB, 70, E_FATAL, EV_FAULT, 0 , "1075908678"),  "BTree variation is not supported!"  ) ;
    public static final ErrorId MsgDb_ValidationFoundProblems 	= new ErrorId( ErrorOf( ES_DB, 86, E_FAILED, EV_ADMIN, 1 , "824381526"),  "Problems were found in %numTables% table(s)."  ) ;
    public static final ErrorId MsgDb_WildMismatch            	= new ErrorId( ErrorOf( ES_DB, 38, E_FAILED, EV_USAGE, 2 , "838930470"),  "Incompatible wildcards '%arg%' <-> '%arg2%'."  ) ;
    public static final ErrorId MsgDb_Write                   	= new ErrorId( ErrorOf( ES_DB, 17, E_FATAL, EV_FAULT, 1 , "1092685841"),  "Database write error on %table%!"  ) ;
    public static final ErrorId MsgDb_WriteNoLock             	= new ErrorId( ErrorOf( ES_DB, 16, E_FATAL, EV_FAULT, 1 , "1092685840"),  "dbput %table%: no write lock!"  ) ;
    public static final ErrorId MsgDb_WrongApp                	= new ErrorId( ErrorOf( ES_DB, 57, E_FAILED, EV_ADMIN, 1 , "824381497"),  "This server is only licensed for %users% use."  ) ;
    public static final ErrorId MsgDb_XactOutstandingRestart  	= new ErrorId( ErrorOf( ES_DB, 85, E_INFO, 0, 1 , "285216853"),  "Server restarted while %count% transaction(s) outstanding."  ) ;
    public static final ErrorId MsgDm_AdminLockDataEx         	= new ErrorId( ErrorOf( ES_DM, 475, E_INFO, EV_ADMIN, 1 , "287513051"),  "Write: %name%"  ) ;
    public static final ErrorId MsgDm_AdminLockDataSh         	= new ErrorId( ErrorOf( ES_DM, 476, E_INFO, EV_ADMIN, 1 , "287513052"),  "Read : %name%"  ) ;
    public static final ErrorId MsgDm_AdminPasswordData       	= new ErrorId( ErrorOf( ES_DM, 723, E_INFO, 0, 1 , "285219539"),  "%user% - must reset password"  ) ;
    public static final ErrorId MsgDm_AdminSpecData           	= new ErrorId( ErrorOf( ES_DM, 466, E_INFO, 0, 1 , "285219282"),  "%depotFile% - created"  ) ;
    public static final ErrorId MsgDm_AlreadyCommitted        	= new ErrorId( ErrorOf( ES_DM, 27, E_FAILED, EV_CONTEXT, 1 , "822286363"),  "%change% is already committed."  ) ;
    public static final ErrorId MsgDm_AlreadyUnloaded         	= new ErrorId( ErrorOf( ES_DM, 705, E_FAILED, EV_CONFIG, 1 , "824449729"),  "%domain% has already been unloaded."  ) ;
    public static final ErrorId MsgDm_AnnotateTooBig	       	= new ErrorId( ErrorOf( ES_DM, 572, E_FAILED, EV_TOOBIG, 1 , "824646204"),  "File size exceeds dm.annotate.maxsize (%maxSize% bytes)."  ) ;
    public static final ErrorId MsgDm_ArchiveFailed           	= new ErrorId( ErrorOf( ES_DM, 110, E_FAILED, EV_FAULT, 1 , "824252526"),  "Remote depot '%depot%' archive access failed."  ) ;
    public static final ErrorId MsgDm_AtMostOne               	= new ErrorId( ErrorOf( ES_DM, 61, E_FAILED, EV_NOTYET, 1 , "822417469"),  "In the change being submitted, %depotFile% has more than one 'branch' or 'delete' integration. Use 'p4 resolved' to display the integrations that are contained in this change. Revert any file(s) containing multiple 'branch' or 'delete' integrations. Then re-integrate those files containing at most one such integration. Then retry the submit."  ) ;
    public static final ErrorId MsgDm_BadAtRev                	= new ErrorId( ErrorOf( ES_DM, 101, E_FAILED, EV_ILLEGAL, 1 , "822351973"),  "Invalid changelist/client/label/date '@%arg%'."  ) ;
    public static final ErrorId MsgDm_BadCaller               	= new ErrorId( ErrorOf( ES_DM, 93, E_FAILED, EV_CONFIG, 0 , "807671901"),  "Invalid user (P4USER) or client (P4CLIENT) name."  ) ;
    public static final ErrorId MsgDm_BadChange               	= new ErrorId( ErrorOf( ES_DM, 14, E_FAILED, EV_USAGE, 1 , "822155278"),  "Invalid changelist number '%change%'."  ) ;
    public static final ErrorId MsgDm_BadDigest               	= new ErrorId( ErrorOf( ES_DM, 418, E_FAILED, EV_USAGE, 1 , "822155682"),  "Invalid digest string '%digest%'."  ) ;
    public static final ErrorId MsgDm_BadIntegFlag            	= new ErrorId( ErrorOf( ES_DM, 50, E_FATAL, EV_FAULT, 0 , "1075910706"),  "DmtIntegData unknown DBT_OPEN_FLAG!"  ) ;
    public static final ErrorId MsgDm_BadJobPresets           	= new ErrorId( ErrorOf( ES_DM, 53, E_FATAL, EV_ADMIN, 0 , "1076041781"),  "Presets in jobspec unusable!"  ) ;
    public static final ErrorId MsgDm_BadJobTemplate          	= new ErrorId( ErrorOf( ES_DM, 51, E_FATAL, EV_FAULT, 0 , "1075910707"),  "Job template unusable!"  ) ;
    public static final ErrorId MsgDm_BadJobView              	= new ErrorId( ErrorOf( ES_DM, 63, E_FAILED, EV_CONFIG, 0 , "807671871"),  "Invalid JobView.  Set with 'p4 user'."  ) ;
    public static final ErrorId MsgDm_BadMappedFileName       	= new ErrorId( ErrorOf( ES_DM, 73, E_FAILED, EV_USAGE, 0 , "805378121"),  "Branch mapping produced illegal filename."  ) ;
    public static final ErrorId MsgDm_BadMaxResult            	= new ErrorId( ErrorOf( ES_DM, 15, E_FAILED, EV_USAGE, 1 , "822155279"),  "Invalid maximum value '%value%'."  ) ;
    public static final ErrorId MsgDm_BadMaxScanRow           	= new ErrorId( ErrorOf( ES_DM, 16, E_FAILED, EV_USAGE, 1 , "822155280"),  "Invalid MaxScanRow number '%value%'."  ) ;
    public static final ErrorId MsgDm_BadOpenFlag             	= new ErrorId( ErrorOf( ES_DM, 56, E_FATAL, EV_FAULT, 0 , "1075910712"),  "DmOpenData unhandled DBT_OPEN_FLAG!"  ) ;
    public static final ErrorId MsgDm_BadOption               	= new ErrorId( ErrorOf( ES_DM, 13, E_FAILED, EV_USAGE, 2 , "838932493"),  "Invalid option '%option%' in %field% option field."  ) ;
    public static final ErrorId MsgDm_BadRevPend              	= new ErrorId( ErrorOf( ES_DM, 426, E_FAILED, EV_USAGE, 0 , "805378474"),  "Can't use a pending changelist number for this command."  ) ;
    public static final ErrorId MsgDm_BadRevRel               	= new ErrorId( ErrorOf( ES_DM, 103, E_FAILED, EV_USAGE, 1 , "822155367"),  "Can't yet do relative operations on '%rev%'."  ) ;
    public static final ErrorId MsgDm_BadRevSpec              	= new ErrorId( ErrorOf( ES_DM, 102, E_FAILED, EV_USAGE, 1 , "822155366"),  "Unintelligible revision specification '%arg%'."  ) ;
    public static final ErrorId MsgDm_BadRevision             	= new ErrorId( ErrorOf( ES_DM, 17, E_FAILED, EV_USAGE, 1 , "822155281"),  "Invalid revision number '%rev%'."  ) ;
    public static final ErrorId MsgDm_BadSequence             	= new ErrorId( ErrorOf( ES_DM, 747, E_FAILED, EV_USAGE, 1 , "822156011"),  "Invalid sequence number '%seq%'."  ) ;
    public static final ErrorId MsgDm_BadSpecType             	= new ErrorId( ErrorOf( ES_DM, 412, E_FAILED, EV_USAGE, 1 , "822155676"),  "Unknown spec type %type%."  ) ;
    public static final ErrorId MsgDm_BadStorageCombo         	= new ErrorId( ErrorOf( ES_DM, 19, E_FAILED, EV_USAGE, 1 , "822155283"),  "Only one storage modifier +C +D +F or +S allowed on '%arg%'."  ) ;
    public static final ErrorId MsgDm_BadTemplate             	= new ErrorId( ErrorOf( ES_DM, 112, E_FATAL, EV_ADMIN, 1 , "1092819056"),  "%key% spec template unusable!"  ) ;
    public static final ErrorId MsgDm_BadTimeout              	= new ErrorId( ErrorOf( ES_DM, 422, E_FAILED, EV_USAGE, 1 , "822155686"),  "Invalid Timeout value '%value%'."  ) ;
    public static final ErrorId MsgDm_BadType                 	= new ErrorId( ErrorOf( ES_DM, 21, E_FAILED, EV_USAGE, 1 , "822155285"),  "Invalid file type '%type%'; see 'p4 help filetypes'."  ) ;
    public static final ErrorId MsgDm_BadTypeAuto	       	= new ErrorId( ErrorOf( ES_DM, 624, E_FAILED, EV_USAGE, 1 , "822155888"),  "Automatic type detection is not allowed here."  ) ;
    public static final ErrorId MsgDm_BadTypeCombo            	= new ErrorId( ErrorOf( ES_DM, 20, E_FAILED, EV_USAGE, 2 , "838932500"),  "Disallowed modifier (%option%) on '%arg%'; see 'p4 help filetypes'."  ) ;
    public static final ErrorId MsgDm_BadTypeMod              	= new ErrorId( ErrorOf( ES_DM, 18, E_FAILED, EV_USAGE, 1 , "822155282"),  "Invalid file type modifier on '%arg%'; see 'p4 help filetypes'."  ) ;
    public static final ErrorId MsgDm_BadTypePartial          	= new ErrorId( ErrorOf( ES_DM, 435, E_FAILED, EV_USAGE, 1 , "822155699"),  "A partial file type is not allowed here."  ) ;
    public static final ErrorId MsgDm_BadVersionCount         	= new ErrorId( ErrorOf( ES_DM, 460, E_FAILED, EV_USAGE, 1 , "822155724"),  "Bad version count '+S%count%', only values 1-10,16,32,64,128,256,512 allowed."  ) ;
    public static final ErrorId MsgDm_BucketAdd	       	= new ErrorId( ErrorOf( ES_DM, 559, E_INFO, EV_NONE, 3 , "318773807"),  "Archiving %depotFile%%depotRev% to %archiveFile%."  ) ;
    public static final ErrorId MsgDm_BucketNoFilesToArchive  	= new ErrorId( ErrorOf( ES_DM, 566, E_WARN, EV_USAGE, 0 , "536943158"),  "[%argc% - no|No] revisions can be archived."  ) ;
    public static final ErrorId MsgDm_BucketNoFilesToPurge    	= new ErrorId( ErrorOf( ES_DM, 568, E_WARN, EV_USAGE, 0 , "536943160"),  "[%argc% - no|No] revisions can be purged."  ) ;
    public static final ErrorId MsgDm_BucketNoFilesToRestore  	= new ErrorId( ErrorOf( ES_DM, 567, E_WARN, EV_USAGE, 0 , "536943159"),  "[%argc% - no|No] revisions can be restored."  ) ;
    public static final ErrorId MsgDm_BucketPurge	       	= new ErrorId( ErrorOf( ES_DM, 561, E_INFO, EV_NONE, 2 , "301996593"),  "Purged %depotFile%%depotRev%."  ) ;
    public static final ErrorId MsgDm_BucketRestore	       	= new ErrorId( ErrorOf( ES_DM, 560, E_INFO, EV_NONE, 3 , "318773808"),  "Restoring %depotFile%%depotRev% from %archiveFile%."  ) ;
    public static final ErrorId MsgDm_BucketSkipBranched      	= new ErrorId( ErrorOf( ES_DM, 564, E_INFO, EV_NONE, 2 , "301996596"),  "Not archiving %depotFile%%depotRev%: content used elsewhere."  ) ;
    public static final ErrorId MsgDm_BucketSkipBucketed      	= new ErrorId( ErrorOf( ES_DM, 585, E_INFO, EV_NONE, 2 , "301996617"),  "Not archiving %depotFile%%depotRev%: trait 'archiveBucket' has been set." ) ;
    public static final ErrorId MsgDm_BucketSkipHead	       	= new ErrorId( ErrorOf( ES_DM, 562, E_INFO, EV_NONE, 2 , "301996594"),  "Not archiving %depotFile%%depotRev%: head revision."  ) ;
    public static final ErrorId MsgDm_BucketSkipLazy	       	= new ErrorId( ErrorOf( ES_DM, 563, E_INFO, EV_NONE, 2 , "301996595"),  "Not archiving %depotFile%%depotRev%: lazy copy."  ) ;
    public static final ErrorId MsgDm_BucketSkipType	       	= new ErrorId( ErrorOf( ES_DM, 565, E_INFO, EV_NONE, 3 , "318773813"),  "Not archiving %depotFile%%depotRev%: stored in delta format (+D)."  ) ;
    public static final ErrorId MsgDm_CantChangeUnloadedOpt   	= new ErrorId( ErrorOf( ES_DM, 706, E_FAILED, EV_USAGE, 0 , "805378754"),  "The autoreload/noautoreload option may not be modified."  ) ;
    public static final ErrorId MsgDm_CantChangeUser          	= new ErrorId( ErrorOf( ES_DM, 84, E_FAILED, EV_USAGE, 1 , "822155348"),  "User name can't be changed from '%user%'."  ) ;
    public static final ErrorId MsgDm_CantChangeUserType      	= new ErrorId( ErrorOf( ES_DM, 577, E_FAILED, EV_USAGE, 1 , "822155841"),  "User type can't be changed."  ) ;
    public static final ErrorId MsgDm_CantFindChange          	= new ErrorId( ErrorOf( ES_DM, 49, E_FATAL, EV_FAULT, 1 , "1092687921"),  "Can't find %change%!"  ) ;
    public static final ErrorId MsgDm_CantOpenHere            	= new ErrorId( ErrorOf( ES_DM, 66, E_FAILED, EV_ILLEGAL, 0 , "805574722"),  "Can't include file(s) not already opened.\nOpen new files with p4 add, p4 edit, etc."  ) ;
    public static final ErrorId MsgDm_ChangeCreated           	= new ErrorId( ErrorOf( ES_DM, 200, E_INFO, 0, 3 , "318773448"),  "%change% created[ with %workCount% open file(s)][ fixing %jobCount% job(s)]."  ) ;
    public static final ErrorId MsgDm_ChangeDeleteHasFiles    	= new ErrorId( ErrorOf( ES_DM, 204, E_INFO, 0, 2 , "301996236"),  "%change% has %count% files associated with it and can't be deleted."  ) ;
    public static final ErrorId MsgDm_ChangeDeleteHasFix      	= new ErrorId( ErrorOf( ES_DM, 203, E_INFO, 0, 2 , "301996235"),  "%change% has %count% fixes associated with it and can't be deleted."  ) ;
    public static final ErrorId MsgDm_ChangeDeleteOpen        	= new ErrorId( ErrorOf( ES_DM, 202, E_INFO, 0, 2 , "301996234"),  "%change% has %count% open file(s) associated with it and can't be deleted."  ) ;
    public static final ErrorId MsgDm_ChangeDeleteShelved    	= new ErrorId( ErrorOf( ES_DM, 517, E_FAILED, EV_CONTEXT, 1 , "822286853"),  "%change% has shelved files associated with it and can't be deleted."  ) ;
    public static final ErrorId MsgDm_ChangeDeleteSuccess     	= new ErrorId( ErrorOf( ES_DM, 205, E_INFO, 0, 1 , "285219021"),  "%change% deleted."  ) ;
    public static final ErrorId MsgDm_ChangeExists            	= new ErrorId( ErrorOf( ES_DM, 484, E_FATAL, EV_FAULT, 1 , "1092688356"),  "Sequence error:  next changelist '%change%' already exists!"  ) ;
    public static final ErrorId MsgDm_ChangeNotOwner	       	= new ErrorId( ErrorOf( ES_DM, 468, E_FAILED, EV_USAGE, 2 , "838932948"),  "%change% can only be updated by user %user%."  ) ;
    public static final ErrorId MsgDm_ChangeUpdated           	= new ErrorId( ErrorOf( ES_DM, 201, E_INFO, 0, 5 , "352327881"),  "%change% updated[, adding %workCount% file(s)][, removing %workCount2% file(s)][, adding %jobCount% fix(es)][, removing %jobCount2% fix(es)]."  ) ;
    public static final ErrorId MsgDm_ChangesData             	= new ErrorId( ErrorOf( ES_DM, 206, E_INFO, 0, 5 , "352327886"),  "%change% on %date% by %user%@%client%%description%"  ) ;
    public static final ErrorId MsgDm_ChangesDataPending      	= new ErrorId( ErrorOf( ES_DM, 207, E_INFO, 0, 5 , "352327887"),  "%change% on %date% by %user%@%client% *pending*%description%"  ) ;
    public static final ErrorId MsgDm_CheckFailed             	= new ErrorId( ErrorOf( ES_DM, 1, E_FAILED, EV_FAULT, 2 , "841029633"),  "%table%/%table2% inconsistencies found."  ) ;
    public static final ErrorId MsgDm_ClassicSwitch           	= new ErrorId( ErrorOf( ES_DM, 685, E_FAILED, EV_NOTYET, 1 , "822418093"),  "Client '%client%' has a static view that will be overwritten; use -f to force switch."  ) ;
    public static final ErrorId MsgDm_ClientBoundToServer     	= new ErrorId( ErrorOf( ES_DM, 672, E_FAILED, EV_PROTECT, 2 , "839260832"),  "Client '%client%' is restricted to use on server '%serverID%'."  ) ;
    public static final ErrorId MsgDm_ClientTooOld            	= new ErrorId( ErrorOf( ES_DM, 538, E_FAILED, EV_USAGE, 1 , "822155802"),  "You may not set minClient to a release newer than your client."  ) ;
    public static final ErrorId MsgDm_CommandCancelled        	= new ErrorId( ErrorOf( ES_DB, 62, E_FAILED, EV_COMM, 0 , "807800894"),  "Command terminated because client closed connection."  ) ;
    public static final ErrorId MsgDm_CommittedNoPerm	       	= new ErrorId( ErrorOf( ES_DM, 573, E_FAILED, EV_USAGE, 2 , "838933053"),  "%change% can only be updated by user %user% with -u, or by admin user with -f."  ) ;
    public static final ErrorId MsgDm_ConcurrentFileChange    	= new ErrorId( ErrorOf( ES_DM, 640, E_FAILED, EV_USAGE, 1 , "822155904"),  "%depotFile% was altered during the course of the submit. Verify the contents of the changelist and retry the submit."  ) ;
    public static final ErrorId MsgDm_ConfigData              	= new ErrorId( ErrorOf( ES_DM, 545, E_INFO, 0, 3 , "318773793"),  "%serverName%: %variableName% = %variableValue%"  ) ;
    public static final ErrorId MsgDm_ConfigWasNotSet         	= new ErrorId( ErrorOf( ES_DM, 547, E_FAILED, EV_UNKNOWN, 1 , "822221347"),  "Configuration variable '%config%' did not have a value."  ) ;
    public static final ErrorId MsgDm_CopyOpenTarget          	= new ErrorId( ErrorOf( ES_DM, 569, E_FAILED, EV_ILLEGAL, 0 , "805575225"),  "Can't copy to target path with files already open."  ) ;
    public static final ErrorId MsgDm_CountersData            	= new ErrorId( ErrorOf( ES_DM, 208, E_INFO, 0, 2 , "301996240"),  "%counterName% = %counterValue%"  ) ;
    public static final ErrorId MsgDm_DbFailed                	= new ErrorId( ErrorOf( ES_DM, 109, E_FAILED, EV_FAULT, 1 , "824252525"),  "Remote depot '%depot%' database access failed."  ) ;
    public static final ErrorId MsgDm_DeleteMoved	       	= new ErrorId( ErrorOf( ES_DM, 627, E_WARN, 0, 2 , "570432115"),  "%clientFile% - can't delete moved file; must undo move first"  ) ;
    public static final ErrorId MsgDm_DepotDelete             	= new ErrorId( ErrorOf( ES_DM, 212, E_INFO, 0, 1 , "285219028"),  "Depot %depotName% deleted."  ) ;
    public static final ErrorId MsgDm_DepotHasStreams         	= new ErrorId( ErrorOf( ES_DM, 751, E_FAILED, EV_NOTYET, 1 , "822418159"),  "Depot '%depot%' is the location of existing streams; cannot delete until they are removed."  ) ;
    public static final ErrorId MsgDm_DepotMapInvalid         	= new ErrorId( ErrorOf( ES_DM, 442, E_FAILED, EV_USAGE, 1 , "822155706"),  "Map entry '%map%' must have only 1 wildcard which must be a trailing '/...' or '\\...'."  ) ;
    public static final ErrorId MsgDm_DepotMissing            	= new ErrorId( ErrorOf( ES_DM, 45, E_FATAL, EV_FAULT, 1 , "1092687917"),  "Depot %depot% missing from depot table!"  ) ;
    public static final ErrorId MsgDm_DepotNoChange           	= new ErrorId( ErrorOf( ES_DM, 211, E_INFO, 0, 1 , "285219027"),  "Depot %depotName% not changed."  ) ;
    public static final ErrorId MsgDm_DepotNotSpec            	= new ErrorId( ErrorOf( ES_DM, 675, E_FAILED, 0, 0 , "805313187"),  "SpecMap entries may only be added for a depot of type 'spec'."  ) ;
    public static final ErrorId MsgDm_DepotNotStream          	= new ErrorId( ErrorOf( ES_DM, 507, E_FAILED, 0, 1 , "822090235"),  "Depot type for '%depot%' must be 'stream'."  ) ;
    public static final ErrorId MsgDm_DepotSave               	= new ErrorId( ErrorOf( ES_DM, 210, E_INFO, 0, 1 , "285219026"),  "Depot %depotName% saved."  ) ;
    public static final ErrorId MsgDm_DepotSpecDup            	= new ErrorId( ErrorOf( ES_DM, 420, E_FAILED, EV_CONTEXT, 1 , "822286756"),  "There is already a spec depot called '%depot%'."  ) ;
    public static final ErrorId MsgDm_DepotUnloadDup          	= new ErrorId( ErrorOf( ES_DM, 701, E_FAILED, EV_CONTEXT, 1 , "822287037"),  "There is already an unload depot called '%depot%'."  ) ;
    public static final ErrorId MsgDm_DepotVsDomains          	= new ErrorId( ErrorOf( ES_DM, 46, E_FATAL, EV_FAULT, 0 , "1075910702"),  "Depot and domains table out of sync!"  ) ;
    public static final ErrorId MsgDm_DepotsData              	= new ErrorId( ErrorOf( ES_DM, 213, E_INFO, 0, 6 , "369105109"),  "%type% %depotName% %updateDate% %location% %map% '%description%'"  ) ;
    public static final ErrorId MsgDm_DepotsDataExtra         	= new ErrorId( ErrorOf( ES_DM, 214, E_INFO, 0, 7 , "385882326"),  "%type% %depotName% %updateDate% %location% %address% %map% '%description%'"  ) ;
    public static final ErrorId MsgDm_DescMissing             	= new ErrorId( ErrorOf( ES_DM, 25, E_FATAL, EV_FAULT, 1 , "1092687897"),  "%key% description missing!"  ) ;
    public static final ErrorId MsgDm_DescribeChange          	= new ErrorId( ErrorOf( ES_DM, 215, E_INFO, 0, 5 , "352327895"),  "%change% by %user%@%client% on %date%%description%"  ) ;
    public static final ErrorId MsgDm_DescribeChangePending   	= new ErrorId( ErrorOf( ES_DM, 216, E_INFO, 0, 5 , "352327896"),  "%change% by %user%@%client% on %date% *pending*%description%"  ) ;
    public static final ErrorId MsgDm_DescribeData            	= new ErrorId( ErrorOf( ES_DM, 217, E_INFO, 1, 3 , "318839001"),  "%depotFile%%depotRev% %action%"  ) ;
    public static final ErrorId MsgDm_DescribeDiff            	= new ErrorId( ErrorOf( ES_DM, 218, E_INFO, 0, 4 , "335550682"),  "\n==== %depotFile%%depotRev% (%type%[/%type2%]) ====\n"  ) ;
    public static final ErrorId MsgDm_DescribeMove            	= new ErrorId( ErrorOf( ES_DM, 495, E_INFO, 1, 4 , "335616495"),  "%depotFile%%depotRev% moved from %depotFile2%%depotRev2%"  ) ;
    public static final ErrorId MsgDm_DfltBranchView          	= new ErrorId( ErrorOf( ES_DM, 87, E_FAILED, EV_USAGE, 0 , "805378135"),  "You cannot use the default branch view; it is just a sample."  ) ;
    public static final ErrorId MsgDm_Diff2DataContent        	= new ErrorId( ErrorOf( ES_DM, 222, E_INFO, 0, 6 , "369105118"),  "==== %depotFile%%depotRev% (%type%) - %depotFile2%%depotRev2% (%type2%) ==== content"  ) ;
    public static final ErrorId MsgDm_Diff2DataIdentical      	= new ErrorId( ErrorOf( ES_DM, 224, E_INFO, 0, 6 , "369105120"),  "==== %depotFile%%depotRev% (%type%) - %depotFile2%%depotRev2% (%type2%) ==== identical"  ) ;
    public static final ErrorId MsgDm_Diff2DataLeft           	= new ErrorId( ErrorOf( ES_DM, 220, E_INFO, 0, 2 , "301996252"),  "==== %depotFile%%depotRev% - <none> ==="  ) ;
    public static final ErrorId MsgDm_Diff2DataRight          	= new ErrorId( ErrorOf( ES_DM, 221, E_INFO, 0, 2 , "301996253"),  "==== <none> - %depotFile%%depotRev% ===="  ) ;
    public static final ErrorId MsgDm_Diff2DataRightPre041    	= new ErrorId( ErrorOf( ES_DM, 423, E_INFO, 0, 2 , "301996455"),  "==== < none > - %depotFile%%depotRev% ===="  ) ;
    public static final ErrorId MsgDm_Diff2DataTypes          	= new ErrorId( ErrorOf( ES_DM, 223, E_INFO, 0, 6 , "369105119"),  "==== %depotFile%%depotRev% (%type%) - %depotFile2%%depotRev2% (%type2%) ==== types"  ) ;
    public static final ErrorId MsgDm_Diff2DataUnified        	= new ErrorId( ErrorOf( ES_DM, 225, E_INFO, 0, 4 , "335550689"),  "--- %depotFile%\t%depotDate%\n+++ %depotFile2%\t%depotDate2%"  ) ;
    public static final ErrorId MsgDm_Diff2DataUnifiedDiffer  	= new ErrorId( ErrorOf( ES_DM, 471, E_INFO, 0, 4 , "335550935"),  "Binary files %depotFile%%depotRev% and %depotFile2%%depotRev2% differ"  ) ;
    public static final ErrorId MsgDm_DiffData                	= new ErrorId( ErrorOf( ES_DM, 219, E_INFO, 0, 4 , "335550683"),  "==== %depotFile%%depotRev% - %localPath% ====[ (%type%)]"  ) ;
    public static final ErrorId MsgDm_DirsData                	= new ErrorId( ErrorOf( ES_DM, 209, E_INFO, 0, 1 , "285219025"),  "%dirName%"  ) ;
    public static final ErrorId MsgDm_DiskSpaceEstimated      	= new ErrorId( ErrorOf( ES_DM, 614, E_FAILED, EV_UNKNOWN, 3 , "855775846"),  "The filesystem '%filesys%' has only %freeSpace% free, but the command estimates it needs at least %estSpace% available."  ) ;
    public static final ErrorId MsgDm_DiskSpaceMinimum        	= new ErrorId( ErrorOf( ES_DM, 613, E_FAILED, EV_UNKNOWN, 3 , "855775845"),  "The filesystem '%filesys%' has only %freeSpace% free, but the server configuration requires at least %cfgSpace% available."  ) ;
    public static final ErrorId MsgDm_DomainDelete            	= new ErrorId( ErrorOf( ES_DM, 228, E_INFO, 0, 2 , "301996260"),  "%domainType% %domainName% deleted."  ) ;
    public static final ErrorId MsgDm_DomainIsUnloaded        	= new ErrorId( ErrorOf( ES_DM, 702, E_FAILED, EV_CONFIG, 2 , "841226942"),  "%domainType% %domain% has been unloaded, and must be reloaded to be used."  ) ;
    public static final ErrorId MsgDm_DomainNoChange          	= new ErrorId( ErrorOf( ES_DM, 227, E_INFO, 0, 2 , "301996259"),  "%domainType% %domainName% not changed."  ) ;
    public static final ErrorId MsgDm_DomainSave              	= new ErrorId( ErrorOf( ES_DM, 226, E_INFO, 0, 2 , "301996258"),  "%domainType% %domainName% saved."  ) ;
    public static final ErrorId MsgDm_DomainSwitch            	= new ErrorId( ErrorOf( ES_DM, 608, E_INFO, 0, 2 , "301996640"),  "%domainType% %domainName% switched."  ) ;
    public static final ErrorId MsgDm_DomainsData             	= new ErrorId( ErrorOf( ES_DM, 230, E_INFO, 0, 4 , "335550694"),  "%domainType% %domainName% %updateDate% '%description%'"  ) ;
    public static final ErrorId MsgDm_DomainsDataClient       	= new ErrorId( ErrorOf( ES_DM, 229, E_INFO, 0, 5 , "352327909"),  "%domainType% %domainName% %updateDate% root %domainMount% '%description%'"  ) ;
    public static final ErrorId MsgDm_DupExists               	= new ErrorId( ErrorOf( ES_DM, 463, E_INFO, 0, 2 , "301996495"),  "%file%%rev% already exists"  ) ;
    public static final ErrorId MsgDm_DupLocked               	= new ErrorId( ErrorOf( ES_DM, 464, E_INFO, 0, 4 , "335550928"),  "%file%%rev% is opened for %action% on client %client%"  ) ;
    public static final ErrorId MsgDm_DupOK                   	= new ErrorId( ErrorOf( ES_DM, 462, E_INFO, 0, 4 , "335550926"),  "%file%%rev% duplicated from %file2%%rev2%"  ) ;
    public static final ErrorId MsgDm_EditSpecNoChange         	= new ErrorId( ErrorOf( ES_DM, 271, E_INFO, 0, 0 , "268441871"),  "Spec %type% not changed."  ) ;
    public static final ErrorId MsgDm_EditSpecSave             	= new ErrorId( ErrorOf( ES_DM, 270, E_INFO, 0, 0 , "268441870"),  "Spec %type% saved."  ) ;
    public static final ErrorId MsgDm_EmbSpecChar              	= new ErrorId( ErrorOf( ES_DM, 700, E_FAILED, EV_USAGE, 1 , "822155964"),  "Embedded special characters (*, %%, #, @) not allowed in '%path%'."  ) ;
    public static final ErrorId MsgDm_EmbWild                  	= new ErrorId( ErrorOf( ES_DM, 543, E_FAILED, EV_USAGE, 1 , "822155807"),  "Embedded wildcards (*, ...) not allowed in '%path%'."  ) ;
    public static final ErrorId MsgDm_EmptyFileName           	= new ErrorId( ErrorOf( ES_DM, 96, E_FAILED, EV_USAGE, 0 , "805378144"),  "An empty string is not allowed as a file name."  ) ;
    public static final ErrorId MsgDm_EmptyRelate             	= new ErrorId( ErrorOf( ES_DM, 92, E_FATAL, EV_FAULT, 0 , "1075910748"),  "RelateMap has empty maps!"  ) ;
    public static final ErrorId MsgDm_EmptyResults            	= new ErrorId( ErrorOf( ES_DM, 104, E_WARN, EV_EMPTY, 1 , "554768488"),  "%reason%."  ) ;
    public static final ErrorId MsgDm_ErrorInSpec             	= new ErrorId( ErrorOf( ES_DM, 69, E_FAILED, EV_ILLEGAL, 1 , "822351941"),  "Error in %domain% specification."  ) ;
    public static final ErrorId MsgDm_ExABOVECHANGE           	= new ErrorId( ErrorOf( ES_DM, 389, E_WARN, EV_EMPTY, 1 , "554768773"),  "[%argc% - no|No] revision(s) above those at that changelist number."  ) ;
    public static final ErrorId MsgDm_ExABOVEDATE             	= new ErrorId( ErrorOf( ES_DM, 390, E_WARN, EV_EMPTY, 1 , "554768774"),  "[%argc% - no|No] revision(s) after that date."  ) ;
    public static final ErrorId MsgDm_ExABOVEHAVE             	= new ErrorId( ErrorOf( ES_DM, 391, E_WARN, EV_EMPTY, 1 , "554768775"),  "[%argc% - no|No] revision(s) above those on client."  ) ;
    public static final ErrorId MsgDm_ExABOVELABEL            	= new ErrorId( ErrorOf( ES_DM, 392, E_WARN, EV_EMPTY, 1 , "554768776"),  "[%argc% - no|No] revision(s) above those in label."  ) ;
    public static final ErrorId MsgDm_ExABOVEREVISION         	= new ErrorId( ErrorOf( ES_DM, 393, E_WARN, EV_EMPTY, 1 , "554768777"),  "[%argc% - no|No] revision(s) above that revision."  ) ;
    public static final ErrorId MsgDm_ExATACTION              	= new ErrorId( ErrorOf( ES_DM, 399, E_WARN, EV_EMPTY, 1 , "554768783"),  "[%argc% - no|No] file(s) with that action."  ) ;
    public static final ErrorId MsgDm_ExATCHANGE              	= new ErrorId( ErrorOf( ES_DM, 394, E_WARN, EV_EMPTY, 1 , "554768778"),  "[%argc% - no|No] file(s) at that changelist number."  ) ;
    public static final ErrorId MsgDm_ExATDATE                	= new ErrorId( ErrorOf( ES_DM, 395, E_WARN, EV_EMPTY, 1 , "554768779"),  "[%argc% - no|No] file(s) as of that date."  ) ;
    public static final ErrorId MsgDm_ExATHAVE                	= new ErrorId( ErrorOf( ES_DM, 396, E_WARN, EV_EMPTY, 1 , "554768780"),  "[%argc% - file(s)|File(s)] not on client."  ) ;
    public static final ErrorId MsgDm_ExATLABEL               	= new ErrorId( ErrorOf( ES_DM, 397, E_WARN, EV_EMPTY, 1 , "554768781"),  "[%argc% - file(s)|File(s)] not in label."  ) ;
    public static final ErrorId MsgDm_ExATREVISION            	= new ErrorId( ErrorOf( ES_DM, 398, E_WARN, EV_EMPTY, 1 , "554768782"),  "[%argc% - no|No] file(s) at that revision."  ) ;
    public static final ErrorId MsgDm_ExATTEXT              	= new ErrorId( ErrorOf( ES_DM, 540, E_WARN, EV_EMPTY, 1 , "554768924"),  "[%argc% - no|No] file(s) of type text."  ) ;
    public static final ErrorId MsgDm_ExBELOWCHANGE           	= new ErrorId( ErrorOf( ES_DM, 400, E_WARN, EV_EMPTY, 1 , "554768784"),  "[%argc% - no|No] revision(s) below those at that changelist number."  ) ;
    public static final ErrorId MsgDm_ExBELOWDATE             	= new ErrorId( ErrorOf( ES_DM, 401, E_WARN, EV_EMPTY, 1 , "554768785"),  "[%argc% - no|No] revision(s) before that date."  ) ;
    public static final ErrorId MsgDm_ExBELOWHAVE             	= new ErrorId( ErrorOf( ES_DM, 402, E_WARN, EV_EMPTY, 1 , "554768786"),  "[%argc% - no|No] revision(s) below those on client."  ) ;
    public static final ErrorId MsgDm_ExBELOWLABEL            	= new ErrorId( ErrorOf( ES_DM, 403, E_WARN, EV_EMPTY, 1 , "554768787"),  "[%argc% - no|No] revision(s) below those in label."  ) ;
    public static final ErrorId MsgDm_ExBELOWREVISION         	= new ErrorId( ErrorOf( ES_DM, 404, E_WARN, EV_EMPTY, 1 , "554768788"),  "[%argc% - no|No] revision(s) below that revision."  ) ;
    public static final ErrorId MsgDm_ExBVIEW                 	= new ErrorId( ErrorOf( ES_DM, 368, E_WARN, EV_EMPTY, 2 , "571545968"),  "%!%[%argc% - no|No] target file(s) in both client and branch view."  ) ;
    public static final ErrorId MsgDm_ExCHANGE                	= new ErrorId( ErrorOf( ES_DM, 365, E_WARN, EV_EMPTY, 1 , "554768749"),  "[%argc% - no|No] such changelist."  ) ;
    public static final ErrorId MsgDm_ExDIFF                  	= new ErrorId( ErrorOf( ES_DM, 373, E_WARN, EV_EMPTY, 1 , "554768757"),  "[%argc% - no|No] differing files."  ) ;
    public static final ErrorId MsgDm_ExDIFFPre101                  	= new ErrorId( ErrorOf( ES_DM, 527, E_WARN, EV_EMPTY, 1 , "554768911"),  "[%argc% - no|No] file(s) to diff."  ) ;
    public static final ErrorId MsgDm_ExDIGESTED              	= new ErrorId( ErrorOf( ES_DM, 374, E_WARN, EV_EMPTY, 1 , "554768758"),  "[%argc% - file(s)|File(s)] already have digests."  ) ;
    public static final ErrorId MsgDm_ExFILE                  	= new ErrorId( ErrorOf( ES_DM, 375, E_WARN, EV_EMPTY, 1 , "554768759"),  "[%argc% - no|No] such file(s)."  ) ;
    public static final ErrorId MsgDm_ExHAVE                  	= new ErrorId( ErrorOf( ES_DM, 376, E_WARN, EV_EMPTY, 1 , "554768760"),  "[%argc% - file(s)|File(s)] not on client."  ) ;
    public static final ErrorId MsgDm_ExINTEGED               	= new ErrorId( ErrorOf( ES_DM, 377, E_WARN, EV_EMPTY, 1 , "554768761"),  "[%argc% - no|No] file(s) integrated."  ) ;
    public static final ErrorId MsgDm_ExINTEGMOVEDEL          	= new ErrorId( ErrorOf( ES_DM, 725, E_WARN, EV_EMPTY, 1 , "554769109"),  "[%argc% - move/delete(s)|Move/delete(s)] must be integrated along with matching move/add(s)."  ) ;
    public static final ErrorId MsgDm_ExINTEGPEND             	= new ErrorId( ErrorOf( ES_DM, 371, E_WARN, EV_EMPTY, 1 , "554768755"),  "[%argc% - all|All] revision(s) already integrated in pending changelist."  ) ;
    public static final ErrorId MsgDm_ExINTEGPERM             	= new ErrorId( ErrorOf( ES_DM, 372, E_WARN, EV_EMPTY, 1 , "554768756"),  "[%argc% - all|All] revision(s) already integrated."  ) ;
    public static final ErrorId MsgDm_ExLABEL                 	= new ErrorId( ErrorOf( ES_DM, 378, E_WARN, EV_EMPTY, 1 , "554768762"),  "[%argc% - file(s)|File(s)] not in label."  ) ;
    public static final ErrorId MsgDm_ExLABSYNC               	= new ErrorId( ErrorOf( ES_DM, 379, E_WARN, EV_EMPTY, 1 , "554768763"),  "[%argc% - label|Label] in sync."  ) ;
    public static final ErrorId MsgDm_ExOPENALL               	= new ErrorId( ErrorOf( ES_DM, 380, E_WARN, EV_EMPTY, 1 , "554768764"),  "[%argc% - file(s)|File(s)] not opened anywhere."  ) ;
    public static final ErrorId MsgDm_ExOPENCHANGE            	= new ErrorId( ErrorOf( ES_DM, 381, E_WARN, EV_EMPTY, 1 , "554768765"),  "[%argc% - file(s)|File(s)] not opened in that changelist."  ) ;
    public static final ErrorId MsgDm_ExOPENCLIENT            	= new ErrorId( ErrorOf( ES_DM, 382, E_WARN, EV_EMPTY, 1 , "554768766"),  "[%argc% - file(s)|File(s)] not opened on this client."  ) ;
    public static final ErrorId MsgDm_ExOPENDFLT              	= new ErrorId( ErrorOf( ES_DM, 384, E_WARN, EV_EMPTY, 1 , "554768768"),  "[%argc% - file(s)|File(s)] not opened in default changelist."  ) ;
    public static final ErrorId MsgDm_ExOPENNOTEDIT           	= new ErrorId( ErrorOf( ES_DM, 383, E_WARN, EV_EMPTY, 1 , "554768767"),  "[%argc% - file(s)|File(s)] not opened for edit."  ) ;
    public static final ErrorId MsgDm_ExPROPERTY              	= new ErrorId( ErrorOf( ES_DM, 735, E_WARN, EV_EMPTY, 1 , "554769119"),  "[%settingName% - no|No] such property."  ) ;
    public static final ErrorId MsgDm_ExPROTECT               	= new ErrorId( ErrorOf( ES_DM, 369, E_WARN, EV_EMPTY, 1 , "554768753"),  "[%argc% - no|No] permission for operation on file(s)."  ) ;
    public static final ErrorId MsgDm_ExPROTECT2              	= new ErrorId( ErrorOf( ES_DM, 480, E_WARN, EV_EMPTY, 2 , "571546080"),  "%!%[%argc% - no|No] permission for operation on file(s)."  ) ;
    public static final ErrorId MsgDm_ExPROTNAME              	= new ErrorId( ErrorOf( ES_DM, 370, E_WARN, EV_EMPTY, 1 , "554768754"),  "[%argc% - protected|Protected] namespace - access denied."  ) ;
    public static final ErrorId MsgDm_ExPROTNAME2             	= new ErrorId( ErrorOf( ES_DM, 481, E_WARN, EV_EMPTY, 2 , "571546081"),  "%!%[%argc% - protected|Protected] namespace - access denied."  ) ;
    public static final ErrorId MsgDm_ExRESOLVED              	= new ErrorId( ErrorOf( ES_DM, 385, E_WARN, EV_EMPTY, 1 , "554768769"),  "[%argc% - no|No] file(s) resolved."  ) ;
    public static final ErrorId MsgDm_ExSTREAM                	= new ErrorId( ErrorOf( ES_DM, 508, E_WARN, EV_EMPTY, 1 , "554768892"),  "[%argc% - no|No] such stream."  ) ;
    public static final ErrorId MsgDm_ExSVIEW                 	= new ErrorId( ErrorOf( ES_DM, 478, E_WARN, EV_EMPTY, 1 , "554768862"),  "[%argc% - no|No] source file(s) in branch view."  ) ;
    public static final ErrorId MsgDm_ExTOINTEG               	= new ErrorId( ErrorOf( ES_DM, 386, E_WARN, EV_EMPTY, 1 , "554768770"),  "[%argc% - no|No] file(s) to integrate."  ) ;
    public static final ErrorId MsgDm_ExTORECONCILE             	= new ErrorId( ErrorOf( ES_DM, 683, E_WARN, EV_EMPTY, 1 , "554769067"),  "[%argc% - no|No] file(s) to reconcile."  ) ;
    public static final ErrorId MsgDm_ExTORESOLVE             	= new ErrorId( ErrorOf( ES_DM, 387, E_WARN, EV_EMPTY, 1 , "554768771"),  "[%argc% - no|No] file(s) to resolve."  ) ;
    public static final ErrorId MsgDm_ExTORETYPE              	= new ErrorId( ErrorOf( ES_DM, 674, E_WARN, EV_EMPTY, 1 , "554769058"),  "[%argc% - no|No] file(s) to retype."  ) ;
    public static final ErrorId MsgDm_ExTOUNSHELVE             	= new ErrorId( ErrorOf( ES_DM, 516, E_WARN, EV_EMPTY, 1 , "554768900"),  "[%argc% - no|No] file(s) to unshelve."  ) ;
    public static final ErrorId MsgDm_ExTVIEW                 	= new ErrorId( ErrorOf( ES_DM, 479, E_WARN, EV_EMPTY, 2 , "571546079"),  "%!%[%argc% - no|No] target file(s) in branch view."  ) ;
    public static final ErrorId MsgDm_ExUPTODATE              	= new ErrorId( ErrorOf( ES_DM, 388, E_WARN, EV_EMPTY, 1 , "554768772"),  "[%argc% - file(s)|File(s)] up-to-date."  ) ;
    public static final ErrorId MsgDm_ExUSER                  	= new ErrorId( ErrorOf( ES_DM, 366, E_WARN, EV_EMPTY, 1 , "554768750"),  "[%argc% - no|No] such user(s)."  ) ;
    public static final ErrorId MsgDm_ExVIEW                  	= new ErrorId( ErrorOf( ES_DM, 367, E_WARN, EV_EMPTY, 1 , "554768751"),  "[%argc% - file(s)|File(s)] not in client view."  ) ;
    public static final ErrorId MsgDm_ExVIEW2                 	= new ErrorId( ErrorOf( ES_DM, 477, E_WARN, EV_EMPTY, 2 , "571546077"),  "%!%[%argc% - file(s)|File(s)] not in client view."  ) ;
    public static final ErrorId MsgDm_FieldCount            	= new ErrorId( ErrorOf( ES_DM, 496, E_FAILED, EV_USAGE, 1 , "822155760"),  "'%tag%' unknown or wrong number of fields for path-type."  ) ;
    public static final ErrorId MsgDm_FieldMissing            	= new ErrorId( ErrorOf( ES_DM, 113, E_FAILED, EV_USAGE, 1 , "822155377"),  "Field %field% missing from form."  ) ;
    public static final ErrorId MsgDm_FilelogData             	= new ErrorId( ErrorOf( ES_DM, 231, E_INFO, 0, 1 , "285219047"),  "%depotFile%"  ) ;
    public static final ErrorId MsgDm_FilelogInteg            	= new ErrorId( ErrorOf( ES_DM, 234, E_INFO, 2, 3 , "318904554"),  "%how% %fromFile%%fromRev%"  ) ;
    public static final ErrorId MsgDm_FilelogRevDefault       	= new ErrorId( ErrorOf( ES_DM, 232, E_INFO, 1, 4 , "335616232"),  "%depotRev% %change% %action% on %date%"  ) ;
    public static final ErrorId MsgDm_FilelogRevMessage       	= new ErrorId( ErrorOf( ES_DM, 233, E_INFO, 1, 8 , "402725097"),  "%depotRev% %change% %action% on %date% by %user%@%client% (%type%)%description%"  ) ;
    public static final ErrorId MsgDm_FilesData               	= new ErrorId( ErrorOf( ES_DM, 235, E_INFO, 0, 5 , "352327915"),  "%depotFile%%depotRev% - %action% %change% (%type%)"  ) ;
    public static final ErrorId MsgDm_FilesDiskUsage          	= new ErrorId( ErrorOf( ES_DM, 454, E_INFO, 0, 4 , "335550918"),  "%depotFile%%depotRev% %fileSize% bytes [%blockCount% blocks]"  ) ;
    public static final ErrorId MsgDm_FilesSummary            	= new ErrorId( ErrorOf( ES_DM, 446, E_INFO, 0, 4 , "335550910"),  "%path% %fileCount% files %fileSize% bytes [%blockCount% blocks]"  ) ;
    public static final ErrorId MsgDm_FiltersReplicaOnly      	= new ErrorId( ErrorOf( ES_DM, 746, E_FAILED, EV_CONTEXT, 0 , "805509866"),  "Data Filters should be specified only for replica servers."  ) ;
    public static final ErrorId MsgDm_FixAdd                  	= new ErrorId( ErrorOf( ES_DM, 236, E_INFO, 0, 3 , "318773484"),  "%job% fixed by %change% (%status%)."  ) ;
    public static final ErrorId MsgDm_FixAddDefault           	= new ErrorId( ErrorOf( ES_DM, 237, E_INFO, 0, 2 , "301996269"),  "%job% fixed by %change%."  ) ;
    public static final ErrorId MsgDm_FixBadVal               	= new ErrorId( ErrorOf( ES_DM, 88, E_FAILED, EV_USAGE, 1 , "822155352"),  "Job fix status must be one of %values%."  ) ;
    public static final ErrorId MsgDm_FixDelete               	= new ErrorId( ErrorOf( ES_DM, 238, E_INFO, 0, 2 , "301996270"),  "Deleted fix %job% by %change%."  ) ;
    public static final ErrorId MsgDm_FixesData               	= new ErrorId( ErrorOf( ES_DM, 239, E_INFO, 0, 6 , "369105135"),  "%job% fixed by %change% on %date% by %user%@%client% (%status%)"  ) ;
    public static final ErrorId MsgDm_FixesDataDefault        	= new ErrorId( ErrorOf( ES_DM, 240, E_INFO, 0, 5 , "352327920"),  "%job% fixed by %change% on %date% by %user%@%client%"  ) ;
    public static final ErrorId MsgDm_GrepFileOutput         	= new ErrorId( ErrorOf( ES_DM, 532, E_INFO, 0, 2 , "301996564"),  "%depotFile%#%depotRev%"  ) ;
    public static final ErrorId MsgDm_GrepLineTooLong         	= new ErrorId( ErrorOf( ES_DM, 534, E_WARN, 0, 4 , "603986454"),  "%depotFile%#%depotRev% - line %linenumber%: maximum line length of %maxlinelength% exceeded"  ) ;
    public static final ErrorId MsgDm_GrepMaxRevs            	= new ErrorId( ErrorOf( ES_DM, 535, E_FAILED, EV_USAGE, 1 , "822155799"),  "Grep revision limit exceeded (over %maxRevs%)."  ) ;
    public static final ErrorId MsgDm_GrepOutput              	= new ErrorId( ErrorOf( ES_DM, 531, E_INFO, 0, 4 , "335550995"),  "%depotFile%#%depotRev%%separator%%linecontent%"  ) ;
    public static final ErrorId MsgDm_GrepSeparator          	= new ErrorId( ErrorOf( ES_DM, 536, E_INFO, 0, 0 , "268442136"),  "--"  ) ;
    public static final ErrorId MsgDm_GrepWithLineNumber      	= new ErrorId( ErrorOf( ES_DM, 533, E_INFO, 0, 6 , "369105429"),  "%depotFile%#%depotRev%%separator1%%linenumber%%separator2%%linecontent%"  ) ;
    public static final ErrorId MsgDm_GroupCreated            	= new ErrorId( ErrorOf( ES_DM, 241, E_INFO, 0, 1 , "285219057"),  "Group %group% created."  ) ;
    public static final ErrorId MsgDm_GroupDeleted            	= new ErrorId( ErrorOf( ES_DM, 243, E_INFO, 0, 1 , "285219059"),  "Group %group% deleted."  ) ;
    public static final ErrorId MsgDm_GroupExists             	= new ErrorId( ErrorOf( ES_DM, 718, E_FAILED, 0, 1, "822090446"),  "No permission to modify existing group %group%."  ) ;
    public static final ErrorId MsgDm_GroupNotCreated         	= new ErrorId( ErrorOf( ES_DM, 242, E_INFO, 0, 1 , "285219058"),  "Group %group% not created."  ) ;
    public static final ErrorId MsgDm_GroupNotOwner	       	= new ErrorId( ErrorOf( ES_DM, 472, E_FAILED, 0, 2, "838867416"),  "User '%user%' is not an owner of group '%group%'."  ) ;
    public static final ErrorId MsgDm_GroupNotUpdated         	= new ErrorId( ErrorOf( ES_DM, 244, E_INFO, 0, 1 , "285219060"),  "Group %group% not updated."  ) ;
    public static final ErrorId MsgDm_GroupUpdated            	= new ErrorId( ErrorOf( ES_DM, 245, E_INFO, 0, 1 , "285219061"),  "Group %group% updated."  ) ;
    public static final ErrorId MsgDm_GroupsData              	= new ErrorId( ErrorOf( ES_DM, 246, E_INFO, 0, 1 , "285219062"),  "%group%"  ) ;
    public static final ErrorId MsgDm_GroupsDataVerbose       	= new ErrorId( ErrorOf( ES_DM, 474, E_INFO, 0, 5 , "352328154"),  "%group% %maxresults% %maxscanrows% %maxtimeout% %timeout%"  ) ;
    public static final ErrorId MsgDm_HaveData                	= new ErrorId( ErrorOf( ES_DM, 247, E_INFO, 0, 3 , "318773495"),  "%depotFile%%haveRev% - %lp%"  ) ;
    public static final ErrorId MsgDm_HaveVsRev               	= new ErrorId( ErrorOf( ES_DM, 55, E_FATAL, EV_FAULT, 1 , "1092687927"),  "File %depotFile% isn't in revisions table!"  ) ;
    public static final ErrorId MsgDm_IdEmbeddedNul           	= new ErrorId( ErrorOf( ES_DM, 749, E_FAILED, EV_USAGE, 1 , "822156013"),  "Embedded null bytes not allowed - '%id%'."  ) ;
    public static final ErrorId MsgDm_IdEmpty                 	= new ErrorId( ErrorOf( ES_DM, 5, E_FAILED, EV_USAGE, 0 , "805378053"),  "Empty identifier not allowed."  ) ;
    public static final ErrorId MsgDm_IdHasComma              	= new ErrorId( ErrorOf( ES_DM, 485, E_FAILED, EV_USAGE, 1 , "822155749"),  "Commas (,) not allowed in '%id%'."  ) ;
    public static final ErrorId MsgDm_IdHasDash               	= new ErrorId( ErrorOf( ES_DM, 4, E_FAILED, EV_USAGE, 1 , "822155268"),  "Initial dash character not allowed in '%id%'."  ) ;
    public static final ErrorId MsgDm_IdHasPercent              	= new ErrorId( ErrorOf( ES_DM, 642, E_FAILED, EV_USAGE, 1 , "822155906"),  "Percent character not allowed in '%id%'."  ) ;
    public static final ErrorId MsgDm_IdHasRev                	= new ErrorId( ErrorOf( ES_DM, 7, E_FAILED, EV_USAGE, 1 , "822155271"),  "Revision chars (@, #) not allowed in '%id%'."  ) ;
    public static final ErrorId MsgDm_IdHasSlash              	= new ErrorId( ErrorOf( ES_DM, 8, E_FAILED, EV_USAGE, 1 , "822155272"),  "Slashes (/) not allowed in '%id%'."  ) ;
    public static final ErrorId MsgDm_IdNonPrint              	= new ErrorId( ErrorOf( ES_DM, 6, E_FAILED, EV_USAGE, 1 , "822155270"),  "Non-printable characters not allowed in '%id%'."  ) ;
    public static final ErrorId MsgDm_IdNullDir               	= new ErrorId( ErrorOf( ES_DM, 9, E_FAILED, EV_USAGE, 1 , "822155273"),  "Null directory (//) not allowed in '%id%'."  ) ;
    public static final ErrorId MsgDm_IdNumber                	= new ErrorId( ErrorOf( ES_DM, 12, E_FAILED, EV_USAGE, 1 , "822155276"),  "Purely numeric name not allowed - '%id%'."  ) ;
    public static final ErrorId MsgDm_IdRelPath               	= new ErrorId( ErrorOf( ES_DM, 10, E_FAILED, EV_USAGE, 1 , "822155274"),  "Relative paths (., ..) not allowed in '%id%'."  ) ;
    public static final ErrorId MsgDm_IdTooLong               	= new ErrorId( ErrorOf( ES_DM, 3, E_FAILED, EV_USAGE, 0 , "805378051"),  "Identifiers too long.  Must not be longer than 1024 bytes of UTF-8."  ) ;
    public static final ErrorId MsgDm_IdWild                  	= new ErrorId( ErrorOf( ES_DM, 11, E_FAILED, EV_USAGE, 1 , "822155275"),  "Wildcards (*, %%%%x, ...) not allowed in '%id%'."  ) ;
    public static final ErrorId MsgDm_ImportNotUnder             	= new ErrorId( ErrorOf( ES_DM, 544, E_FAILED, EV_CONTEXT, 1 , "822286880"),  "Import path '%depotFile%' is not under an accessible depot."  ) ;
    public static final ErrorId MsgDm_InfoDomain              	= new ErrorId( ErrorOf( ES_DM, 249, E_INFO, 0, 2 , "301996281"),  "%domainType% root: %root%"  ) ;
    public static final ErrorId MsgDm_InfoUnknownDomain       	= new ErrorId( ErrorOf( ES_DM, 248, E_INFO, 0, 1 , "285219064"),  "%domainType% unknown."  ) ;
    public static final ErrorId MsgDm_IntegAlreadyOpened      	= new ErrorId( ErrorOf( ES_DM, 250, E_INFO, 0, 2 , "301996282"),  "%depotFile% - can't %action% (already opened on this client)"  ) ;
    public static final ErrorId MsgDm_IntegBadAction          	= new ErrorId( ErrorOf( ES_DM, 255, E_INFO, 0, 3 , "318773503"),  "%depotFile% - can't %action% (already opened for %badAction%)[ (remapped from %movedFrom%)]"  ) ;
    public static final ErrorId MsgDm_IntegBadAncestor        	= new ErrorId( ErrorOf( ES_DM, 253, E_INFO, 0, 5 , "352327933"),  "%depotFile% - can't %action% from %fromFile%%fromRev% without -d or %flag% flag"  ) ;
    public static final ErrorId MsgDm_IntegBadBase            	= new ErrorId( ErrorOf( ES_DM, 254, E_INFO, 0, 4 , "335550718"),  "%depotFile% - can't %action% from %fromFile%%fromRev% without -i flag"  ) ;
    public static final ErrorId MsgDm_IntegBadClient          	= new ErrorId( ErrorOf( ES_DM, 256, E_INFO, 0, 2 , "301996288"),  "%depotFile% - is already opened by client %client%"  ) ;
    public static final ErrorId MsgDm_IntegBadUser            	= new ErrorId( ErrorOf( ES_DM, 257, E_INFO, 0, 2 , "301996289"),  "%depotFile% - is already opened by user %user%"  ) ;
    public static final ErrorId MsgDm_IntegBaselessMove       	= new ErrorId( ErrorOf( ES_DM, 682, E_WARN, 0, 3 , "587209386"),  "%depotFile% - resolve move to %moveFile% before integrating from %fromFile%"  ) ;
    public static final ErrorId MsgDm_IntegCantAdd            	= new ErrorId( ErrorOf( ES_DM, 258, E_INFO, 0, 2 , "301996290"),  "%depotFile% - can't %action% existing file"  ) ;
    public static final ErrorId MsgDm_IntegCantModify         	= new ErrorId( ErrorOf( ES_DM, 259, E_INFO, 0, 2 , "301996291"),  "%depotFile% - can't %action% deleted file"  ) ;
    public static final ErrorId MsgDm_IntegIncompatable       	= new ErrorId( ErrorOf( ES_DM, 461, E_INFO, 0, 2 , "301996493"),  "%depotFile% - file type of %fromFile% incompatible"  ) ;
    public static final ErrorId MsgDm_IntegIntoReadOnly       	= new ErrorId( ErrorOf( ES_DM, 251, E_INFO, 0, 2 , "301996283"),  "%depotFile% - can only %action% into file in a local depot"  ) ;
    public static final ErrorId MsgDm_IntegMovedNoAccess      	= new ErrorId( ErrorOf( ES_DM, 552, E_INFO, 0, 2 , "301996584"),  "%depotFile% - no permission (remapped from %movedFrom%)"  ) ;
    public static final ErrorId MsgDm_IntegMovedNoFrom        	= new ErrorId( ErrorOf( ES_DM, 721, E_INFO, 0, 5 , "352328401"),  "%depotFile% - can't %action% from %fromFile%%fromRev% (moved from %movedFrom%; provide a branch view that maps this file, or use -Di to disregard move/deletes)"  ) ;
    public static final ErrorId MsgDm_IntegMovedOutScope      	= new ErrorId( ErrorOf( ES_DM, 556, E_INFO, 0, 2 , "301996588"),  "%depotFile% - not in branch view (remapped from %movedFrom%)"  ) ;
    public static final ErrorId MsgDm_IntegMovedUnmapped      	= new ErrorId( ErrorOf( ES_DM, 551, E_INFO, 0, 2 , "301996583"),  "%depotFile% - not in client view (remapped from %movedFrom%)"  ) ;
    public static final ErrorId MsgDm_IntegMustSync           	= new ErrorId( ErrorOf( ES_DM, 260, E_INFO, 0, 1 , "285219076"),  "%toFile% - must sync before integrating."  ) ;
    public static final ErrorId MsgDm_IntegNotHandled         	= new ErrorId( ErrorOf( ES_DM, 264, E_INFO, 0, 3 , "318773512"),  "%depotFile%%workRev% - flag %flag% not handled!"  ) ;
    public static final ErrorId MsgDm_IntegOpenOkay           	= new ErrorId( ErrorOf( ES_DM, 261, E_INFO, 0, 5 , "352327941"),  "%depotFile%%workRev% - %action% from %fromFile%%fromRev%"  ) ;
    public static final ErrorId MsgDm_IntegOpenOkayBase       	= new ErrorId( ErrorOf( ES_DM, 424, E_INFO, 0, 8 , "402659752"),  "%depotFile%%workRev% - %action% from %fromFile%%fromRev%[ using base %baseFile%][%baseRev%][ (remapped from %remappedFrom%)]"  ) ;
    public static final ErrorId MsgDm_IntegPreviewResolve     	= new ErrorId( ErrorOf( ES_DM, 710, E_INFO, 1, 5 , "352393926"),  "must resolve %resolveType% from %fromFile%%fromRev%[ using base %baseFile%][%baseRev%]"  ) ;
    public static final ErrorId MsgDm_IntegPreviewResolveMove 	= new ErrorId( ErrorOf( ES_DM, 711, E_INFO, 1, 2 , "302062279"),  "must resolve move to %fromFile%[ using base %baseFile%]"  ) ;
    public static final ErrorId MsgDm_IntegSyncBranch         	= new ErrorId( ErrorOf( ES_DM, 262, E_INFO, 0, 5 , "352327942"),  "%depotFile%%workRev% - %action%/sync from %fromFile%%fromRev%"  ) ;
    public static final ErrorId MsgDm_IntegSyncDelete         	= new ErrorId( ErrorOf( ES_DM, 263, E_INFO, 0, 5 , "352327943"),  "%depotFile%%workRev% - sync/%action% from %fromFile%%fromRev%"  ) ;
    public static final ErrorId MsgDm_IntegSyncIntegBase      	= new ErrorId( ErrorOf( ES_DM, 427, E_INFO, 0, 5 , "352328107"),  "%depotFile%%workRev% - sync/%action% from %fromFile%%fromRev%[ using base %baseFile%][%baseRev%][ (remapped from %remappedFrom%)]"  ) ;
    public static final ErrorId MsgDm_IntegTooVirtual         	= new ErrorId( ErrorOf( ES_DM, 449, E_INFO, 0, 2 , "301996481"),  "%depotFile% - can't %action% file branched with integrate -v"  ) ;
    public static final ErrorId MsgDm_IntegVsRev              	= new ErrorId( ErrorOf( ES_DM, 59, E_FATAL, EV_FAULT, 1 , "1092687931"),  "%depotFile% is missing from the rev table!"  ) ;
    public static final ErrorId MsgDm_IntegVsShelve              	= new ErrorId( ErrorOf( ES_DM, 631, E_FAILED, EV_FAULT, 2 , "841030263"),  "%depotFile%%rev%: can't resolve (shelved change was deleted); must revert, or revert -k and edit before submit."  ) ;
    public static final ErrorId MsgDm_IntegVsWork             	= new ErrorId( ErrorOf( ES_DM, 60, E_FATAL, EV_FAULT, 1 , "1092687932"),  "%depotFile% is missing from the working table!"  ) ;
    public static final ErrorId MsgDm_IntegXOpened            	= new ErrorId( ErrorOf( ES_DM, 252, E_INFO, 0, 2 , "301996284"),  "%depotFile% - can't %action% exclusive file already opened"  ) ;
    public static final ErrorId MsgDm_IntegedData             	= new ErrorId( ErrorOf( ES_DM, 265, E_INFO, 0, 5 , "352327945"),  "%toFile%%toRev% - %how% %fromFile%%fromRev%"  ) ;
    public static final ErrorId MsgDm_InvalidEscape           	= new ErrorId( ErrorOf( ES_DM, 433, E_FAILED, EV_USAGE, 0 , "805378481"),  "Target file has illegal escape sequence [%xx]."  ) ;
    public static final ErrorId MsgDm_InvalidParent             	= new ErrorId( ErrorOf( ES_DM, 542, E_FAILED, EV_CONTEXT, 1 , "822286878"),  "Invalid parent field '%parent%'. Check stream, parent and type."  ) ;
    public static final ErrorId MsgDm_InvalidStreamFmt          	= new ErrorId( ErrorOf( ES_DM, 576, E_FAILED, 0, 1, "822090304"),  "Stream '%stream%' is not the correct format of '//depotname/string' "  ) ;
    public static final ErrorId MsgDm_InvalidType             	= new ErrorId( ErrorOf( ES_DM, 2, E_FAILED, EV_USAGE, 2 , "838932482"),  "Invalid %type% '%arg%'."  ) ;
    public static final ErrorId MsgDm_JobDelete               	= new ErrorId( ErrorOf( ES_DM, 268, E_INFO, 0, 1 , "285219084"),  "Job %job% deleted."  ) ;
    public static final ErrorId MsgDm_JobDeleteHasFix      	= new ErrorId( ErrorOf( ES_DM, 465, E_INFO, 0, 2 , "301996497"),  "%job% has %count% fixes associated with it and can't be deleted."  ) ;
    public static final ErrorId MsgDm_JobDescMissing          	= new ErrorId( ErrorOf( ES_DM, 75, E_FAILED, EV_USAGE, 1 , "822155339"),  "'%field%' field blank.  You must provide it."  ) ;
    public static final ErrorId MsgDm_JobDescription          	= new ErrorId( ErrorOf( ES_DM, 269, E_INFO, 0, 5 , "352327949"),  "%job%[ on %date%][ by %user%][ *%status%*][%description%]"  ) ;
    public static final ErrorId MsgDm_JobFieldAlways        	= new ErrorId( ErrorOf( ES_DM, 441, E_FAILED, EV_USAGE, 2 , "838932921"),  "%field% is a read-only always field and can't be changed from '%value%'.\nThe job may have been updated while you were editing."  ) ;
    public static final ErrorId MsgDm_JobFieldReadOnly        	= new ErrorId( ErrorOf( ES_DM, 77, E_FAILED, EV_USAGE, 2 , "838932557"),  "%field% is read-only and can't be changed from '%value%'."  ) ;
    public static final ErrorId MsgDm_JobHasChanged           	= new ErrorId( ErrorOf( ES_DM, 434, E_FAILED, EV_UNKNOWN, 0 , "805444018"),  "Job has been modified by another user, clear date field to overwrite."  ) ;
    public static final ErrorId MsgDm_JobName101              	= new ErrorId( ErrorOf( ES_DM, 79, E_FAILED, EV_USAGE, 0 , "805378127"),  "A job name field with code 101 must be present."  ) ;
    public static final ErrorId MsgDm_JobNameJob              	= new ErrorId( ErrorOf( ES_DM, 74, E_FAILED, EV_USAGE, 0 , "805378122"),  "The job name 'job' is reserved."  ) ;
    public static final ErrorId MsgDm_JobNameMissing          	= new ErrorId( ErrorOf( ES_DM, 54, E_FATAL, EV_ADMIN, 0 , "1076041782"),  "Missing job name field!"  ) ;
    public static final ErrorId MsgDm_JobNoChange             	= new ErrorId( ErrorOf( ES_DM, 267, E_INFO, 0, 1 , "285219083"),  "Job %job% not changed."  ) ;
    public static final ErrorId MsgDm_JobSave                 	= new ErrorId( ErrorOf( ES_DM, 266, E_INFO, 0, 1 , "285219082"),  "Job %job% saved."  ) ;
    public static final ErrorId MsgDm_LabelHasRev             	= new ErrorId( ErrorOf( ES_DM, 438, E_FAILED, EV_NOTYET, 1 , "822417846"),  "Label '%label%' has a Revision field and must remain empty."  ) ;
    public static final ErrorId MsgDm_LabelLocked             	= new ErrorId( ErrorOf( ES_DM, 81, E_FAILED, EV_PROTECT, 1 , "822483025"),  "Can't modify locked label '%label%'.\nUse 'label' to change label options."  ) ;
    public static final ErrorId MsgDm_LabelLoop               	= new ErrorId( ErrorOf( ES_DM, 455, E_FAILED, EV_USAGE, 1 , "822155719"),  "Too many automatic labels (label '%label%' may refer to itself)."  ) ;
    public static final ErrorId MsgDm_LabelNoSync             	= new ErrorId( ErrorOf( ES_DM, 437, E_FAILED, EV_NOTYET, 0 , "805640629"),  "The Revision field can only be added to empty labels."  ) ;
    public static final ErrorId MsgDm_LabelOwner              	= new ErrorId( ErrorOf( ES_DM, 80, E_FAILED, EV_PROTECT, 2 , "839260240"),  "Can't modify label '%label%' owned by '%user%'."  ) ;
    public static final ErrorId MsgDm_LabelSyncAdd            	= new ErrorId( ErrorOf( ES_DM, 272, E_INFO, 0, 2 , "301996304"),  "%depotFile%%haveRev% - added"  ) ;
    public static final ErrorId MsgDm_LabelSyncDelete         	= new ErrorId( ErrorOf( ES_DM, 273, E_INFO, 0, 2 , "301996305"),  "%depotFile%%haveRev% - deleted"  ) ;
    public static final ErrorId MsgDm_LabelSyncReplace        	= new ErrorId( ErrorOf( ES_DM, 274, E_INFO, 0, 2 , "301996306"),  "%depotFile%%haveRev% - replaced"  ) ;
    public static final ErrorId MsgDm_LabelSyncUpdate         	= new ErrorId( ErrorOf( ES_DM, 275, E_INFO, 0, 2 , "301996307"),  "%depotFile%%haveRev% - updated"  ) ;
    public static final ErrorId MsgDm_LameCodes               	= new ErrorId( ErrorOf( ES_DM, 410, E_FAILED, EV_USAGE, 3 , "855710106"),  "Field codes must be between %low%-%hi% for %type% specs."  ) ;
    public static final ErrorId MsgDm_LicenseNoChange         	= new ErrorId( ErrorOf( ES_DM, 451, E_INFO, 0, 0 , "268442051"),  "License file not changed."  ) ;
    public static final ErrorId MsgDm_LicenseSave             	= new ErrorId( ErrorOf( ES_DM, 450, E_INFO, 0, 0 , "268442050"),  "License file saved."  ) ;
    public static final ErrorId MsgDm_LicensedClients         	= new ErrorId( ErrorOf( ES_DM, 119, E_INFO, EV_ADMIN, 2 , "304289911"),  "License count: %count% clients used of %max% licensed."  ) ;
    public static final ErrorId MsgDm_LicensedUsers           	= new ErrorId( ErrorOf( ES_DM, 120, E_INFO, EV_ADMIN, 2 , "304289912"),  "License count: %count% users used of %max% licensed."  ) ;
    public static final ErrorId MsgDm_LimitBadArg             	= new ErrorId( ErrorOf( ES_DM, 625, E_FAILED, EV_USAGE, 1 , "822155889"),  "%path% - must refer to a local depot in depot syntax."  ) ;
    public static final ErrorId MsgDm_LineTooLong             	= new ErrorId( ErrorOf( ES_DM, 673, E_FAILED, EV_USAGE, 1 , "822155937"),  "Logfile line too long. Maximum length is %maxLineLen%. This length can be increased by setting the filesys.bufsize configurable."  ) ;
    public static final ErrorId MsgDm_LocWild                  	= new ErrorId( ErrorOf( ES_DM, 514, E_FAILED, EV_USAGE, 2 , "838932994"),  "%loc% wildcards (*, ...) not allowed in path: '%path%'."  ) ;
    public static final ErrorId MsgDm_LockAlready             	= new ErrorId( ErrorOf( ES_DM, 277, E_INFO, 0, 1 , "285219093"),  "%depotFile% - already locked"  ) ;
    public static final ErrorId MsgDm_LockAlreadyOther        	= new ErrorId( ErrorOf( ES_DM, 278, E_INFO, 0, 3 , "318773526"),  "%depotFile% - already locked by %user%@%client%"  ) ;
    public static final ErrorId MsgDm_LockBadUnicode          	= new ErrorId( ErrorOf( ES_DM, 525, E_INFO, 0, 1 , "285219341"),  "%depotFile% - cannot submit unicode type file using non-unicode server"  ) ;
    public static final ErrorId MsgDm_LockNoPermission        	= new ErrorId( ErrorOf( ES_DM, 279, E_INFO, 0, 1 , "285219095"),  "%depotFile% - no permission to lock file"  ) ;
    public static final ErrorId MsgDm_LockSuccess             	= new ErrorId( ErrorOf( ES_DM, 276, E_INFO, 0, 1 , "285219092"),  "%depotFile% - locking"  ) ;
    public static final ErrorId MsgDm_LockUtf16NotSupp        	= new ErrorId( ErrorOf( ES_DM, 526, E_INFO, 0, 1 , "285219342"),  "%depotFile% - utf16 files can not be submitted by pre-2007.2 clients"  ) ;
    public static final ErrorId MsgDm_LockedClient            	= new ErrorId( ErrorOf( ES_DM, 94, E_FAILED, EV_PROTECT, 2 , "839260254"),  "Locked client '%client%' can only be used by owner '%user%'."  ) ;
    public static final ErrorId MsgDm_LockedDelete            	= new ErrorId( ErrorOf( ES_DM, 70, E_FAILED, EV_PROTECT, 2 , "839260230"),  "%type% '%name%' is locked and can't be deleted."  ) ;
    public static final ErrorId MsgDm_LockedHost              	= new ErrorId( ErrorOf( ES_DM, 95, E_FAILED, EV_PROTECT, 2 , "839260255"),  "Client '%client%' can only be used from host '%host%'."  ) ;
    public static final ErrorId MsgDm_LockedUpdate            	= new ErrorId( ErrorOf( ES_DM, 68, E_FAILED, EV_PROTECT, 3 , "856037444"),  "Locked %type% '%name%' owned by '%user%'; use -f to force update."  ) ;
    public static final ErrorId MsgDm_LoggerData              	= new ErrorId( ErrorOf( ES_DM, 283, E_INFO, 0, 3 , "318773531"),  "%sequence% %key% %attribute%"  ) ;
    public static final ErrorId MsgDm_ManyRevSpec             	= new ErrorId( ErrorOf( ES_DM, 436, E_FAILED, EV_USAGE, 1 , "822155700"),  "Too many revision specifications (max %max%)."  ) ;
    public static final ErrorId MsgDm_MapNoListAccess         	= new ErrorId( ErrorOf( ES_DM, 432, E_FAILED, EV_CONTEXT, 0 , "805509552"),  "User does not have list access for mapped depots."  ) ;
    public static final ErrorId MsgDm_MapNotUnder             	= new ErrorId( ErrorOf( ES_DM, 44, E_FAILED, EV_CONTEXT, 2 , "839063596"),  "Mapping '%depotFile%' is not under '%prefix%'."  ) ;
    public static final ErrorId MsgDm_MaxLockTime             	= new ErrorId( ErrorOf( ES_DM, 453, E_FAILED, EV_ADMIN, 1 , "824383941"),  "Operation took too long (over %maxLockTime% seconds); see 'p4 help maxlocktime'."  ) ;
    public static final ErrorId MsgDm_MaxResults              	= new ErrorId( ErrorOf( ES_DB, 32, E_FAILED, EV_ADMIN, 1 , "824381472"),  "Request too large (over %maxResults%); see 'p4 help maxresults'."  ) ;
    public static final ErrorId MsgDm_MaxScanRows             	= new ErrorId( ErrorOf( ES_DB, 61, E_FAILED, EV_ADMIN, 1 , "824381501"),  "Too many rows scanned (over %maxScanRows%); see 'p4 help maxscanrows'."  ) ;
    public static final ErrorId MsgDm_MayNotBeNegative        	= new ErrorId( ErrorOf( ES_DM, 615, E_FAILED, EV_USAGE, 1 , "822155879"),  "Negative value not allowed for counter '%counter%'."  ) ;
    public static final ErrorId MsgDm_MergeBadBase            	= new ErrorId( ErrorOf( ES_DM, 638, E_INFO, 0, 3 , "318773886"),  "%depotFile% - can't merge unrelated file %fromFile%%fromRev%"  ) ;
    public static final ErrorId MsgDm_MissingDesc             	= new ErrorId( ErrorOf( ES_DM, 62, E_FAILED, EV_USAGE, 0 , "805378110"),  "Change description missing.  You must enter one."  ) ;
    public static final ErrorId MsgDm_MissingStream             	= new ErrorId( ErrorOf( ES_DM, 575, E_FAILED, EV_UNKNOWN, 2 , "838998591"),  "Missing stream '%name%' in stream hierarchy for '%stream%'."  ) ;
    public static final ErrorId MsgDm_MonitorCantTerminate    	= new ErrorId( ErrorOf( ES_DM, 409, E_INFO, 0, 1 , "285219225"),  "** process '%id%' can't terminate, runtime < 10 seconds **"  ) ;
    public static final ErrorId MsgDm_MonitorClear            	= new ErrorId( ErrorOf( ES_DM, 407, E_INFO, 0, 1 , "285219223"),  "** process '%id%' record cleared **"  ) ;
    public static final ErrorId MsgDm_MonitorData             	= new ErrorId( ErrorOf( ES_DM, 406, E_INFO, 0, 9 , "419436950"),  "%id% [%prog% ][%host% ][%runstate%|T] %user% [%client% ]%elapsed% %function% %args%"  ) ;
    public static final ErrorId MsgDm_MonitorPause            	= new ErrorId( ErrorOf( ES_DM, 609, E_INFO, 0, 1 , "285219425"),  "** process '%id%' record paused **"  ) ;
    public static final ErrorId MsgDm_MonitorResume           	= new ErrorId( ErrorOf( ES_DM, 610, E_INFO, 0, 1 , "285219426"),  "** process '%id%' record resumed **"  ) ;
    public static final ErrorId MsgDm_MonitorTerminate        	= new ErrorId( ErrorOf( ES_DM, 408, E_INFO, 0, 1 , "285219224"),  "** process '%id%' marked for termination **"  ) ;
    public static final ErrorId MsgDm_MoveBadAction           	= new ErrorId( ErrorOf( ES_DM, 488, E_INFO, 0, 2 , "301996520"),  "%depotFile% - can't move (already opened for %badAction%)"  ) ;
    public static final ErrorId MsgDm_MoveDeleted	       	= new ErrorId( ErrorOf( ES_DM, 626, E_WARN, 0, 2 , "570432114"),  "%clientFile% - can't move (open for %action%); must accept other resolve(s) or ignore"  ) ;
    public static final ErrorId MsgDm_MoveExists              	= new ErrorId( ErrorOf( ES_DM, 489, E_INFO, 0, 1 , "285219305"),  "%depotFile% - can't move to an existing file"  ) ;
    public static final ErrorId MsgDm_MoveMisMatch            	= new ErrorId( ErrorOf( ES_DM, 490, E_FATAL, EV_FAULT, 0 , "1075911146"),  "Mismatched move on client!"  ) ;
    public static final ErrorId MsgDm_MoveNeedForce           	= new ErrorId( ErrorOf( ES_DM, 530, E_INFO, 0, 1 , "285219346"),  "%clientFile% - is synced; use -f to force move"  ) ;
    public static final ErrorId MsgDm_MoveNoMatch             	= new ErrorId( ErrorOf( ES_DM, 491, E_INFO, 0, 3 , "318773739"),  "%depotFile% - needs %direction%file %movedFile%"  ) ;
    public static final ErrorId MsgDm_MoveNotResolved         	= new ErrorId( ErrorOf( ES_DM, 529, E_INFO, 0, 1 , "285219345"),  "%depotFile% - is unresolved, can't force move"  ) ;
    public static final ErrorId MsgDm_MoveNotSynced           	= new ErrorId( ErrorOf( ES_DM, 528, E_INFO, 0, 1 , "285219344"),  "%depotFile% - not synced, can't force move"  ) ;
    public static final ErrorId MsgDm_MoveReadOnly            	= new ErrorId( ErrorOf( ES_DM, 494, E_INFO, 0, 1 , "285219310"),  "%depotFile% - can't move to a spec or remote depot"  ) ;
    public static final ErrorId MsgDm_MoveSuccess             	= new ErrorId( ErrorOf( ES_DM, 487, E_INFO, 0, 4 , "335550951"),  "%toFile%%toRev% - moved from %fromFile%%fromRev%"  ) ;
    public static final ErrorId MsgDm_MultiWordDefault        	= new ErrorId( ErrorOf( ES_DM, 78, E_FAILED, EV_USAGE, 1 , "822155342"),  "%field% can't have a default multi-word value."  ) ;
    public static final ErrorId MsgDm_MustBeNumeric           	= new ErrorId( ErrorOf( ES_DM, 617, E_FAILED, EV_USAGE, 1 , "822155881"),  "Non-numeric value not allowed for counter '%counter%'."  ) ;
    public static final ErrorId MsgDm_NameChanged             	= new ErrorId( ErrorOf( ES_DM, 57, E_FATAL, EV_FAULT, 1 , "1092687929"),  "File %depotFile% changed it's name!"  ) ;
    public static final ErrorId MsgDm_NeedClient              	= new ErrorId( ErrorOf( ES_DM, 99, E_FAILED, EV_CONFIG, 2 , "841226339"),  "%arg% - must create client '%client%' to access local files."  ) ;
    public static final ErrorId MsgDm_NeedJobUpgrade          	= new ErrorId( ErrorOf( ES_DM, 52, E_FATAL, EV_ADMIN, 0 , "1076041780"),  "Jobs database must be upgraded with 'p4 jobs -R'!"  ) ;
    public static final ErrorId MsgDm_NeedsUpgrades           	= new ErrorId( ErrorOf( ES_DM, 22, E_FAILED, EV_ADMIN, 2 , "841160726"),  "Database is at old upgrade level %level%.  Use 'p4d -xu' to upgrade to level %level2%."  ) ;
    public static final ErrorId MsgDm_NoArchive               	= new ErrorId( ErrorOf( ES_DM, 91, E_FATAL, EV_FAULT, 1 , "1092687963"),  "Can't map %lbrFile% to archive!"  ) ;
    public static final ErrorId MsgDm_NoCheckin               	= new ErrorId( ErrorOf( ES_DM, 106, E_FATAL, EV_FAULT, 1 , "1092687978"),  "%path% - can't checkin remote file!"  ) ;
    public static final ErrorId MsgDm_NoClearText             	= new ErrorId( ErrorOf( ES_DM, 419, E_FAILED, EV_USAGE, 0 , "805378467"),  "Passwords can only be set by 'p4 passwd' at this security level."  ) ;
    public static final ErrorId MsgDm_NoClient                	= new ErrorId( ErrorOf( ES_DM, 89, E_FATAL, EV_FAULT, 1 , "1092687961"),  "%clientFile% - can't translate to local path -- no client!"  ) ;
    public static final ErrorId MsgDm_NoCodeZero              	= new ErrorId( ErrorOf( ES_DM, 115, E_FAILED, EV_USAGE, 1 , "822155379"),  "Code 0 not allowed on field '%field%'."  ) ;
    public static final ErrorId MsgDm_NoDefault               	= new ErrorId( ErrorOf( ES_DM, 117, E_FAILED, EV_USAGE, 1 , "822155381"),  "Field '%field%' needs a preset value to be type '%opt%'."  ) ;
    public static final ErrorId MsgDm_NoDelete                	= new ErrorId( ErrorOf( ES_DM, 105, E_FATAL, EV_FAULT, 1 , "1092687977"),  "%path% - can't delete remote file!"  ) ;
    public static final ErrorId MsgDm_NoDepot                 	= new ErrorId( ErrorOf( ES_DM, 90, E_FATAL, EV_FAULT, 1 , "1092687962"),  "Can't find %depot% in depot map!"  ) ;
    public static final ErrorId MsgDm_NoDepotTypeChange       	= new ErrorId( ErrorOf( ES_DM, 618, E_FAILED, EV_ILLEGAL, 0 , "805575274"),  "Depot type cannot be changed."  ) ;
    public static final ErrorId MsgDm_NoIntegHavemaps	       	= new ErrorId( ErrorOf( ES_DM, 448, E_FAILED, EV_USAGE, 0 , "805378496"),  "Havemap entries found in non-client view!"  ) ;
    public static final ErrorId MsgDm_NoIntegOverlays         	= new ErrorId( ErrorOf( ES_DM, 421, E_FAILED, EV_USAGE, 0 , "805378469"),  "Overlay (+) mappings are not allowed in branch views."  ) ;
    public static final ErrorId MsgDm_NoModComChange          	= new ErrorId( ErrorOf( ES_DM, 64, E_FAILED, EV_CONTEXT, 1 , "822286400"),  "Can't update committed change %change%."  ) ;
    public static final ErrorId MsgDm_NoNextRev               	= new ErrorId( ErrorOf( ES_DM, 48, E_FATAL, EV_FAULT, 1 , "1092687920"),  "Can't find %depotFile%'s successor rev!"  ) ;
    public static final ErrorId MsgDm_NoNotOp                 	= new ErrorId( ErrorOf( ES_DM, 114, E_FAILED, EV_USAGE, 0 , "805378162"),  "Can't handle ^ (not) operator there."  ) ;
    public static final ErrorId MsgDm_NoPerms                 	= new ErrorId( ErrorOf( ES_DM, 41, E_FAILED, EV_PROTECT, 0 , "805705769"),  "You don't have permission for this operation."  ) ;
    public static final ErrorId MsgDm_NoPrevRev               	= new ErrorId( ErrorOf( ES_DM, 616, E_INFO, 0, 2 , "301996648"),  "Unable to show the differences for file %depotFile% because the revision prior to %depotRev% is missing from the revisions table. If the prior revisions of this file were obliterated, this is a normal situation; otherwise it may indicate repository damage and should be investigated further."  ) ;
    public static final ErrorId MsgDm_NoProtect               	= new ErrorId( ErrorOf( ES_DM, 123, E_FAILED, EV_PROTECT, 1 , "822483067"),  "Access for user '%user%' has not been enabled by 'p4 protect'."  ) ;
    public static final ErrorId MsgDm_NoRev                   	= new ErrorId( ErrorOf( ES_DM, 97, E_FAILED, EV_USAGE, 0 , "805378145"),  "A revision specification (# or @) cannot be used here."  ) ;
    public static final ErrorId MsgDm_NoRevRange              	= new ErrorId( ErrorOf( ES_DM, 98, E_FAILED, EV_USAGE, 0 , "805378146"),  "A revision range cannot be used here."  ) ;
    public static final ErrorId MsgDm_NoRevisionOverwrite     	= new ErrorId( ErrorOf( ES_DM, 741, E_FATAL, EV_FAULT, 2 , "1109465829"),  "Revision %depotFile%#%depotRev% already exists! A submit operation attempted to overwrite this revision with a new file at the same revision. This should never happen, and therefore the server has aborted the submit. It is possible that the Perforce database files have been corrupted by a disk failure, system crash, or improper restore operation. Please contact Perforce technical support for assistance. Please do not perform any further operations on the server until the problem can be resolved. Please save all server logs, journals, and database tables for use in determining the necessary recovery operations."  ) ;
    public static final ErrorId MsgDm_NoRmtInterop            	= new ErrorId( ErrorOf( ES_DM, 111, E_FAILED, EV_ADMIN, 0 , "807606383"),  "Remote depot access is not supported between UNIX and NT prior to 99.2."  ) ;
    public static final ErrorId MsgDm_NoStreamAtChange          	= new ErrorId( ErrorOf( ES_DM, 550, E_FAILED, EV_CONTEXT, 2 , "839064102"),  "No stream '%stream%' existed at change %change%"  ) ;
    public static final ErrorId MsgDm_NoSuchChange            	= new ErrorId( ErrorOf( ES_DM, 26, E_FAILED, EV_UNKNOWN, 1 , "822220826"),  "%change% unknown."  ) ;
    public static final ErrorId MsgDm_NoSuchConfig            	= new ErrorId( ErrorOf( ES_DM, 546, E_FAILED, EV_UNKNOWN, 1 , "822221346"),  "No such configuration variable '%config%'."  ) ;
    public static final ErrorId MsgDm_NoSuchCounter           	= new ErrorId( ErrorOf( ES_DM, 30, E_FAILED, EV_UNKNOWN, 1 , "822220830"),  "No such counter '%counter%'."  ) ;
    public static final ErrorId MsgDm_NoSuchDepot             	= new ErrorId( ErrorOf( ES_DM, 32, E_FAILED, EV_UNKNOWN, 1 , "822220832"),  "Depot '%depot%' doesn't exist."  ) ;
    public static final ErrorId MsgDm_NoSuchDepot2            	= new ErrorId( ErrorOf( ES_DM, 33, E_FAILED, EV_UNKNOWN, 1 , "822220833"),  "Depot '%depot%' unknown - use 'depot' to create it."  ) ;
    public static final ErrorId MsgDm_NoSuchDomain            	= new ErrorId( ErrorOf( ES_DM, 34, E_FAILED, EV_UNKNOWN, 2 , "838998050"),  "%type% '%name%' doesn't exist."  ) ;
    public static final ErrorId MsgDm_NoSuchDomain2           	= new ErrorId( ErrorOf( ES_DM, 35, E_FAILED, EV_UNKNOWN, 3 , "855775267"),  "%type% '%name%' unknown - use '%command%' command to create it."  ) ;
    public static final ErrorId MsgDm_NoSuchFix               	= new ErrorId( ErrorOf( ES_DM, 40, E_FAILED, EV_UNKNOWN, 0 , "805443624"),  "No such fix."  ) ;
    public static final ErrorId MsgDm_NoSuchGroup             	= new ErrorId( ErrorOf( ES_DM, 72, E_FAILED, EV_UNKNOWN, 1 , "822220872"),  "Group '%group%' doesn't exist."  ) ;
    public static final ErrorId MsgDm_NoSuchJob               	= new ErrorId( ErrorOf( ES_DM, 38, E_FAILED, EV_UNKNOWN, 1 , "822220838"),  "Job '%job%' doesn't exist."  ) ;
    public static final ErrorId MsgDm_NoSuchJob2              	= new ErrorId( ErrorOf( ES_DM, 39, E_FAILED, EV_UNKNOWN, 1 , "822220839"),  "Job '%job%' unknown - use 'job' to create it."  ) ;
    public static final ErrorId MsgDm_NoSuchKey           	= new ErrorId( ErrorOf( ES_DM, 643, E_FAILED, EV_UNKNOWN, 1 , "822221443"),  "No such key '%key%'."  ) ;
    public static final ErrorId MsgDm_NoSuchProperty          	= new ErrorId( ErrorOf( ES_DM, 734, E_FAILED, EV_UNKNOWN, 2 , "838998750"),  "No such property '%settingName%' sequence %settingSequence%."  ) ;
    public static final ErrorId MsgDm_NoSuchRelease           	= new ErrorId( ErrorOf( ES_DM, 537, E_FAILED, EV_USAGE, 1 , "822155801"),  "There was no Perforce release named '%release%'."  ) ;
    public static final ErrorId MsgDm_NoSuchResource          	= new ErrorId( ErrorOf( ES_DM, 629, E_FATAL, EV_FAULT, 2 , "1109465717"),  "Resource %objType%#%objName% was never locked!"  ) ;
    public static final ErrorId MsgDm_NoSuchServer            	= new ErrorId( ErrorOf( ES_DM, 664, E_FAILED, EV_UNKNOWN, 1 , "822221464"),  "Server '%server%' doesn't exist."  ) ;
    public static final ErrorId MsgDm_NoSuchServerlog         	= new ErrorId( ErrorOf( ES_DM, 714, E_FAILED, EV_UNKNOWN, 1 , "822221514"),  "No such logfile '%logfile%'."  ) ;
    public static final ErrorId MsgDm_NoUnloadedAutoLabel     	= new ErrorId( ErrorOf( ES_DM, 717, E_FAILED, EV_USAGE, 0 , "805378765"),  "An automatic label may not specify the autoreload option."  ) ;
    public static final ErrorId MsgDm_NotAsService            	= new ErrorId( ErrorOf( ES_DM, 571, E_FAILED, EV_CONFIG, 0 , "807672379"),  "Command not allowed for a service user."  ) ;
    public static final ErrorId MsgDm_NotBucket	       	= new ErrorId( ErrorOf( ES_DM, 558, E_FAILED, EV_USAGE, 1 , "822155822"),  "%depot% is not an archive depot."  ) ;
    public static final ErrorId MsgDm_NotClientOrLabel        	= new ErrorId( ErrorOf( ES_DM, 703, E_FAILED, EV_CONFIG, 2 , "841226943"),  "%domain% must be a %domainType%."  ) ;
    public static final ErrorId MsgDm_NotStreamReady            	= new ErrorId( ErrorOf( ES_DM, 557, E_FAILED, EV_USAGE, 1 , "822155821"),  "Client '%client%' requires an application that can fully support streams."  ) ;
    public static final ErrorId MsgDm_NotThatCounter          	= new ErrorId( ErrorOf( ES_DM, 31, E_FAILED, EV_USAGE, 1 , "822155295"),  "Too dangerous to touch counter '%counter%'."  ) ;
    public static final ErrorId MsgDm_NotUnderClient          	= new ErrorId( ErrorOf( ES_DB, 40, E_FAILED, EV_CONTEXT, 2 , "839061544"),  "Path '%path%' is not under client '%client%'."  ) ;
    public static final ErrorId MsgDm_NotUnderRoot            	= new ErrorId( ErrorOf( ES_DB, 39, E_FAILED, EV_CONTEXT, 2 , "839061543"),  "Path '%path%' is not under client's root '%root%'."  ) ;
    public static final ErrorId MsgDm_NotUnloaded             	= new ErrorId( ErrorOf( ES_DM, 704, E_FAILED, EV_CONFIG, 1 , "824449728"),  "%domain% does not require reloading."  ) ;
    public static final ErrorId MsgDm_OpenAlready             	= new ErrorId( ErrorOf( ES_DM, 284, E_INFO, 0, 2 , "301996316"),  "%depotFile% - can't %action% (already opened on this client)"  ) ;
    public static final ErrorId MsgDm_OpenBadAction           	= new ErrorId( ErrorOf( ES_DM, 287, E_INFO, 0, 3 , "318773535"),  "%depotFile% - can't %action% (already opened for %badAction%)"  ) ;
    public static final ErrorId MsgDm_OpenBadChange           	= new ErrorId( ErrorOf( ES_DM, 290, E_INFO, 0, 2 , "301996322"),  "%depotFile% - can't change from %change% - use 'reopen'"  ) ;
    public static final ErrorId MsgDm_OpenBadClient           	= new ErrorId( ErrorOf( ES_DM, 288, E_INFO, 0, 2 , "301996320"),  "%depotFile% - is already opened by client %client%"  ) ;
    public static final ErrorId MsgDm_OpenBadType             	= new ErrorId( ErrorOf( ES_DM, 291, E_INFO, 0, 2 , "301996323"),  "%depotFile% - can't change from %type% - use 'reopen'"  ) ;
    public static final ErrorId MsgDm_OpenBadUser             	= new ErrorId( ErrorOf( ES_DM, 289, E_INFO, 0, 2 , "301996321"),  "%depotFile% - is already opened by user %user%"  ) ;
    public static final ErrorId MsgDm_OpenCantDeleted         	= new ErrorId( ErrorOf( ES_DM, 295, E_INFO, 0, 2 , "301996327"),  "%depotFile% - can't %action% deleted file"  ) ;
    public static final ErrorId MsgDm_OpenCantExists          	= new ErrorId( ErrorOf( ES_DM, 294, E_INFO, 0, 2 , "301996326"),  "%depotFile% - can't %action% existing file"  ) ;
    public static final ErrorId MsgDm_OpenFilesCantChange     	= new ErrorId( ErrorOf( ES_DM, 473, E_FAILED, EV_ILLEGAL, 0 , "805575129"),  "Change has files open, client cannot be modified."  ) ;
    public static final ErrorId MsgDm_OpenFilesCantChangeUser 	= new ErrorId( ErrorOf( ES_DM, 509, E_FAILED, EV_ILLEGAL, 0 , "805575165"),  "Change has files open, user cannot be modified."  ) ;
    public static final ErrorId MsgDm_OpenIsLocked            	= new ErrorId( ErrorOf( ES_DM, 298, E_INFO, 1, 3 , "318839082"),  "%depotFile% - locked by %user%@%client%"  ) ;
    public static final ErrorId MsgDm_OpenIsOpened            	= new ErrorId( ErrorOf( ES_DM, 299, E_INFO, 1, 3 , "318839083"),  "%depotFile% - also opened by %user%@%client%"  ) ;
    public static final ErrorId MsgDm_OpenMustResolve         	= new ErrorId( ErrorOf( ES_DM, 297, E_INFO, 1, 2 , "302061865"),  "%depotFile% - must sync/resolve %workRev% before submitting"  ) ;
    public static final ErrorId MsgDm_OpenOtherDepot          	= new ErrorId( ErrorOf( ES_DM, 724, E_FAILED, 0, 3 , "855644884"),  "%clientFile% - can't open %depotFile% (already opened as %depotFile2%)"  ) ;
    public static final ErrorId MsgDm_OpenReOpen              	= new ErrorId( ErrorOf( ES_DM, 292, E_INFO, 0, 3 , "318773540"),  "%depotFile%%workRev% - reopened for %action%"  ) ;
    public static final ErrorId MsgDm_OpenReadOnly            	= new ErrorId( ErrorOf( ES_DM, 285, E_INFO, 0, 2 , "301996317"),  "%depotFile% - can only %action% file in a local depot"  ) ;
    public static final ErrorId MsgDm_OpenSuccess             	= new ErrorId( ErrorOf( ES_DM, 296, E_INFO, 0, 3 , "318773544"),  "%depotFile%%workRev% - opened for %action%"  ) ;
    public static final ErrorId MsgDm_OpenUpToDate            	= new ErrorId( ErrorOf( ES_DM, 293, E_INFO, 0, 3 , "318773541"),  "%depotFile%%workRev% - currently opened for %action%"  ) ;
    public static final ErrorId MsgDm_OpenWarnDeleted         	= new ErrorId( ErrorOf( ES_DM, 301, E_INFO, 1, 2 , "302061869"),  "%depotFile% - warning: %action% of deleted file"  ) ;
    public static final ErrorId MsgDm_OpenWarnExists          	= new ErrorId( ErrorOf( ES_DM, 300, E_INFO, 1, 2 , "302061868"),  "%depotFile% - warning: %action% of existing file"  ) ;
    public static final ErrorId MsgDm_OpenWarnFileNotMapped   	= new ErrorId( ErrorOf( ES_DM, 570, E_INFO, 1, 2 , "302062138"),  "%depotFile% - warning: file not mapped in stream %stream% client"  ) ;
    public static final ErrorId MsgDm_OpenWarnMoved           	= new ErrorId( ErrorOf( ES_DM, 493, E_INFO, 1, 2 , "302062061"),  "%depotFile% - warning: %action% of moved file"  ) ;
    public static final ErrorId MsgDm_OpenWarnOpenNotStream   	= new ErrorId( ErrorOf( ES_DM, 554, E_INFO, 1, 2 , "302062122"),  "%depotFile% - warning: cannot submit from stream %stream% client"  ) ;
    public static final ErrorId MsgDm_OpenWarnOpenStream      	= new ErrorId( ErrorOf( ES_DM, 553, E_INFO, 1, 1 , "285284905"),  "%depotFile% - warning: cannot submit from non-stream client"  ) ;
    public static final ErrorId MsgDm_OpenWarnPurged          	= new ErrorId( ErrorOf( ES_DM, 405, E_INFO, 1, 2 , "302061973"),  "%depotFile% - warning: %action% of purged file"  ) ;
    public static final ErrorId MsgDm_OpenXOpened             	= new ErrorId( ErrorOf( ES_DM, 286, E_INFO, 0, 2 , "301996318"),  "%depotFile% - can't %action% exclusive file already opened"  ) ;
    public static final ErrorId MsgDm_OpenedData              	= new ErrorId( ErrorOf( ES_DM, 302, E_INFO, 0, 5 , "352327982"),  "%depotFile%%workRev% - %action% %change% (%type%)"  ) ;
    public static final ErrorId MsgDm_OpenedDataS             	= new ErrorId( ErrorOf( ES_DM, 644, E_INFO, 0, 3 , "318773892"),  "%depotFile% - %action% %change%"  ) ;
    public static final ErrorId MsgDm_OpenedDelete            	= new ErrorId( ErrorOf( ES_DM, 71, E_FAILED, EV_NOTYET, 1 , "822417479"),  "Client '%client%' has files opened. To delete the client, revert any opened files and delete any pending changes first. An administrator may specify -f to force the delete of another user's client."  ) ;
    public static final ErrorId MsgDm_OpenedLocked            	= new ErrorId( ErrorOf( ES_DM, 304, E_INFO, 0, 5 , "352327984"),  "%depotFile%%workRev% - %action% %change% (%type%) *locked*"  ) ;
    public static final ErrorId MsgDm_OpenedLockedS           	= new ErrorId( ErrorOf( ES_DM, 646, E_INFO, 0, 3 , "318773894"),  "%depotFile% - %action% %change% *locked*"  ) ;
    public static final ErrorId MsgDm_OpenedOther             	= new ErrorId( ErrorOf( ES_DM, 303, E_INFO, 0, 7 , "385882415"),  "%depotFile%%workRev% - %action% %change% (%type%) by %user%@%client%"  ) ;
    public static final ErrorId MsgDm_OpenedOtherLocked       	= new ErrorId( ErrorOf( ES_DM, 305, E_INFO, 0, 7 , "385882417"),  "%depotFile%%workRev% - %action% %change% (%type%) by %user%@%client% *locked*"  ) ;
    public static final ErrorId MsgDm_OpenedOtherLockedS      	= new ErrorId( ErrorOf( ES_DM, 647, E_INFO, 0, 5 , "352328327"),  "%depotFile% - %action% %change% by %user%@%client% *locked*"  ) ;
    public static final ErrorId MsgDm_OpenedOtherS            	= new ErrorId( ErrorOf( ES_DM, 645, E_INFO, 0, 5 , "352328325"),  "%depotFile% - %action% %change% by %user%@%client%"  ) ;
    public static final ErrorId MsgDm_OpenedSwitch            	= new ErrorId( ErrorOf( ES_DM, 607, E_FAILED, EV_NOTYET, 1 , "822418015"),  "Client '%client%' has files opened; use -f to force switch."  ) ;
    public static final ErrorId MsgDm_OpenedTaskSwitch        	= new ErrorId( ErrorOf( ES_DM, 743, E_FAILED, EV_NOTYET, 1 , "822418151"),  "Client '%client%' has files opened from a task stream; must revert, or revert -k before switching."  ) ;
    public static final ErrorId MsgDm_OpenedXData             	= new ErrorId( ErrorOf( ES_DM, 635, E_INFO, 0, 5 , "352328315"),  "%depotFile%%workRev% - %action% %change% (%type%) *exclusive*"  ) ;
    public static final ErrorId MsgDm_OpenedXDataS            	= new ErrorId( ErrorOf( ES_DM, 648, E_INFO, 0, 3 , "318773896"),  "%depotFile% - %action% %change% *exclusive*"  ) ;
    public static final ErrorId MsgDm_OpenedXOther            	= new ErrorId( ErrorOf( ES_DM, 636, E_INFO, 0, 7 , "385882748"),  "%depotFile%%workRev% - %action% %change% (%type%) by %user%@%client% *exclusive*"  ) ;
    public static final ErrorId MsgDm_OpenedXOtherS           	= new ErrorId( ErrorOf( ES_DM, 649, E_INFO, 0, 5 , "352328329"),  "%depotFile% - %action% %change% by %user%@%client% *exclusive*"  ) ;
    public static final ErrorId MsgDm_OperatorNotAllowed      	= new ErrorId( ErrorOf( ES_DM, 632, E_FAILED, EV_PROTECT, 2 , "839260792"),  "Operator user %userName% may not perform operation %funcName%"  ) ;
    public static final ErrorId MsgDm_OutOfSequence           	= new ErrorId( ErrorOf( ES_DM, 483, E_FATAL, EV_FAULT, 2 , "1109465571"),  "Sequence error:  local 'change' counter '%local%' vs remote '%remote%'!"  ) ;
    public static final ErrorId MsgDm_OwnerCantChange	       	= new ErrorId( ErrorOf( ES_DM, 467, E_FAILED, EV_ILLEGAL, 0 , "805575123"),  "Client, user, date and status cannot be changed."  ) ;
    public static final ErrorId MsgDm_Passwd982               	= new ErrorId( ErrorOf( ES_DM, 85, E_FAILED, EV_UPGRADE, 0 , "807737429"),  "You need a 98.2 or newer client to set a password."  ) ;
    public static final ErrorId MsgDm_PastUpgrade             	= new ErrorId( ErrorOf( ES_DM, 23, E_FAILED, EV_ADMIN, 2 , "841160727"),  "Database is at upgrade level %level% past this server's level %level2%."  ) ;
    public static final ErrorId MsgDm_PathNotUnder            	= new ErrorId( ErrorOf( ES_DM, 42, E_FAILED, EV_CONTEXT, 2 , "839063594"),  "Path '%depotFile%' is not under '%prefix%'."  ) ;
    public static final ErrorId MsgDm_PendingDelete           	= new ErrorId( ErrorOf( ES_DM, 447, E_FAILED, EV_NOTYET, 1 , "822417855"),  "Client '%client%' has pending changes. To delete the client, delete any pending changes first. An administrator may specify -f to force the delete of another user's client."  ) ;
    public static final ErrorId MsgDm_PendingNoPerm	       	= new ErrorId( ErrorOf( ES_DM, 574, E_FAILED, EV_USAGE, 2 , "838933054"),  "%change% can only be updated by user %user%, or by admin user with -f."  ) ;
    public static final ErrorId MsgDm_PopulateDesc            	= new ErrorId( ErrorOf( ES_DM, 679, E_INFO, 0, 2 , "301996711"),  "Populate %target%[ from %source%]."  ) ;
    public static final ErrorId MsgDm_PopulateInvalidStream   	= new ErrorId( ErrorOf( ES_DM, 727, E_FAILED, EV_ILLEGAL, 1 , "822352599"),  "Can't update stream target with '%depotFile%'"  ) ;
    public static final ErrorId MsgDm_PopulateMultipleStreams 	= new ErrorId( ErrorOf( ES_DM, 728, E_FAILED, EV_ILLEGAL, 0 , "805575384"),  "Can't update multiple streams with single command." ) ;
    public static final ErrorId MsgDm_PopulateTargetExists    	= new ErrorId( ErrorOf( ES_DM, 678, E_FAILED, EV_ILLEGAL, 0 , "805575334"),  "Can't populate target path when files already exist."  ) ;
    public static final ErrorId MsgDm_PopulateTargetMixed     	= new ErrorId( ErrorOf( ES_DM, 726, E_FAILED, EV_ILLEGAL, 0 , "805575382"),  "Can't update target with mixed stream/non-stream paths."  ) ;
    public static final ErrorId MsgDm_PosWild                  	= new ErrorId( ErrorOf( ES_DM, 515, E_FAILED, EV_USAGE, 1 , "822155779"),  "Positional wildcards (%%%%x) not allowed in path: '%path%'."  ) ;
    public static final ErrorId MsgDm_PropertyData            	= new ErrorId( ErrorOf( ES_DM, 731, E_INFO, 0, 2 , "301996763"),  "%settingName% = %settingNalue%"  ) ;
    public static final ErrorId MsgDm_PropertyDataGroup       	= new ErrorId( ErrorOf( ES_DM, 733, E_INFO, 0, 3 , "318773981"),  "%settingName% = %settingNalue% (group %groupName%)"  ) ;
    public static final ErrorId MsgDm_PropertyDataUser        	= new ErrorId( ErrorOf( ES_DM, 732, E_INFO, 0, 3 , "318773980"),  "%settingName% = %settingNalue% (user %userName%)"  ) ;
    public static final ErrorId MsgDm_ProtectNoChange         	= new ErrorId( ErrorOf( ES_DM, 307, E_INFO, 0, 0 , "268441907"),  "Protections not changed."  ) ;
    public static final ErrorId MsgDm_ProtectSave             	= new ErrorId( ErrorOf( ES_DM, 306, E_INFO, 0, 0 , "268441906"),  "Protections saved."  ) ;
    public static final ErrorId MsgDm_ProtectedCodes          	= new ErrorId( ErrorOf( ES_DM, 411, E_FAILED, EV_USAGE, 1 , "822155675"),  "Builtin field %code% cannot be changed."  ) ;
    public static final ErrorId MsgDm_ProtectsData            	= new ErrorId( ErrorOf( ES_DM, 440, E_INFO, 0, 7 , "385882552"),  "%perm% %isgroup% %user% %ipaddr% %mapFlag%%depotFile%"  ) ;
    public static final ErrorId MsgDm_ProtectsEmpty           	= new ErrorId( ErrorOf( ES_DM, 456, E_FAILED, EV_ADMIN, 0 , "807606728"),  "Protections table is empty."  ) ;
    public static final ErrorId MsgDm_ProtectsMaxData         	= new ErrorId( ErrorOf( ES_DM, 452, E_INFO, 0, 1 , "285219268"),  "%perm%"  ) ;
    public static final ErrorId MsgDm_ProtectsNoSuper         	= new ErrorId( ErrorOf( ES_DM, 469, E_FAILED, EV_ADMIN, 0 , "807606741"),  "Can't delete last valid 'super' entry from protections table."  ) ;
    public static final ErrorId MsgDm_PurgeCheck              	= new ErrorId( ErrorOf( ES_DM, 310, E_INFO, 0, 5 , "352327990"),  "Would delete [%onHave% client ][%onLabel% label ][%onInteg% integration ][%onWorking% opened ][%onRev% revision ][and add %synInteg% integration ]record(s)."  ) ;
    public static final ErrorId MsgDm_PurgeData               	= new ErrorId( ErrorOf( ES_DM, 312, E_INFO, 0, 2 , "301996344"),  "%depotFile%%depotRev% - purged"  ) ;
    public static final ErrorId MsgDm_PurgeDeleted            	= new ErrorId( ErrorOf( ES_DM, 309, E_INFO, 0, 5 , "352327989"),  "Deleted [%onHave% client ][%onLabel% label ][%onInteg% integration ][%onWorking% opened ][%onRev% revision ][and added %synInteg% integration ]record(s)."  ) ;
    public static final ErrorId MsgDm_PurgeFirst              	= new ErrorId( ErrorOf( ES_DM, 67, E_FAILED, EV_NOTYET, 1 , "822417475"),  "Depot %depot% isn't empty. To delete a depot, all file revisions must be removed and all lazy copy references from other depots must be severed. Use 'p4 obliterate' or 'p4 snap' to break file linkages from other depots, then clear this depot with 'p4 obliterate', then retry the deletion."  ) ;
    public static final ErrorId MsgDm_PurgeNoRecords          	= new ErrorId( ErrorOf( ES_DM, 311, E_INFO, 0, 0 , "268441911"),  "No records to delete."  ) ;
    public static final ErrorId MsgDm_PurgeSnapData           	= new ErrorId( ErrorOf( ES_DM, 308, E_INFO, 0, 4 , "335550772"),  "%depotFile%%depotRev% - copy from %lbrFile% %lbrRev%"  ) ;
    public static final ErrorId MsgDm_ReconcileBadName        	= new ErrorId( ErrorOf( ES_DM, 676, E_WARN, EV_ILLEGAL, 1 , "553917092"),  "%file% - can't reconcile filename with illegal characters."  ) ;
    public static final ErrorId MsgDm_ReconcileNeedForce      	= new ErrorId( ErrorOf( ES_DM, 677, E_WARN, EV_ILLEGAL, 1 , "553917093"),  "%file% - can't reconcile filename with wildcards [@#%*]. Use -f to force reconcile."  ) ;
    public static final ErrorId MsgDm_ReferClient             	= new ErrorId( ErrorOf( ES_DM, 100, E_FAILED, EV_UNKNOWN, 2 , "838998116"),  "%path% - must refer to client '%client%'."  ) ;
    public static final ErrorId MsgDm_ReleaseAbandon          	= new ErrorId( ErrorOf( ES_DM, 314, E_INFO, 0, 3 , "318773562"),  "%depotFile%%haveRev% - was %action%, abandoned"  ) ;
    public static final ErrorId MsgDm_ReleaseClear            	= new ErrorId( ErrorOf( ES_DM, 315, E_INFO, 0, 3 , "318773563"),  "%depotFile%%haveRev% - was %action%, cleared"  ) ;
    public static final ErrorId MsgDm_ReleaseDelete           	= new ErrorId( ErrorOf( ES_DM, 316, E_INFO, 0, 3 , "318773564"),  "%depotFile%%haveRev% - was %action%, deleted"  ) ;
    public static final ErrorId MsgDm_ReleaseHasMoved         	= new ErrorId( ErrorOf( ES_DM, 486, E_INFO, 0, 2 , "301996518"),  "%depotFile%%haveRev% - has been moved, not reverted"  ) ;
    public static final ErrorId MsgDm_ReleaseHasPending       	= new ErrorId( ErrorOf( ES_DM, 313, E_INFO, 0, 2 , "301996345"),  "%depotFile%%haveRev% - has pending integrations, not reverted"  ) ;
    public static final ErrorId MsgDm_ReleaseNotOwner         	= new ErrorId( ErrorOf( ES_DM, 443, E_INFO, 0, 3 , "318773691"),  "%depotFile%%haveRev% - belongs to user %user%, not reverted"  ) ;
    public static final ErrorId MsgDm_ReleaseRevert           	= new ErrorId( ErrorOf( ES_DM, 317, E_INFO, 0, 3 , "318773565"),  "%depotFile%%haveRev% - was %action%, reverted"  ) ;
    public static final ErrorId MsgDm_ReleaseUnlockAbandon    	= new ErrorId( ErrorOf( ES_DM, 318, E_INFO, 0, 3 , "318773566"),  "%depotFile%%haveRev% - was %action%, unlocked and abandoned"  ) ;
    public static final ErrorId MsgDm_ReleaseUnlockClear      	= new ErrorId( ErrorOf( ES_DM, 319, E_INFO, 0, 3 , "318773567"),  "%depotFile%%haveRev% - was %action%, unlocked and cleared"  ) ;
    public static final ErrorId MsgDm_ReleaseUnlockDelete     	= new ErrorId( ErrorOf( ES_DM, 320, E_INFO, 0, 3 , "318773568"),  "%depotFile%%haveRev% - was %action%, unlocked and deleted"  ) ;
    public static final ErrorId MsgDm_ReleaseUnlockRevert     	= new ErrorId( ErrorOf( ES_DM, 321, E_INFO, 0, 3 , "318773569"),  "%depotFile%%haveRev% - was %action%, unlocked and reverted"  ) ;
    public static final ErrorId MsgDm_ReloadData              	= new ErrorId( ErrorOf( ES_DM, 716, E_INFO, 0, 2 , "301996748"),  "%object% %name% reloaded."  ) ;
    public static final ErrorId MsgDm_ReloadFirst             	= new ErrorId( ErrorOf( ES_DM, 722, E_FAILED, EV_NOTYET, 1 , "822418130"),  "Unload depot %depot% isn't empty of unload files; reload any unloaded clients or labels with 'p4 reload' first. All labels with the 'autoreload' option set must be deleted prior to deleting the unload depot. Remove all non-Perforce files from the depot prior to depot deletion."  ) ;
    public static final ErrorId MsgDm_ReloadNotOwner          	= new ErrorId( ErrorOf( ES_DM, 709, E_FAILED, EV_USAGE, 0 , "805378757"),  "Unloaded client, label, or task stream %domainName% is not owned by you."  ) ;
    public static final ErrorId MsgDm_ReopenData              	= new ErrorId( ErrorOf( ES_DM, 322, E_INFO, 0, 5 , "352328002"),  "%depotFile%%workRev% - reopened[; user %user%][; type %type%][; %change%]"  ) ;
    public static final ErrorId MsgDm_ReopenDataNoChange      	= new ErrorId( ErrorOf( ES_DM, 323, E_INFO, 0, 5 , "352328003"),  "%depotFile%%workRev% - nothing changed[; user %user%][; type %type%][; %change%]"  ) ;
    public static final ErrorId MsgDm_Resolve2WayRaw          	= new ErrorId( ErrorOf( ES_DM, 325, E_INFO, 0, 3 , "318773573"),  "%localPath% - vs %fromFile%%fromRev%"  ) ;
    public static final ErrorId MsgDm_Resolve3WayRaw          	= new ErrorId( ErrorOf( ES_DM, 326, E_INFO, 0, 5 , "352328006"),  "%localPath% - %baseType%/%headType% merge %fromFile%%fromRev%[ using base %baseFile%][%baseRev%]"  ) ;
    public static final ErrorId MsgDm_Resolve3WayText         	= new ErrorId( ErrorOf( ES_DM, 327, E_INFO, 0, 3 , "318773575"),  "%localPath% - merging %fromFile%%fromRev%"  ) ;
    public static final ErrorId MsgDm_Resolve3WayTextBase     	= new ErrorId( ErrorOf( ES_DM, 425, E_INFO, 0, 3 , "318773673"),  "%localPath% - merging %fromFile%%fromRev% using base %baseFile%%baseRev%"  ) ;
    public static final ErrorId MsgDm_ResolveAction           	= new ErrorId( ErrorOf( ES_DM, 590, E_INFO, 0, 6 , "369105486"),  "%localPath% - resolving %resolveType% from %fromFile%%fromRev%[ using base %baseFile%][%baseRev%]"  ) ;
    public static final ErrorId MsgDm_ResolveActionMove       	= new ErrorId( ErrorOf( ES_DM, 622, E_INFO, 0, 3 , "318773870"),  "%localPath% - resolving move to %fromFile%[ using base %baseFile%]"  ) ;
    public static final ErrorId MsgDm_ResolveDelete           	= new ErrorId( ErrorOf( ES_DM, 324, E_INFO, 0, 1 , "285219140"),  "%localPath% - has been deleted - revert and sync."  ) ;
    public static final ErrorId MsgDm_ResolveDoBranch	       	= new ErrorId( ErrorOf( ES_DM, 594, E_INFO, 0, 0 , "268442194"),  "Branch resolve"  ) ;
    public static final ErrorId MsgDm_ResolveDoBranchActionT  	= new ErrorId( ErrorOf( ES_DM, 595, E_INFO, 0, 0 , "268442195"),  "branch"  ) ;
    public static final ErrorId MsgDm_ResolveDoBranchActionY  	= new ErrorId( ErrorOf( ES_DM, 596, E_INFO, 0, 0 , "268442196"),  "ignore"  ) ;
    public static final ErrorId MsgDm_ResolveDoDelete         	= new ErrorId( ErrorOf( ES_DM, 597, E_INFO, 0, 0 , "268442197"),  "Delete resolve"  ) ;
    public static final ErrorId MsgDm_ResolveDoDeleteActionT  	= new ErrorId( ErrorOf( ES_DM, 598, E_INFO, 0, 0 , "268442198"),  "delete"  ) ;
    public static final ErrorId MsgDm_ResolveDoDeleteActionY  	= new ErrorId( ErrorOf( ES_DM, 599, E_INFO, 0, 0 , "268442199"),  "ignore"  ) ;
    public static final ErrorId MsgDm_ResolveFiletype         	= new ErrorId( ErrorOf( ES_DM, 591, E_INFO, 0, 0 , "268442191"),  "Filetype resolve"  ) ;
    public static final ErrorId MsgDm_ResolveFiletypeAction   	= new ErrorId( ErrorOf( ES_DM, 592, E_INFO, 0, 1 , "285219408"),  "(%type%)"  ) ;
    public static final ErrorId MsgDm_ResolveMove             	= new ErrorId( ErrorOf( ES_DM, 600, E_INFO, 0, 0 , "268442200"),  "Filename resolve"  ) ;
    public static final ErrorId MsgDm_ResolveMoveAction       	= new ErrorId( ErrorOf( ES_DM, 601, E_INFO, 0, 1 , "285219417"),  "%depotPath%"  ) ;
    public static final ErrorId MsgDm_ResolveShelveDelete              	= new ErrorId( ErrorOf( ES_DM, 639, E_FAILED, EV_FAULT, 2 , "841030271"),  "%depotFile%%rev%: can't resolve (shelved file was deleted); must revert, or revert -k and edit before submit."  ) ;
    public static final ErrorId MsgDm_ResolveTrait            	= new ErrorId( ErrorOf( ES_DM, 666, E_INFO, 0, 0 , "268442266"),  "Attribute resolve"  ) ;
    public static final ErrorId MsgDm_ResolveTraitActionM     	= new ErrorId( ErrorOf( ES_DM, 669, E_INFO, 0, 1 , "285219485"),  "merge their [%count% ]propagating attribute(s) with your set of attribute(s)"  ) ;
    public static final ErrorId MsgDm_ResolveTraitActionT     	= new ErrorId( ErrorOf( ES_DM, 667, E_INFO, 0, 1 , "285219483"),  "overwrite your open attributes with their set of [%count% ]attribute(s)"  ) ;
    public static final ErrorId MsgDm_ResolveTraitActionY     	= new ErrorId( ErrorOf( ES_DM, 668, E_INFO, 0, 1 , "285219484"),  "leave your set of [%count% ]open attribute(s) unchanged"  ) ;
    public static final ErrorId MsgDm_ResolvedAction          	= new ErrorId( ErrorOf( ES_DM, 593, E_INFO, 0, 6 , "369105489"),  "%localPath% - resolved %resolveType% from %fromFile%%fromRev%[ using base %baseFile%][%baseRev%]"  ) ;
    public static final ErrorId MsgDm_ResolvedActionMove      	= new ErrorId( ErrorOf( ES_DM, 623, E_INFO, 0, 3 , "318773871"),  "%localPath% - resolved move (%how% %fromFile%)[ using base %baseFile%]"  ) ;
    public static final ErrorId MsgDm_ResolvedData            	= new ErrorId( ErrorOf( ES_DM, 328, E_INFO, 0, 4 , "335550792"),  "%localPath% - %how% %fromFile%%fromRev%"  ) ;
    public static final ErrorId MsgDm_ResolvedDataBase        	= new ErrorId( ErrorOf( ES_DM, 428, E_INFO, 0, 4 , "335550892"),  "%localPath% - %how% %fromFile%%fromRev% base %baseFile%%baseRev%"  ) ;
    public static final ErrorId MsgDm_ResourceAlreadyLocked   	= new ErrorId( ErrorOf( ES_DM, 628, E_FATAL, EV_FAULT, 2 , "1109465716"),  "Resource %objType%#%objName% is already locked!"  ) ;
    public static final ErrorId MsgDm_RetypeData              	= new ErrorId( ErrorOf( ES_DM, 459, E_INFO, 0, 4 , "335550923"),  "%depotFile%%depotRev% - %oldType% now %newType%"  ) ;
    public static final ErrorId MsgDm_RevVsRevCx              	= new ErrorId( ErrorOf( ES_DM, 47, E_FATAL, EV_FAULT, 0 , "1075910703"),  "Revision table out of sync with index!"  ) ;
    public static final ErrorId MsgDm_ReviewData              	= new ErrorId( ErrorOf( ES_DM, 329, E_INFO, 0, 4 , "335550793"),  "%change% %user% <%email%> (%fullName%)"  ) ;
    public static final ErrorId MsgDm_ReviewsData             	= new ErrorId( ErrorOf( ES_DM, 330, E_INFO, 0, 3 , "318773578"),  "%user% <%email%> (%fullname%)"  ) ;
    public static final ErrorId MsgDm_RmtAuthFailed           	= new ErrorId( ErrorOf( ES_DM, 124, E_FAILED, EV_FAULT, 0 , "807475324"),  "Remote authorization server access failed."  ) ;
    public static final ErrorId MsgDm_RmtError                	= new ErrorId( ErrorOf( ES_DM, 107, E_FAILED, EV_FAULT, 1 , "824252523"),  "%text%"  ) ;
    public static final ErrorId MsgDm_RmtSequenceFailed       	= new ErrorId( ErrorOf( ES_DM, 482, E_FATAL, EV_FAULT, 1 , "1092688354"),  "Remote '%counter%' counter update failed."  ) ;
    public static final ErrorId MsgDm_SameCode                	= new ErrorId( ErrorOf( ES_DM, 116, E_FAILED, EV_USAGE, 2 , "838932596"),  "Fields '%field%' and '%field2%' have the same code."  ) ;
    public static final ErrorId MsgDm_SameTag                 	= new ErrorId( ErrorOf( ES_DM, 413, E_FAILED, EV_USAGE, 2 , "838932893"),  "Fields '%field%' and '%field2%' have the same tag."  ) ;
    public static final ErrorId MsgDm_SemiInDefault           	= new ErrorId( ErrorOf( ES_DM, 118, E_FAILED, EV_USAGE, 1 , "822155382"),  "Default for '%field%' can't have ;'s in it."  ) ;
    public static final ErrorId MsgDm_ServerDelete            	= new ErrorId( ErrorOf( ES_DM, 663, E_INFO, 0, 1 , "285219479"),  "Server %serverName% deleted."  ) ;
    public static final ErrorId MsgDm_ServerNoChange          	= new ErrorId( ErrorOf( ES_DM, 662, E_INFO, 0, 1 , "285219478"),  "Server %serverName% not changed."  ) ;
    public static final ErrorId MsgDm_ServerSave              	= new ErrorId( ErrorOf( ES_DM, 661, E_INFO, 0, 1 , "285219477"),  "Server %serverName% saved."  ) ;
    public static final ErrorId MsgDm_ServerTypeMismatch      	= new ErrorId( ErrorOf( ES_DM, 719, E_FAILED, EV_CONTEXT, 0 , "805509839"),  "Server type is not appropriate for specified server services."  ) ;
    public static final ErrorId MsgDm_ServerViewMap           	= new ErrorId( ErrorOf( ES_DM, 745, E_FAILED, EV_CONTEXT, 0 , "805509865"),  "This type of view mapping may not be provided for this server."  ) ;
    public static final ErrorId MsgDm_ServersData             	= new ErrorId( ErrorOf( ES_DM, 665, E_INFO, 0, 6 , "369105561"),  "%serverID% %type% %name% %address% %services% '%description%'"  ) ;
    public static final ErrorId MsgDm_ServiceNotProvided      	= new ErrorId( ErrorOf( ES_DM, 671, E_FAILED, EV_USAGE, 0 , "805378719"),  "Server does not provide this service."  ) ;
    public static final ErrorId MsgDm_ServiceUserLogin        	= new ErrorId( ErrorOf( ES_DM, 720, E_FAILED, EV_FAULT, 0 , "807475920"),  "Remote server refused request. Please verify that service user is correctly logged in to remote server, then retry."  ) ;
    public static final ErrorId MsgDm_ShelveCantUpdate        	= new ErrorId( ErrorOf( ES_DM, 512, E_FAILED, EV_USAGE , 1 , "822155776"),  "%depotFile% - already shelved, use -f to update."  ) ;
    public static final ErrorId MsgDm_ShelveIncompatible         	= new ErrorId( ErrorOf( ES_DM, 522, E_FAILED, EV_USAGE, 1 , "822155786"),  "%depotFile% - can't overwrite a shelved moved file, use -r to replace."  ) ;
    public static final ErrorId MsgDm_ShelveLocked             	= new ErrorId( ErrorOf( ES_DM, 518, E_INFO, 0, 1 , "285219334"),  "%depotFile% - shelved file locked, try again later."  ) ;
    public static final ErrorId MsgDm_ShelveMaxFiles          	= new ErrorId( ErrorOf( ES_DM, 523, E_FAILED, EV_USAGE, 1 , "822155787"),  "Shelve file limit exceeded (over %maxFiles%)."  ) ;
    public static final ErrorId MsgDm_ShelveNeedsResolve          	= new ErrorId( ErrorOf( ES_DM, 620, E_FAILED, 0, 3 , "855644780"),  "%depotFile% - must resolve %file%%srev% before shelving"  ) ;
    public static final ErrorId MsgDm_ShelveNoPerm          	= new ErrorId( ErrorOf( ES_DM, 541, E_INFO, 0, 1 , "285219357"),  "%depotFile% - no permission to shelve file"  ) ;
    public static final ErrorId MsgDm_ShelveOpenResolves          	= new ErrorId( ErrorOf( ES_DM, 633, E_FAILED, 0, 3 , "855644793"),  "%depotFile% - unshelved file for %user%@%client% needs resolve"  ) ;
    public static final ErrorId MsgDm_ShelveUnlocked             	= new ErrorId( ErrorOf( ES_DM, 519, E_INFO, 0, 1 , "285219335"),  "%depotFile% - shelved file unlocked, try again later."  ) ;
    public static final ErrorId MsgDm_ShelvedDelete            	= new ErrorId( ErrorOf( ES_DM, 524, E_FAILED, EV_NOTYET, 1 , "822417932"),  "Client '%client%' has files shelved; use 'shelve -df' to remove them, and then try again."  ) ;
    public static final ErrorId MsgDm_ShelvedHasWorking           	= new ErrorId( ErrorOf( ES_DM, 742, E_INFO, 0, 1 , "285219558"),  "%depotFile% - cannot submit while open in shelved change"  ) ;
    public static final ErrorId MsgDm_SnapFirst               	= new ErrorId( ErrorOf( ES_DM, 619, E_FAILED, EV_NOTYET, 1 , "822418027"),  "Depot %depot% isn't empty of archive contents. One or more files are still present in the depot directory. Other depots may have branched or integrated from files in this depot. Break those linkages with 'p4 snap' and/or remove references from other depots with 'p4 obliterate' first. Next, remove all non-Perforce files from the depot prior to depot deletion. Once all references have been removed, either remove any remaining physical files and directories from the depot directory and retry the operation, or specify '-f' to bypass this check and delete the depot."  ) ;
    public static final ErrorId MsgDm_SpecDeleted             	= new ErrorId( ErrorOf( ES_DM, 416, E_INFO, 0, 1 , "285219232"),  "Spec %type% deleted."  ) ;
    public static final ErrorId MsgDm_SpecNoChange            	= new ErrorId( ErrorOf( ES_DM, 415, E_INFO, 0, 1 , "285219231"),  "Spec %type% not changed."  ) ;
    public static final ErrorId MsgDm_SpecNotDefined          	= new ErrorId( ErrorOf( ES_DM, 417, E_FAILED, EV_UNKNOWN, 1 , "822221217"),  "Spec %type% not defined."  ) ;
    public static final ErrorId MsgDm_SpecSave                	= new ErrorId( ErrorOf( ES_DM, 414, E_INFO, 0, 1 , "285219230"),  "Spec %type% saved."  ) ;
    public static final ErrorId MsgDm_StatusSuccess             	= new ErrorId( ErrorOf( ES_DM, 684, E_INFO, 0, 4 , "335551148"),  "%localfile% - reconcile to %action% %depotFile%%workRev%"  ) ;
    public static final ErrorId MsgDm_StreamBadConvert          	= new ErrorId( ErrorOf( ES_DM, 740, E_FAILED, EV_USAGE, 1, "822156004"),  "Cannot convert 'task' stream to '%type%' - parent from different depot."  ) ;
    public static final ErrorId MsgDm_StreamConverted           	= new ErrorId( ErrorOf( ES_DM, 738, E_INFO, 0, 2, "301996770"),  "Stream '%name%' converted from 'task' to '%type%'."  ) ;
    public static final ErrorId MsgDm_StreamDepthErr      	= new ErrorId( ErrorOf( ES_DM, 504, E_FAILED, 0, 1, "822090232"),  "Stream '%stream%' must reside in first folder below depot level."  ) ;
    public static final ErrorId MsgDm_StreamDoubleSlash   	= new ErrorId( ErrorOf( ES_DM, 502, E_FAILED, 0, 1, "822090230"),  "Stream '%stream%' contains embedded double slashes (//)."  ) ;
    public static final ErrorId MsgDm_StreamEndSlash      	= new ErrorId( ErrorOf( ES_DM, 505, E_FAILED, 0, 1, "822090233"),  "Trailing slash not allowed in '%id%'."  ) ;
    public static final ErrorId MsgDm_StreamEqDepot       	= new ErrorId( ErrorOf( ES_DM, 503, E_FAILED, 0, 1, "822090231"),  "Stream '%stream%' must be below depot level."  ) ;
    public static final ErrorId MsgDm_StreamHasChildren        	= new ErrorId( ErrorOf( ES_DM, 580, E_FAILED, EV_NOTYET, 1 , "822417988"),  "Stream '%stream%' has child streams; cannot delete until they are removed."  ) ;
    public static final ErrorId MsgDm_StreamHasClients         	= new ErrorId( ErrorOf( ES_DM, 581, E_FAILED, EV_NOTYET, 1 , "822417989"),  "Stream '%stream%' has active clients; cannot delete until they are removed."  ) ;
    public static final ErrorId MsgDm_StreamIncompatibleC      	= new ErrorId( ErrorOf( ES_DM, 584, E_FAILED, EV_CONTEXT, 3 , "855841352"),  "Stream '%stream%' (%oldType% -> %type%) not compatible with child streams; use -u to force update."  ) ;
    public static final ErrorId MsgDm_StreamIncompatibleP      	= new ErrorId( ErrorOf( ES_DM, 583, E_FAILED, EV_CONTEXT, 4 , "872618567"),  "Stream '%stream%' (%type%) not compatible with Parent %parent% (%parentType%); use -u to force update."  ) ;
    public static final ErrorId MsgDm_StreamIsMainline            	= new ErrorId( ErrorOf( ES_DM, 630, E_FAILED, EV_USAGE, 1 , "822155894"),  "Stream '%name%' has no parent, therefore (command not allowed)."  ) ;
    public static final ErrorId MsgDm_StreamIsUnloaded        	= new ErrorId( ErrorOf( ES_DM, 748, E_FAILED, EV_CONFIG, 2 , "841226988"),  "Client %client% cannot be used with unloaded stream %stream%, switch to another stream or reload it."  ) ;
    public static final ErrorId MsgDm_StreamIsVirtual            	= new ErrorId( ErrorOf( ES_DM, 681, E_FAILED, EV_USAGE, 1 , "822155945"),  "Stream '%name%' is a virtual stream (command not allowed)."  ) ;
    public static final ErrorId MsgDm_StreamNeedForce           	= new ErrorId( ErrorOf( ES_DM, 737, E_FAILED, EV_USAGE, 1, "822156001"),  "Converting from 'task' stream to '%type%' requires '-f' force option."  ) ;
    public static final ErrorId MsgDm_StreamNested        	= new ErrorId( ErrorOf( ES_DM, 501, E_FAILED, 0, 2, "838867445"),  "Streams cannot be nested. '%stream%' contains existing stream '%nested%'."  ) ;
    public static final ErrorId MsgDm_StreamNoConvert           	= new ErrorId( ErrorOf( ES_DM, 736, E_FAILED, EV_USAGE, 1, "822156000"),  "Cannot convert '%type%' stream to 'task' stream."  ) ;
    public static final ErrorId MsgDm_StreamNoFlow		= new ErrorId( ErrorOf( ES_DM, 680, E_FAILED, EV_CONTEXT, 1 , "822287016"),  "Stream '%stream%' type of virtual cannot have 'toparent' or 'fromparent' options set."  ) ;
    public static final ErrorId MsgDm_StreamNoReparent          	= new ErrorId( ErrorOf( ES_DM, 729, E_FAILED, 0, 2, "838867673"),  "Cannot change Parent '%parent%' in %type% stream '%stream%'."   ) ;
    public static final ErrorId MsgDm_StreamNotOwner     	= new ErrorId( ErrorOf( ES_DM, 497, E_FAILED, 0, 2, "838867441"),  "Stream '%stream%' is owned by '%owner%'."  ) ;
    public static final ErrorId MsgDm_StreamOverflow            	= new ErrorId( ErrorOf( ES_DM, 549, E_FAILED, EV_USAGE, 0 , "805378597"),  "Stream hierarchy in endless loop!"  ) ;
    public static final ErrorId MsgDm_StreamOwnerReq     	= new ErrorId( ErrorOf( ES_DM, 582, E_FAILED, 0, 1, "822090310"),  "Owner field of Stream '%stream%' required."  ) ;
    public static final ErrorId MsgDm_StreamOwnerUpdate           	= new ErrorId( ErrorOf( ES_DM, 586, E_FAILED, 0, 2, "838867530"),  "Stream '%stream%' owner '%owner%' required for -u force update."   ) ;
    public static final ErrorId MsgDm_StreamParentIsTask        	= new ErrorId( ErrorOf( ES_DM, 739, E_FAILED, EV_USAGE, 1, "822156003"),  "Parent stream '%name%' is a task stream, child streams not allowed."  ) ;
    public static final ErrorId MsgDm_StreamPathRooted          	= new ErrorId( ErrorOf( ES_DM, 578, E_FAILED, 0, 1, "822090306"),  "View '%view%' must be relative and not contain leading slashes "   ) ;
    public static final ErrorId MsgDm_StreamPathSlash           	= new ErrorId( ErrorOf( ES_DM, 579, E_FAILED, 0, 1, "822090307"),  "Imported path '%view%' requires leading slashes in full depot path "   ) ;
    public static final ErrorId MsgDm_StreamRootErr      	= new ErrorId( ErrorOf( ES_DM, 499, E_FAILED, 0, 1, "822090227"),  "Stream '%stream%' must begin with '//'."  ) ;
    public static final ErrorId MsgDm_StreamVsDomains          	= new ErrorId( ErrorOf( ES_DM, 506, E_FATAL, EV_FAULT, 0 , "1075911162"),  "Stream and domains table out of sync!"  ) ;
    public static final ErrorId MsgDm_StreamsData 	  	= new ErrorId( ErrorOf( ES_DM, 498, E_INFO, 0, 5 , "352328178"),  "Stream %stream% %type% %parent% '%title%'[ %status%]"  ) ;
    public static final ErrorId MsgDm_SubmitChanges           	= new ErrorId( ErrorOf( ES_DM, 339, E_INFO, 0, 2 , "301996371"),  "Use 'p4 submit -c %change%' to submit file(s) in pending %newChange%."  ) ;
    public static final ErrorId MsgDm_SubmitMovedToDefault    	= new ErrorId( ErrorOf( ES_DM, 445, E_INFO, 0, 2 , "301996477"),  "%depotFile%%depotRev% - unchanged, moved to default changelist"  ) ;
    public static final ErrorId MsgDm_SubmitMustResolve       	= new ErrorId( ErrorOf( ES_DM, 334, E_INFO, 0, 1 , "285219150"),  "%depotFile% - must resolve before submitting"  ) ;
    public static final ErrorId MsgDm_SubmitNewResolve        	= new ErrorId( ErrorOf( ES_DM, 338, E_INFO, 0, 2 , "301996370"),  "%fromFile% - must resolve %fromRev%"  ) ;
    public static final ErrorId MsgDm_SubmitRefresh           	= new ErrorId( ErrorOf( ES_DM, 336, E_INFO, 0, 2 , "301996368"),  "%depotFile%%depotRev% - refreshing"  ) ;
    public static final ErrorId MsgDm_SubmitResolve           	= new ErrorId( ErrorOf( ES_DM, 337, E_INFO, 0, 3 , "318773585"),  "%toFile% - must resolve %fromFile%%fromRev%"  ) ;
    public static final ErrorId MsgDm_SubmitReverted          	= new ErrorId( ErrorOf( ES_DM, 444, E_INFO, 0, 2 , "301996476"),  "%depotFile%%depotRev% - unchanged, reverted"  ) ;
    public static final ErrorId MsgDm_SubmitTransfer          	= new ErrorId( ErrorOf( ES_DM, 335, E_INFO, 0, 3 , "318773583"),  "%action% %depotFile%%depotRev%"  ) ;
    public static final ErrorId MsgDm_SubmitUpToDate          	= new ErrorId( ErrorOf( ES_DM, 331, E_INFO, 0, 2 , "301996363"),  "%depotFile% - opened at head rev %workRev%"  ) ;
    public static final ErrorId MsgDm_SubmitWasAdd            	= new ErrorId( ErrorOf( ES_DM, 332, E_INFO, 0, 2 , "301996364"),  "%depotFile% - %action% of added file; must revert"  ) ;
    public static final ErrorId MsgDm_SubmitWasDelete         	= new ErrorId( ErrorOf( ES_DM, 333, E_INFO, 0, 2 , "301996365"),  "%depotFile% - %action% of deleted file; must revert"  ) ;
    public static final ErrorId MsgDm_SubmitWasDeleteCanReadd 	= new ErrorId( ErrorOf( ES_DM, 539, E_INFO, 0, 2 , "301996571"),  "%depotFile% - %action% of deleted file; must sync & add -d or revert"  ) ;
    public static final ErrorId MsgDm_SyncAdd                 	= new ErrorId( ErrorOf( ES_DM, 340, E_INFO, 0, 3 , "318773588"),  "%depotFile%%depotRev% - added as %localPath%"  ) ;
    public static final ErrorId MsgDm_SyncCantDelete          	= new ErrorId( ErrorOf( ES_DM, 343, E_INFO, 0, 3 , "318773591"),  "%depotFile%%workRev% - is opened for %action% and can't be deleted"  ) ;
    public static final ErrorId MsgDm_SyncCantPublishIsOpen   	= new ErrorId( ErrorOf( ES_DM, 457, E_INFO, 0, 1 , "285219273"),  "%depotFile% - can't sync -p a file that's opened"  ) ;
    public static final ErrorId MsgDm_SyncCantPublishOnHave   	= new ErrorId( ErrorOf( ES_DM, 458, E_INFO, 0, 1 , "285219274"),  "%depotFile% - can't sync -p a file that's synced"  ) ;
    public static final ErrorId MsgDm_SyncCantReplace         	= new ErrorId( ErrorOf( ES_DM, 344, E_INFO, 0, 3 , "318773592"),  "%depotFile%%workRev% - is opened for %action% and can't be replaced"  ) ;
    public static final ErrorId MsgDm_SyncDelete              	= new ErrorId( ErrorOf( ES_DM, 341, E_INFO, 0, 3 , "318773589"),  "%depotFile%%haveRev% - deleted as %localPath%"  ) ;
    public static final ErrorId MsgDm_SyncIndexOutOfBounds    	= new ErrorId( ErrorOf( ES_DM, 606, E_FATAL, EV_FAULT, 2 , "1109465694"),  "Index out of range %index% of %total%"  ) ;
    public static final ErrorId MsgDm_SyncIntegBackwards      	= new ErrorId( ErrorOf( ES_DM, 349, E_INFO, 0, 2 , "301996381"),  "%depotFile%%workRev% - is opened at a later revision - not changed"  ) ;
    public static final ErrorId MsgDm_SyncIntegDelete         	= new ErrorId( ErrorOf( ES_DM, 348, E_INFO, 0, 3 , "318773596"),  "%depotFile%%workRev% - is opened for %action% - not changed"  ) ;
    public static final ErrorId MsgDm_SyncIntegUpdate         	= new ErrorId( ErrorOf( ES_DM, 347, E_INFO, 0, 2 , "301996379"),  "%depotFile%%workRev% - is opened and not being changed"  ) ;
    public static final ErrorId MsgDm_SyncMissingMoveSource   	= new ErrorId( ErrorOf( ES_DM, 492, E_INFO, 0, 2 , "301996524"),  "%depotFile% - can't sync moved file,  %fromFile% is missing from the rev table!"  ) ;
    public static final ErrorId MsgDm_SyncNotSafeAdd          	= new ErrorId( ErrorOf( ES_DM, 602, E_INFO, 0, 3 , "318773850"),  "%depotFile%%depotRev% - can't overwrite existing file %localPath%"  ) ;
    public static final ErrorId MsgDm_SyncNotSafeDelete       	= new ErrorId( ErrorOf( ES_DM, 603, E_INFO, 0, 3 , "318773851"),  "%depotFile%%depotRev% - can't delete modified file %localPath%"  ) ;
    public static final ErrorId MsgDm_SyncNotSafeReplace      	= new ErrorId( ErrorOf( ES_DM, 605, E_INFO, 0, 3 , "318773853"),  "%depotFile%%depotRev% - can't replace modified file %localPath%"  ) ;
    public static final ErrorId MsgDm_SyncNotSafeUpdate       	= new ErrorId( ErrorOf( ES_DM, 604, E_INFO, 0, 3 , "318773852"),  "%depotFile%%depotRev% - can't update modified file %localPath%"  ) ;
    public static final ErrorId MsgDm_SyncRefresh             	= new ErrorId( ErrorOf( ES_DM, 346, E_INFO, 0, 3 , "318773594"),  "%depotFile%%depotRev% - refreshing %localPath%"  ) ;
    public static final ErrorId MsgDm_SyncReplace             	= new ErrorId( ErrorOf( ES_DM, 342, E_INFO, 0, 3 , "318773590"),  "%depotFile%%depotRev% - replacing %localPath%"  ) ;
    public static final ErrorId MsgDm_SyncResolve             	= new ErrorId( ErrorOf( ES_DM, 351, E_INFO, 1, 2 , "302061919"),  "%depotFile% - must resolve %revRange% before submitting"  ) ;
    public static final ErrorId MsgDm_SyncUpdate              	= new ErrorId( ErrorOf( ES_DM, 345, E_INFO, 0, 3 , "318773593"),  "%depotFile%%depotRev% - updating %localPath%"  ) ;
    public static final ErrorId MsgDm_SyncUptodate            	= new ErrorId( ErrorOf( ES_DM, 350, E_INFO, 0, 2 , "301996382"),  "%depotFile%%haveRev% - is up-to-date"  ) ;
    public static final ErrorId MsgDm_TheseCantChange         	= new ErrorId( ErrorOf( ES_DM, 65, E_FAILED, EV_ILLEGAL, 0 , "805574721"),  "Client and status cannot be changed."  ) ;
    public static final ErrorId MsgDm_TooManyClients          	= new ErrorId( ErrorOf( ES_DM, 37, E_FAILED, EV_ADMIN, 0 , "807606309"),  "Can't add client - over license quota."  ) ;
    public static final ErrorId MsgDm_TooManyRoots            	= new ErrorId( ErrorOf( ES_DM, 123, E_FAILED, EV_USAGE, 0 , "805378171"),  "Too many client root alternatives -- only 2 allowed."  ) ;
    public static final ErrorId MsgDm_TooManyUsers            	= new ErrorId( ErrorOf( ES_DM, 43, E_FAILED, EV_ADMIN, 0 , "807606315"),  "Can't create a new user - over license quota."  ) ;
    public static final ErrorId MsgDm_TooOld                  	= new ErrorId( ErrorOf( ES_DM, 108, E_FAILED, EV_UPGRADE, 0 , "807737452"),  "Remote server is too old to support remote access.  Install a new server."  ) ;
    public static final ErrorId MsgDm_TraitCleared            	= new ErrorId( ErrorOf( ES_DM, 429, E_INFO, 0, 3 , "318773677"),  "%depotFile%%depotRev% - %name% cleared"  ) ;
    public static final ErrorId MsgDm_TraitIsOpen             	= new ErrorId( ErrorOf( ES_DM, 686, E_FAILED, EV_CONTEXT, 0 , "805509806"),  "Cannot set propagating traits on currently opened file(s)."  ) ;
    public static final ErrorId MsgDm_TraitNotSet             	= new ErrorId( ErrorOf( ES_DM, 430, E_INFO, 0, 3 , "318773678"),  "%depotFile%%depotRev% - %name% not set"  ) ;
    public static final ErrorId MsgDm_TraitSet                	= new ErrorId( ErrorOf( ES_DM, 431, E_INFO, 0, 3 , "318773679"),  "%depotFile%%depotRev% - %name% set"  ) ;
    public static final ErrorId MsgDm_TriggerNoChange         	= new ErrorId( ErrorOf( ES_DM, 353, E_INFO, 0, 0 , "268441953"),  "Triggers not changed."  ) ;
    public static final ErrorId MsgDm_TriggerSave             	= new ErrorId( ErrorOf( ES_DM, 352, E_INFO, 0, 0 , "268441952"),  "Triggers saved."  ) ;
    public static final ErrorId MsgDm_TryDelClient            	= new ErrorId( ErrorOf( ES_DM, 121, E_INFO, EV_ADMIN, 0 , "270735481"),  "Try deleting old clients with 'client -d'."  ) ;
    public static final ErrorId MsgDm_TryDelUser              	= new ErrorId( ErrorOf( ES_DM, 122, E_INFO, EV_ADMIN, 0 , "270735482"),  "Try deleting old users with 'user -d'."  ) ;
    public static final ErrorId MsgDm_TryEvalLicense          	= new ErrorId( ErrorOf( ES_DM, 470, E_INFO, EV_ADMIN, 0 , "270735830"),  "\nAdditional users/clients may be obtained for\nevaluation purposes by visiting...\n\nhttp://www.perforce.com/eval\n"  ) ;
    public static final ErrorId MsgDm_TwistedMap	       	= new ErrorId( ErrorOf( ES_DM, 439, E_FAILED, EV_TOOBIG, 0 , "807868855"),  "Client map too twisted for directory list."  ) ;
    public static final ErrorId MsgDm_TypeMapNoChange         	= new ErrorId( ErrorOf( ES_DM, 355, E_INFO, 0, 1 , "285219171"),  "%type% not changed."  ) ;
    public static final ErrorId MsgDm_TypeMapSave             	= new ErrorId( ErrorOf( ES_DM, 354, E_INFO, 0, 1 , "285219170"),  "%type% saved."  ) ;
    public static final ErrorId MsgDm_UnLockAlready           	= new ErrorId( ErrorOf( ES_DM, 281, E_INFO, 0, 1 , "285219097"),  "%depotFile% - already unlocked"  ) ;
    public static final ErrorId MsgDm_UnLockAlreadyOther      	= new ErrorId( ErrorOf( ES_DM, 282, E_INFO, 0, 3 , "318773530"),  "%depotFile% - locked by %user%@%client%"  ) ;
    public static final ErrorId MsgDm_UnLockSuccess           	= new ErrorId( ErrorOf( ES_DM, 280, E_INFO, 0, 1 , "285219096"),  "%depotFile% - unlocking"  ) ;
    public static final ErrorId MsgDm_Unicode                 	= new ErrorId( ErrorOf( ES_DM, 24, E_FAILED, EV_ADMIN, 1 , "824383512"),  "Database has %value% tables with non-UTF8 text and can't be switched to Unicode mode."  ) ;
    public static final ErrorId MsgDm_UnidentifiedServer      	= new ErrorId( ErrorOf( ES_DM, 670, E_FAILED, EV_USAGE, 0 , "805378718"),  "Server identity has not been defined, use 'p4d -xD' to specify it."  ) ;
    public static final ErrorId MsgDm_UnknownReplicationMode  	= new ErrorId( ErrorOf( ES_DM, 611, E_FAILED, EV_FAULT, 1 , "824253027"),  "Unknown replication mode '%mode%'."  ) ;
    public static final ErrorId MsgDm_UnknownReplicationTarget 	= new ErrorId( ErrorOf( ES_DM, 612, E_FAILED, EV_FAULT, 1 , "824253028"),  "Unknown replication target '%target%'."  ) ;
    public static final ErrorId MsgDm_UnloadData              	= new ErrorId( ErrorOf( ES_DM, 715, E_INFO, 0, 2 , "301996747"),  "%object% %name% unloaded."  ) ;
    public static final ErrorId MsgDm_UnloadDepotMissing      	= new ErrorId( ErrorOf( ES_DM, 707, E_FAILED, EV_USAGE, 0 , "805378755"),  "No unload depot has been defined for this server."  ) ;
    public static final ErrorId MsgDm_UnloadNotOwner          	= new ErrorId( ErrorOf( ES_DM, 708, E_FAILED, EV_USAGE, 0 , "805378756"),  "Client, label, or task stream %domainName% is not owned by you."  ) ;
    public static final ErrorId MsgDm_UnshelveBadAction       	= new ErrorId( ErrorOf( ES_DM, 510, E_INFO, 0, 2 , "301996542"),  "%depotFile% - can't unshelve (already opened for %badAction%)"  ) ;
    public static final ErrorId MsgDm_UnshelveBadAdd       	= new ErrorId( ErrorOf( ES_DM, 520, E_INFO, 0, 2 , "301996552"),  "Can't unshelve %depotFile% to open for %badAdd%: file already exists."  ) ;
    public static final ErrorId MsgDm_UnshelveBadClientView       	= new ErrorId( ErrorOf( ES_DM, 641, E_INFO, 0, 2 , "301996673"),  "%depotFile% - can't unshelve (already opened for %action% using a different client view path)"  ) ;
    public static final ErrorId MsgDm_UnshelveBadEdit       	= new ErrorId( ErrorOf( ES_DM, 521, E_INFO, 0, 2 , "301996553"),  "Can't unshelve %depotFile% to open for %badEdit%: file does not exist or has been deleted."  ) ;
    public static final ErrorId MsgDm_UnshelveIsLocked        	= new ErrorId( ErrorOf( ES_DM, 513, E_FAILED, EV_USAGE , 0 , "805378561"),  "File(s) in this shelve are locked - try again later!"  ) ;
    public static final ErrorId MsgDm_UnshelveNotTask         	= new ErrorId( ErrorOf( ES_DM, 744, E_FAILED, EV_USAGE, 2 , "838933224"),  "%depotFile% - can't unshelve for %action%, task stream client required."  ) ;
    public static final ErrorId MsgDm_UnshelveResolve           	= new ErrorId( ErrorOf( ES_DM, 621, E_INFO, 1, 3 , "318839405"),  "%depotFile% - must resolve %fromFile%%rev% before submitting"  ) ;
    public static final ErrorId MsgDm_UnshelveSuccess         	= new ErrorId( ErrorOf( ES_DM, 511, E_INFO, 0, 3 , "318773759"),  "%depotFile%%depotRev% - unshelved, opened for %action%"  ) ;
    public static final ErrorId MsgDm_UseConfigure            	= new ErrorId( ErrorOf( ES_DM, 548, E_FAILED, EV_UNKNOWN, 0 , "805444132"),  "Usage: { set [name#]var=value | unset [name#]var }"  ) ;
    public static final ErrorId MsgDm_UserCantChange	       	= new ErrorId( ErrorOf( ES_DM, 750, E_FAILED, EV_ILLEGAL, 0 , "805575406"),  "User cannot be changed in a committed change."  ) ;
    public static final ErrorId MsgDm_UserCantDelete          	= new ErrorId( ErrorOf( ES_DM, 359, E_INFO, 0, 2 , "301996391"),  "User %user% has file(s) open on %value% client(s) and can't be deleted."  ) ;
    public static final ErrorId MsgDm_UserDelete              	= new ErrorId( ErrorOf( ES_DM, 360, E_INFO, 0, 1 , "285219176"),  "User %user% deleted."  ) ;
    public static final ErrorId MsgDm_UserNoChange            	= new ErrorId( ErrorOf( ES_DM, 357, E_INFO, 0, 1 , "285219173"),  "User %user% not changed."  ) ;
    public static final ErrorId MsgDm_UserNotExist            	= new ErrorId( ErrorOf( ES_DM, 358, E_FAILED, EV_UNKNOWN, 1 , "822221158"),  "User %user% doesn't exist."  ) ;
    public static final ErrorId MsgDm_UserOrGroup             	= new ErrorId( ErrorOf( ES_DM, 83, E_FAILED, EV_USAGE, 1 , "822155347"),  "Indicator must be 'user' or 'group', not '%value%'."  ) ;
    public static final ErrorId MsgDm_UserSave                	= new ErrorId( ErrorOf( ES_DM, 356, E_INFO, 0, 1 , "285219172"),  "User %user% saved."  ) ;
    public static final ErrorId MsgDm_UsersData               	= new ErrorId( ErrorOf( ES_DM, 361, E_INFO, 0, 4 , "335550825"),  "%user% <%email%> (%fullName%) accessed %accessDate%"  ) ;
    public static final ErrorId MsgDm_UsersDataLong           	= new ErrorId( ErrorOf( ES_DM, 555, E_INFO, 0, 7 , "385882667"),  "%user% <%email%> (%fullName%) accessed %accessDate% type %type% ticket expires %endDate% password last changed %passDate%"  ) ;
    public static final ErrorId MsgDm_VerifyData              	= new ErrorId( ErrorOf( ES_DM, 362, E_INFO, 0, 7 , "385882474"),  "%depotFile%%depotRev% - %action% %change% (%type%) %digest%[ %status%]"  ) ;
    public static final ErrorId MsgDm_VerifyDataProblem       	= new ErrorId( ErrorOf( ES_DM, 730, E_FAILED, 0, 7 , "922753754"),  "%depotFile%%depotRev% - %action% %change% (%type%) %digest% %status%"  ) ;
    public static final ErrorId MsgDm_WhereData               	= new ErrorId( ErrorOf( ES_DM, 364, E_INFO, 0, 4 , "335550828"),  "%mapFlag%%depotFile% %clientFile% %localPath%"  ) ;
    public static final ErrorId MsgDm_WildAdd                 	= new ErrorId( ErrorOf( ES_DM, 82, E_FAILED, EV_USAGE, 0 , "805378130"),  "Can't add filenames with wildcards [@#%*] in them.\nUse -f option to force add."  ) ;
    public static final ErrorId MsgDm_WildAddTripleDots       	= new ErrorId( ErrorOf( ES_DM, 637, E_FAILED, EV_USAGE, 0 , "805378685"),  "Can't add filenames containing the ellipsis wildcard (...)."  ) ;
    public static final ErrorId MsgDm_WorkingVsLocked         	= new ErrorId( ErrorOf( ES_DM, 58, E_FATAL, EV_FAULT, 0 , "1075910714"),  "Working and locked tables out of sync!"  ) ;
    public static final ErrorId MsgDm_WrongClient             	= new ErrorId( ErrorOf( ES_DM, 28, E_FAILED, EV_CONTEXT, 2 , "839063580"),  "%change% belongs to client %client%."  ) ;
    public static final ErrorId MsgDm_WrongDomain             	= new ErrorId( ErrorOf( ES_DM, 36, E_FAILED, EV_CONTEXT, 3 , "855840804"),  "%name% is a %type%, not a %type2%."  ) ;
    public static final ErrorId MsgDm_WrongUser               	= new ErrorId( ErrorOf( ES_DM, 29, E_FAILED, EV_CONTEXT, 2 , "839063581"),  "%change% belongs to user %user%."  ) ;
    public static final ErrorId MsgDm_WrongUserDelete         	= new ErrorId( ErrorOf( ES_DM, 86, E_FAILED, EV_PROTECT, 1 , "822483030"),  "Not user '%user%'; use -f to force delete."  ) ;
    public static final ErrorId MsgLbr_After                  	= new ErrorId( ErrorOf( ES_LBR, 101, E_FATAL, EV_FAULT, 1 , "1092683877"),  "RCS no revision after %name%!"  ) ;
    public static final ErrorId MsgLbr_BadType1               	= new ErrorId( ErrorOf( ES_LBR, 1, E_FATAL, EV_FAULT, 1 , "1092683777"),  "Unsupported librarian file type %lbrType%!"  ) ;
    public static final ErrorId MsgLbr_Checkin                	= new ErrorId( ErrorOf( ES_LBR, 102, E_FATAL, EV_FAULT, 2 , "1109461094"),  "RCS checkin %file%#%rev% failed!"  ) ;
    public static final ErrorId MsgLbr_Checkout               	= new ErrorId( ErrorOf( ES_LBR, 103, E_FATAL, EV_FAULT, 1 , "1092683879"),  "RCS checkout %file% failed!"  ) ;
    public static final ErrorId MsgLbr_Commit                 	= new ErrorId( ErrorOf( ES_LBR, 104, E_FATAL, EV_FAULT, 1 , "1092683880"),  "RCS can't commit changes to %file%!"  ) ;
    public static final ErrorId MsgLbr_Diff                   	= new ErrorId( ErrorOf( ES_LBR, 105, E_FATAL, EV_FAULT, 1 , "1092683881"),  "RCS diff %file% failed!"  ) ;
    public static final ErrorId MsgLbr_Edit0                  	= new ErrorId( ErrorOf( ES_LBR, 106, E_FATAL, EV_FAULT, 0 , "1075906666"),  "RCS editLineNumber past currLineNumber!"  ) ;
    public static final ErrorId MsgLbr_Edit1                  	= new ErrorId( ErrorOf( ES_LBR, 107, E_FATAL, EV_FAULT, 0 , "1075906667"),  "RCS editLineCount bogus in RcsPieceDelete!"  ) ;
    public static final ErrorId MsgLbr_Edit2                  	= new ErrorId( ErrorOf( ES_LBR, 108, E_FATAL, EV_FAULT, 1 , "1092683884"),  "RCS editLine '%line%' bogus!"  ) ;
    public static final ErrorId MsgLbr_Empty                  	= new ErrorId( ErrorOf( ES_LBR, 109, E_FATAL, EV_FAULT, 0 , "1075906669"),  "RCS checkin author/state empty!"  ) ;
    public static final ErrorId MsgLbr_EofAt                  	= new ErrorId( ErrorOf( ES_LBR, 110, E_FATAL, EV_FAULT, 0 , "1075906670"),  "RCS EOF in @ block!"  ) ;
    public static final ErrorId MsgLbr_ExpDesc                	= new ErrorId( ErrorOf( ES_LBR, 111, E_FATAL, EV_FAULT, 0 , "1075906671"),  "RCS expected desc!"  ) ;
    public static final ErrorId MsgLbr_ExpEof                 	= new ErrorId( ErrorOf( ES_LBR, 112, E_FATAL, EV_FAULT, 0 , "1075906672"),  "RCS expected EOF!"  ) ;
    public static final ErrorId MsgLbr_ExpRev                 	= new ErrorId( ErrorOf( ES_LBR, 113, E_FATAL, EV_FAULT, 0 , "1075906673"),  "RCS expected optional revision!"  ) ;
    public static final ErrorId MsgLbr_ExpSemi                	= new ErrorId( ErrorOf( ES_LBR, 114, E_FATAL, EV_FAULT, 0 , "1075906674"),  "RCS expected ;!"  ) ;
    public static final ErrorId MsgLbr_Expect                 	= new ErrorId( ErrorOf( ES_LBR, 111, E_FATAL, EV_FAULT, 2 , "1109461103"),  "RCS expected %token%, got %token2%!"  ) ;
    public static final ErrorId MsgLbr_FmtLbrStat             	= new ErrorId( ErrorOf( ES_LBR, 129, E_INFO, EV_NONE, 11 , "452987009"),  "%file% %rev% %type% %state% %action% %digest% %size% %process% %timestamp% %retries% %lastError%"  ) ;
    public static final ErrorId MsgLbr_FmtLbrStat2            	= new ErrorId( ErrorOf( ES_LBR, 130, E_INFO, EV_NONE, 14 , "503318658"),  "%file% %rev% %type% %state% %action% %digest% %size% %change% %revDate% %modTime% %process% %timestamp% %retries% %lastError%"  ) ;
    public static final ErrorId MsgLbr_LbrOpenFail            	= new ErrorId( ErrorOf( ES_LBR, 131, E_FAILED, EV_FAULT, 2 , "841025667"),  "Error opening librarian file %lbrFile% revision %lbrRev%."  ) ;
    public static final ErrorId MsgLbr_Lock                   	= new ErrorId( ErrorOf( ES_LBR, 115, E_FATAL, EV_FAULT, 1 , "1092683891"),  "RCS lock on %file% failed!"  ) ;
    public static final ErrorId MsgLbr_Loop                   	= new ErrorId( ErrorOf( ES_LBR, 116, E_FATAL, EV_FAULT, 1 , "1092683892"),  "RCS loop in revision tree at %name%!"  ) ;
    public static final ErrorId MsgLbr_Mangled                	= new ErrorId( ErrorOf( ES_LBR, 117, E_FATAL, EV_FAULT, 1 , "1092683893"),  "RCS delta mangled: %text%!"  ) ;
    public static final ErrorId MsgLbr_MkDir                  	= new ErrorId( ErrorOf( ES_LBR, 118, E_FATAL, EV_FAULT, 1 , "1092683894"),  "RCS can't make directory for %file%!"  ) ;
    public static final ErrorId MsgLbr_NoBrRev                	= new ErrorId( ErrorOf( ES_LBR, 119, E_FATAL, EV_FAULT, 1 , "1092683895"),  "RCS no branch to revision %rev%!"  ) ;
    public static final ErrorId MsgLbr_NoBranch               	= new ErrorId( ErrorOf( ES_LBR, 120, E_FATAL, EV_FAULT, 1 , "1092683896"),  "RCS no such branch %branch%!"  ) ;
    public static final ErrorId MsgLbr_NoRev                  	= new ErrorId( ErrorOf( ES_LBR, 121, E_FATAL, EV_FAULT, 1 , "1092683897"),  "RCS no such revision %rev%!"  ) ;
    public static final ErrorId MsgLbr_NoRev3                 	= new ErrorId( ErrorOf( ES_LBR, 123, E_FATAL, EV_FAULT, 1 , "1092683899"),  "RCS expected revision %rev% missing!"  ) ;
    public static final ErrorId MsgLbr_NoRevDel               	= new ErrorId( ErrorOf( ES_LBR, 124, E_FATAL, EV_FAULT, 1 , "1092683900"),  "RCS non-existant revision %rev% to delete!"  ) ;
    public static final ErrorId MsgLbr_Parse                  	= new ErrorId( ErrorOf( ES_LBR, 125, E_FATAL, EV_FAULT, 1 , "1092683901"),  "RCS parse error at line %line%!"  ) ;
    public static final ErrorId MsgLbr_Purged                 	= new ErrorId( ErrorOf( ES_LBR, 2, E_FAILED, EV_EMPTY, 2 , "839976962"),  "Old revision %lbrRev% of tempobj %lbrFile% purged; try using head revision."  ) ;
    public static final ErrorId MsgLbr_RcsTooBig              	= new ErrorId( ErrorOf( ES_LBR, 128, E_FAILED, EV_TOOBIG, 1 , "824641664"),  "Result RCS file '%file%' is too big; change type to compressed text."  ) ;
    public static final ErrorId MsgLbr_RevLess                	= new ErrorId( ErrorOf( ES_LBR, 126, E_FATAL, EV_FAULT, 0 , "1075906686"),  "RCS log without matching revision!"  ) ;
    public static final ErrorId MsgLbr_ScriptFailed           	= new ErrorId( ErrorOf( ES_LBR, 3, E_FAILED, EV_ADMIN, 3 , "857933827"),  "%trigger% %op%: %result%"  ) ;
    public static final ErrorId MsgLbr_TooBig                 	= new ErrorId( ErrorOf( ES_LBR, 127, E_FATAL, EV_FAULT, 0 , "1075906687"),  "RCS token too big!"  ) ;
    public static final ErrorId MsgOs_Deleted                 	= new ErrorId( ErrorOf( ES_OS, 6, E_FATAL, EV_FAULT, 1 , "1092681734"),  "%handle%: deleted handled!"  ) ;
    public static final ErrorId MsgOs_EmptyFork               	= new ErrorId( ErrorOf( ES_OS, 8, E_FAILED, EV_CLIENT, 1 , "824311816"),  "Resource fork for %file% from server is empty."  ) ;
    public static final ErrorId MsgOs_Net                     	= new ErrorId( ErrorOf( ES_OS, 3, E_FAILED, EV_COMM, 3 , "858128387"),  "%operation%: %arg%: %errmsg%"  ) ;
    public static final ErrorId MsgOs_NetUn                   	= new ErrorId( ErrorOf( ES_OS, 4, E_FAILED, EV_COMM, 3 , "858128388"),  "%operation%: %arg%: unknown network error %errno%"  ) ;
    public static final ErrorId MsgOs_NoSuch                  	= new ErrorId( ErrorOf( ES_OS, 7, E_FATAL, EV_FAULT, 1 , "1092681735"),  "%handle%: no such handle!"  ) ;
    public static final ErrorId MsgOs_Sys                     	= new ErrorId( ErrorOf( ES_OS, 1, E_FAILED, EV_FAULT, 3 , "857800705"),  "%operation%: %arg%: %errmsg%"  ) ;
    public static final ErrorId MsgOs_Sys2                    	= new ErrorId( ErrorOf( ES_OS, 9, E_FAILED, EV_FAULT, 3 , "857800713"),  "%operation2%: %arg2%: %errmsg2%"  ) ;
    public static final ErrorId MsgOs_SysUn                   	= new ErrorId( ErrorOf( ES_OS, 2, E_FAILED, EV_FAULT, 3 , "857800706"),  "%operation%: %arg%: unknown errno %errno%"  ) ;
    public static final ErrorId MsgOs_SysUn2                  	= new ErrorId( ErrorOf( ES_OS, 10, E_FAILED, EV_FAULT, 3 , "857800714"),  "%operation2%: %arg2%: unknown errno %errno2%"  ) ;
    public static final ErrorId MsgOs_TooMany                 	= new ErrorId( ErrorOf( ES_OS, 5, E_FATAL, EV_FAULT, 1 , "1092681733"),  "%handle%: too many handles!"  ) ;
    public static final ErrorId MsgRpc_Break                  	= new ErrorId( ErrorOf( ES_RPC, 21, E_FAILED, EV_COMM, 0 , "807799829"),  "TCP receive interrupted by client."  ) ;
    public static final ErrorId MsgRpc_Closed                 	= new ErrorId( ErrorOf( ES_RPC, 1, E_FAILED, EV_COMM, 0 , "807799809"),  "Partner exited unexpectedly."  ) ;
    public static final ErrorId MsgRpc_Listen                 	= new ErrorId( ErrorOf( ES_RPC, 3, E_FAILED, EV_COMM, 1 , "824577027"),  "Listen %address% failed."  ) ;
    public static final ErrorId MsgRpc_MaxWait                	= new ErrorId( ErrorOf( ES_RPC, 39, E_FAILED, EV_COMM, 2 , "841354279"),  "TCP %operation% exceeded maximum configured duration of %seconds% seconds."  ) ;
    public static final ErrorId MsgRpc_NameResolve            	= new ErrorId( ErrorOf( ES_RPC, 37, E_FAILED, EV_COMM, 2 , "841354277"),  "%errortext%"  ) ;
    public static final ErrorId MsgRpc_NoPoss                 	= new ErrorId( ErrorOf( ES_RPC, 5, E_FAILED, EV_COMM, 0 , "807799813"),  "Required positional parameter missing."  ) ;
    public static final ErrorId MsgRpc_NotP4                  	= new ErrorId( ErrorOf( ES_RPC, 6, E_FAILED, EV_COMM, 0 , "807799814"),  "RpcTransport: partner is not a Perforce client/server."  ) ;
    public static final ErrorId MsgRpc_Operat                 	= new ErrorId( ErrorOf( ES_RPC, 7, E_FAILED, EV_COMM, 1 , "824577031"),  "Operation '%operation%' failed."  ) ;
    public static final ErrorId MsgRpc_PxRemoteSvrFail        	= new ErrorId( ErrorOf( ES_RPC, 52, E_FAILED, EV_COMM, 0 , "807799860"),  "Proxy unable to communicate with remote server:"  ) ;
    public static final ErrorId MsgRpc_Read                   	= new ErrorId( ErrorOf( ES_RPC, 8, E_FAILED, EV_COMM, 0 , "807799816"),  "RpcTransport: partial message read"  ) ;
    public static final ErrorId MsgRpc_Reconn                 	= new ErrorId( ErrorOf( ES_RPC, 9, E_FATAL, EV_COMM, 0 , "1076235273"),  "Can't connect an existing connection!"  ) ;
    public static final ErrorId MsgRpc_ServiceNoTrust         	= new ErrorId( ErrorOf( ES_RPC, 50, E_FAILED, EV_COMM, 1 , "824577074"),  "%server% cannot forward your request; target failed SSL/trust verification."  ) ;
    public static final ErrorId MsgRpc_SslAccept              	= new ErrorId( ErrorOf( ES_RPC, 38, E_FAILED, EV_COMM, 1 , "824577062"),  "SSL connection accept failed %error%.\n\tClient must add SSL protocol prefix to P4PORT."  ) ;
    public static final ErrorId MsgRpc_SslBadDir              	= new ErrorId( ErrorOf( ES_RPC, 41, E_FATAL, EV_COMM, 0 , "1076235305"),  "P4SSLDIR not defined or does not reference a valid directory."  ) ;
    public static final ErrorId MsgRpc_SslBadFsSecurity       	= new ErrorId( ErrorOf( ES_RPC, 42, E_FATAL, EV_COMM, 0 , "1076235306"),  "P4SSLDIR directory or key and certificate files not secure."  ) ;
    public static final ErrorId MsgRpc_SslBadKeyFile          	= new ErrorId( ErrorOf( ES_RPC, 36, E_FATAL, EV_COMM, 0 , "1076235300"),  "Either privatekey.txt or certificate.txt files do not exist."  ) ;
    public static final ErrorId MsgRpc_SslCertBadDates        	= new ErrorId( ErrorOf( ES_RPC, 45, E_FATAL, EV_COMM, 0 , "1076235309"),  "Certificate date range invalid."  ) ;
    public static final ErrorId MsgRpc_SslCertGen             	= new ErrorId( ErrorOf( ES_RPC, 34, E_FATAL, EV_COMM, 0 , "1076235298"),  "Unable to generate certificate or private key for server."  ) ;
    public static final ErrorId MsgRpc_SslCfgExpire           	= new ErrorId( ErrorOf( ES_RPC, 53, E_FAILED, EV_COMM, 1 , "824577077"),  "Certificate config.txt: invalid EX value \"%exValue%\", must be number > 0."  ) ;
    public static final ErrorId MsgRpc_SslCfgUnits            	= new ErrorId( ErrorOf( ES_RPC, 54, E_FAILED, EV_COMM, 0 , "807799862"),  "Certificate config.txt: invalid UNITS value, must be either secs, mins, hours, or days."  ) ;
    public static final ErrorId MsgRpc_SslCleartext           	= new ErrorId( ErrorOf( ES_RPC, 33, E_FAILED, EV_COMM, 0 , "807799841"),  "Failed client connect, server using SSL.\nClient must add SSL protocol prefix to P4PORT."  ) ;
    public static final ErrorId MsgRpc_SslClose               	= new ErrorId( ErrorOf( ES_RPC, 27, E_FAILED, EV_COMM, 0 , "807799835"),  "SSL close failed."  ) ;
    public static final ErrorId MsgRpc_SslConnect             	= new ErrorId( ErrorOf( ES_RPC, 23, E_FAILED, EV_COMM, 2 , "841354263"),  "SSL connect to %host% failed %error%.\n\tRemove SSL protocol prefix from P4PORT."  ) ;
    public static final ErrorId MsgRpc_SslCredsBadOwner       	= new ErrorId( ErrorOf( ES_RPC, 44, E_FATAL, EV_COMM, 0 , "1076235308"),  "P4SSLDIR or credentials files not owned by Perforce process effective user."  ) ;
    public static final ErrorId MsgRpc_SslCtx                 	= new ErrorId( ErrorOf( ES_RPC, 29, E_FAILED, EV_COMM, 1 , "824577053"),  "Fail create ctx on %service%."  ) ;
    public static final ErrorId MsgRpc_SslDirHasCreds         	= new ErrorId( ErrorOf( ES_RPC, 43, E_FATAL, EV_COMM, 0 , "1076235307"),  "P4SSLDIR contains credentials, please remove key and certificate files."  ) ;
    public static final ErrorId MsgRpc_SslFailGetExpire       	= new ErrorId( ErrorOf( ES_RPC, 47, E_FAILED, EV_COMM, 0 , "807799855"),  "Failed to get certificate's expiration date."  ) ;
    public static final ErrorId MsgRpc_SslGetPubKey           	= new ErrorId( ErrorOf( ES_RPC, 40, E_FATAL, EV_COMM, 0 , "1076235304"),  "Unable to get public key for token generation."  ) ;
    public static final ErrorId MsgRpc_SslInit                	= new ErrorId( ErrorOf( ES_RPC, 32, E_FATAL, EV_COMM, 0 , "1076235296"),  "Failed to initialize SSL library."  ) ;
    public static final ErrorId MsgRpc_SslInvalid             	= new ErrorId( ErrorOf( ES_RPC, 28, E_FAILED, EV_COMM, 1 , "824577052"),  "Invalid operation for SSL on %service%."  ) ;
    public static final ErrorId MsgRpc_SslKeyNotRSA           	= new ErrorId( ErrorOf( ES_RPC, 55, E_FAILED, EV_COMM, 0 , "807799863"),  "Fail load key, not of type RSA."  ) ;
    public static final ErrorId MsgRpc_SslLibMismatch         	= new ErrorId( ErrorOf( ES_RPC, 51, E_FAILED, EV_COMM, 1 , "824577075"),  "SSL library must be at least version %sslversion%."  ) ;
    public static final ErrorId MsgRpc_SslListen              	= new ErrorId( ErrorOf( ES_RPC, 24, E_FAILED, EV_COMM, 1 , "824577048"),  "SSL listen on %service% failed."  ) ;
    public static final ErrorId MsgRpc_SslNoCredentials       	= new ErrorId( ErrorOf( ES_RPC, 46, E_FATAL, EV_COMM, 0 , "1076235310"),  "SSL credentials do not exist."  ) ;
    public static final ErrorId MsgRpc_SslNoSsl               	= new ErrorId( ErrorOf( ES_RPC, 35, E_FATAL, EV_COMM, 0 , "1076235299"),  "Trying to use SSL when SSL library has not been compiled into program."  ) ;
    public static final ErrorId MsgRpc_SslRecv                	= new ErrorId( ErrorOf( ES_RPC, 25, E_FAILED, EV_COMM, 0 , "807799833"),  "SSL receive failed."  ) ;
    public static final ErrorId MsgRpc_SslSend                	= new ErrorId( ErrorOf( ES_RPC, 26, E_FAILED, EV_COMM, 0 , "807799834"),  "SSL send failed."  ) ;
    public static final ErrorId MsgRpc_SslShutdown            	= new ErrorId( ErrorOf( ES_RPC, 30, E_FAILED, EV_COMM, 0 , "807799838"),  "SSL read/write failed since in Shutdown."  ) ;
    public static final ErrorId MsgRpc_Stdio                  	= new ErrorId( ErrorOf( ES_RPC, 10, E_FATAL, EV_COMM, 0 , "1076235274"),  "Can't make outbound connection via stdio!"  ) ;
    public static final ErrorId MsgRpc_TcpAccept              	= new ErrorId( ErrorOf( ES_RPC, 11, E_FAILED, EV_COMM, 0 , "807799819"),  "TCP connection accept failed."  ) ;
    public static final ErrorId MsgRpc_TcpConnect             	= new ErrorId( ErrorOf( ES_RPC, 12, E_FAILED, EV_COMM, 1 , "824577036"),  "TCP connect to %host% failed."  ) ;
    public static final ErrorId MsgRpc_TcpHost                	= new ErrorId( ErrorOf( ES_RPC, 13, E_FAILED, EV_COMM, 1 , "824577037"),  "%host%: host unknown."  ) ;
    public static final ErrorId MsgRpc_TcpListen              	= new ErrorId( ErrorOf( ES_RPC, 14, E_FAILED, EV_COMM, 1 , "824577038"),  "TCP listen on %service% failed."  ) ;
    public static final ErrorId MsgRpc_TcpPeerSsl             	= new ErrorId( ErrorOf( ES_RPC, 31, E_FAILED, EV_COMM, 0 , "807799839"),  "Failed client SSL connection setup, server not using SSL."  ) ;
    public static final ErrorId MsgRpc_TcpPortInvalid         	= new ErrorId( ErrorOf( ES_RPC, 22, E_FAILED, EV_COMM, 1 , "824577046"),  "TCP port number %service% is out of range."  ) ;
    public static final ErrorId MsgRpc_TcpRecv                	= new ErrorId( ErrorOf( ES_RPC, 15, E_FAILED, EV_COMM, 0 , "807799823"),  "TCP receive failed."  ) ;
    public static final ErrorId MsgRpc_TcpSend                	= new ErrorId( ErrorOf( ES_RPC, 16, E_FAILED, EV_COMM, 0 , "807799824"),  "TCP send failed."  ) ;
    public static final ErrorId MsgRpc_TcpService             	= new ErrorId( ErrorOf( ES_RPC, 17, E_FAILED, EV_COMM, 1 , "824577041"),  "%service%: service unknown."  ) ;
    public static final ErrorId MsgRpc_TooBig                 	= new ErrorId( ErrorOf( ES_RPC, 18, E_FATAL, EV_COMM, 0 , "1076235282"),  "Rpc buffer too big to send!"  ) ;
    public static final ErrorId MsgRpc_UnReg                  	= new ErrorId( ErrorOf( ES_RPC, 19, E_FATAL, EV_COMM, 1 , "1093012499"),  "Internal function '%function%' unregistered!"  ) ;
    public static final ErrorId MsgRpc_Unconn                 	= new ErrorId( ErrorOf( ES_RPC, 20, E_FATAL, EV_COMM, 0 , "1076235284"),  "Connection attempt on unopened rpc!"  ) ;
    public static final ErrorId MsgServer_ActionResolve111    	= new ErrorId( ErrorOf( ES_SERVER, 498, E_WARN, EV_UPGRADE, 2 , "572857842"),  "%localFile% - upgrade to a 2011.1 or later client to perform an interactive %resolveType% resolve, or use resolve -a."  ) ;
    public static final ErrorId MsgServer_AddDelete           	= new ErrorId( ErrorOf( ES_SERVER, 35, E_FAILED, EV_USAGE, 0 , "805379107"),  "Can't add (-a) and delete (-d) at the same time."  ) ;
    public static final ErrorId MsgServer_AdminNoSpecDepot    	= new ErrorId( ErrorOf( ES_SERVER, 353, E_FAILED, EV_ADMIN, 0 , "807607649"),  "Can't create forms - no 'spec' depot found."  ) ;
    public static final ErrorId MsgServer_AdminNoSuchSpec     	= new ErrorId( ErrorOf( ES_SERVER, 578, E_WARN, EV_ADMIN, 1 , "555949634"),  "No form specifications of type %specName% were found."  ) ;
    public static final ErrorId MsgServer_AdminNothingLocked  	= new ErrorId( ErrorOf( ES_SERVER, 366, E_INFO, EV_ADMIN, 0 , "270736750"),  "No tables locked."  ) ;
    public static final ErrorId MsgServer_AdminNothingLogged  	= new ErrorId( ErrorOf( ES_SERVER, 373, E_WARN, EV_ADMIN, 0 , "539172213"),  "No journal or log files found."  ) ;
    public static final ErrorId MsgServer_AdminPasswordNoPasswords 	= new ErrorId( ErrorOf( ES_SERVER, 619, E_FAILED, EV_EMPTY, 0 , "806428267"),  "No users with passwords found."  ) ;
    public static final ErrorId MsgServer_AdminPasswordNoSuchUser 	= new ErrorId( ErrorOf( ES_SERVER, 618, E_FAILED, EV_UNKNOWN, 1 , "822222442"),  "%user% - no such user, or user does not have a password."  ) ;
    public static final ErrorId MsgServer_AdminReplicaCkp     	= new ErrorId( ErrorOf( ES_SERVER, 529, E_INFO, EV_ADMIN, 0 , "270736913"),  "The 'pull' command will perform the checkpoint at the next rotation of the journal on the master."  ) ;
    public static final ErrorId MsgServer_AdminSizeData  	= new ErrorId( ErrorOf( ES_SERVER, 372, E_INFO, EV_ADMIN, 2 , "304291188"),  "%name% %size% bytes"  ) ;
    public static final ErrorId MsgServer_BFNoOverwriteLocal  	= new ErrorId( ErrorOf( ES_SERVER, 622, E_FAILED, EV_FAULT, 5 , "891362926"),  "Replica name conflict: Globally-defined object %domainName% of type %domainType% would overwrite locally-defined object %localName% of type %localType%, which is bound to server %serverId%. Replication has been halted for this replica. To resume replication, the locally-defined object must be deleted (e.g., 'p4 client -d' to delete a Build Farm Client)."  ) ;
    public static final ErrorId MsgServer_BadCheckpointNum       	= new ErrorId( ErrorOf( ES_SERVER, 380, E_FAILED, EV_ADMIN, 1 , "824384892"),  "Checkpoint %number% is not available"  ) ;
    public static final ErrorId MsgServer_BadCommand          	= new ErrorId( ErrorOf( ES_SERVER, 26, E_FAILED, EV_USAGE, 0 , "805379098"),  "Unknown command.  Try 'p4 help' for info."  ) ;
    public static final ErrorId MsgServer_BadExtraFlag        	= new ErrorId( ErrorOf( ES_SERVER, 18, E_FAILED, EV_USAGE, 0 , "805379090"),  "Unknown -x operation.  Try 'f', 'i', 'u', 'v', or 'x'."  ) ;
    public static final ErrorId MsgServer_BadIPAddr           	= new ErrorId( ErrorOf( ES_SERVER, 8, E_FAILED, EV_ADMIN, 0 , "807607304"),  "Licensing error -- invalid server IP address."  ) ;
    public static final ErrorId MsgServer_BadImport           	= new ErrorId( ErrorOf( ES_SERVER, 354, E_FAILED, EV_CLIENT, 2 , "841096546"),  "Can't copy %depotFile%%depotRev% - revision has been purged!"  ) ;
    public static final ErrorId MsgServer_BadJnlFlag          	= new ErrorId( ErrorOf( ES_SERVER, 17, E_FAILED, EV_USAGE, 0 , "805379089"),  "Unknown journaling flag.  Try 'c', 'd', 'j' or 'r'."  ) ;
    public static final ErrorId MsgServer_BadJournalNum       	= new ErrorId( ErrorOf( ES_SERVER, 379, E_FAILED, EV_ADMIN, 1 , "824384891"),  "Journal %number% is not available"  ) ;
    public static final ErrorId MsgServer_BadPCache           	= new ErrorId( ErrorOf( ES_SERVER, 295, E_FAILED, EV_ADMIN, 0 , "807607591"),  "Proxy Cache directory (set with $P4PCACHE or -r flag) invalid."  ) ;
    public static final ErrorId MsgServer_BadPassword         	= new ErrorId( ErrorOf( ES_SERVER, 21, E_FAILED, EV_CONFIG, 0 , "807672853"),  "Perforce password (P4PASSWD) invalid or unset."  ) ;
    public static final ErrorId MsgServer_BadPassword0        	= new ErrorId( ErrorOf( ES_SERVER, 38, E_FAILED, EV_ILLEGAL, 0 , "805575718"),  "Password invalid."  ) ;
    public static final ErrorId MsgServer_BadPassword1        	= new ErrorId( ErrorOf( ES_SERVER, 39, E_FAILED, EV_ILLEGAL, 0 , "805575719"),  "Passwords don't match."  ) ;
    public static final ErrorId MsgServer_BadRoot             	= new ErrorId( ErrorOf( ES_SERVER, 7, E_FAILED, EV_ADMIN, 0 , "807607303"),  "Root directory (set with $P4ROOT or -r flag) invalid."  ) ;
    public static final ErrorId MsgServer_BadServicePack      	= new ErrorId( ErrorOf( ES_SERVER, 320, E_FAILED, EV_ADMIN, 1 , "824384832"),  "On Windows XP the Perforce server requires at least \"Service Pack 2\",\n        on Windows Server 2003 it requires at least \"Service Pack 1\",\n        and Windows 2000 is no longer supported.\n        This machine is running OS \"%os%\" with \"%pack%\"."  ) ;
    public static final ErrorId MsgServer_BadSortOption        	= new ErrorId( ErrorOf( ES_SERVER, 461, E_FAILED, EV_USAGE, 1 , "822156749"),  "%name% is not a valid sort attribute name."  ) ;
    public static final ErrorId MsgServer_BadTransfers        	= new ErrorId( ErrorOf( ES_SERVER, 51, E_FAILED, EV_CLIENT, 0 , "807541811"),  "Some file(s) could not be transferred from client."  ) ;
    public static final ErrorId MsgServer_BoundClientExists   	= new ErrorId( ErrorOf( ES_SERVER, 580, E_FAILED, EV_USAGE, 1 , "822156868"),  "Client %client% already exists."  ) ;
    public static final ErrorId MsgServer_BoundClientServerID 	= new ErrorId( ErrorOf( ES_SERVER, 581, E_FAILED, EV_USAGE, 0 , "805379653"),  "Bound client must be created on a server with a fixed identity."  ) ;
    public static final ErrorId MsgServer_CantAuthenticate    	= new ErrorId( ErrorOf( ES_SERVER, 334, E_FAILED, EV_ILLEGAL, 0 , "805576014"),  "Command unavailable: external authentication '%triggerType%' trigger not found."  ) ;
    public static final ErrorId MsgServer_CantChangeOther     	= new ErrorId( ErrorOf( ES_SERVER, 336, E_FAILED, EV_ILLEGAL, 0 , "805576016"),  "Cannot change password for another user with external authentication."  ) ;
    public static final ErrorId MsgServer_CantOpen            	= new ErrorId( ErrorOf( ES_SERVER, 14, E_FATAL, EV_FAULT, 2 , "1109466126"),  "%depotFile% - can't %action% file!"  ) ;
    public static final ErrorId MsgServer_CantRevertToPurged  	= new ErrorId( ErrorOf( ES_SERVER, 501, E_FAILED, EV_NOTYET, 0 , "805641717"),  "%file% has been purged and cannot be reverted. Use 'p4 revert -k' and then 'p4 sync' to get a newer revision."  ) ;
    public static final ErrorId MsgServer_CantUnloadLocked    	= new ErrorId( ErrorOf( ES_SERVER, 630, E_FAILED, EV_USAGE, 2 , "838934134"),  "Specify the '-L' flag in order to unload locked %domainType% %domainName%."  ) ;
    public static final ErrorId MsgServer_ChangesShelved        	= new ErrorId( ErrorOf( ES_SERVER, 614, E_INFO, 1, 1 , "285285990"),  "File(s) shelved in change %change%"  ) ;
    public static final ErrorId MsgServer_ClientBadHost       	= new ErrorId( ErrorOf( ES_SERVER, 589, E_FAILED, EV_ADMIN, 0 , "807607885"),  "TCP connection not licensed from '%address%'."  ) ;
    public static final ErrorId MsgServer_ClientOpFailed      	= new ErrorId( ErrorOf( ES_SERVER, 29, E_FAILED, EV_CLIENT, 0 , "807541789"),  "Client side operation(s) failed.  Command aborted."  ) ;
    public static final ErrorId MsgServer_ClientTooOld        	= new ErrorId( ErrorOf( ES_SERVER, 428, E_FAILED, EV_USAGE, 1 , "822156716"),  "Client is too old to use this server.  %message%"  ) ;
    public static final ErrorId MsgServer_CommandCancelled    	= new ErrorId( ErrorOf( ES_SERVER, 332, E_FAILED, EV_ADMIN, 0 , "807607628"),  "Command terminated by 'p4 monitor terminate'."  ) ;
    public static final ErrorId MsgServer_CommandDisabled     	= new ErrorId( ErrorOf( ES_SERVER, 600, E_FAILED, EV_ADMIN, 1 , "824385112"),  "Operation '%commandName%' disabled on this server." ) ;
    public static final ErrorId MsgServer_CommunicationLoop   	= new ErrorId( ErrorOf( ES_SERVER, 576, E_FAILED, EV_USAGE, 1 , "822156864"),  "Server %serverID% may not send a message to itself."  ) ;
    public static final ErrorId MsgServer_ConfigureNone       	= new ErrorId( ErrorOf( ES_SERVER, 466, E_INFO, 0, 3 , "318774738"),  "No configurables have been set."  ) ;
    public static final ErrorId MsgServer_ConfigureServerNone 	= new ErrorId( ErrorOf( ES_SERVER, 467, E_INFO, 0, 3 , "318774739"),  "No configurables have been set for server '%serverName%'."  ) ;
    public static final ErrorId MsgServer_ConfigureSet        	= new ErrorId( ErrorOf( ES_SERVER, 437, E_INFO, 0, 3 , "318774709"),  "For server '%serverName%', configuration variable '%variableName%' set to '%variableValue%'"  ) ;
    public static final ErrorId MsgServer_ConfigureUnSet      	= new ErrorId( ErrorOf( ES_SERVER, 438, E_INFO, 0, 2 , "301997494"),  "For server '%serverName%', configuration variable '%variableName%' removed."  ) ;
    public static final ErrorId MsgServer_ConnectBroken       	= new ErrorId( ErrorOf( ES_SERVER, 28, E_FAILED, EV_COMM, 1 , "824581148"),  "Connection from %peerAddress% broken."  ) ;
    public static final ErrorId MsgServer_CopyDoNothing       	= new ErrorId( ErrorOf( ES_SERVER, 521, E_FAILED, EV_USAGE, 1 , "822156809"),  "Stream %stream% not configured to 'copy' or 'merge' changes in this direction."  ) ;
    public static final ErrorId MsgServer_CopyNeedsMergeFirst 	= new ErrorId( ErrorOf( ES_SERVER, 522, E_FAILED, EV_USAGE, 1 , "822156810"),  "Stream %stream% cannot 'copy' over outstanding 'merge' changes."  ) ;
    public static final ErrorId MsgServer_CopyWrongDirection  	= new ErrorId( ErrorOf( ES_SERVER, 520, E_FAILED, EV_USAGE, 1 , "822156808"),  "Stream %stream% needs 'merge' not 'copy' in this direction."  ) ;
    public static final ErrorId MsgServer_CouldntLock         	= new ErrorId( ErrorOf( ES_SERVER, 43, E_FAILED, EV_NOTYET, 0 , "805641259"),  "File(s) couldn't be locked."  ) ;
    public static final ErrorId MsgServer_CounterDelete       	= new ErrorId( ErrorOf( ES_SERVER, 100, E_INFO, 0, 1 , "285219940"),  "Counter %counterName% deleted."  ) ;
    public static final ErrorId MsgServer_CounterGet          	= new ErrorId( ErrorOf( ES_SERVER, 102, E_INFO, 0, 1 , "285219942"),  "%counterValue%"  ) ;
    public static final ErrorId MsgServer_CounterNotNumeric   	= new ErrorId( ErrorOf( ES_SERVER, 423, E_FAILED, EV_USAGE, 1 , "822156711"),  "Can't increment counter '%counterName%' - value is not numeric."  ) ;
    public static final ErrorId MsgServer_CounterSet          	= new ErrorId( ErrorOf( ES_SERVER, 101, E_INFO, 0, 1 , "285219941"),  "Counter %counterName% set."  ) ;
    public static final ErrorId MsgServer_CounterWarning      	= new ErrorId( ErrorOf( ES_SERVER, 518, E_WARN, EV_NONE, 3 , "587210246"),  "Warning: '%counterName%' counter is now %counterValue%, maximum allowed is %counterMax%"  ) ;
    public static final ErrorId MsgServer_CreatingDb	       	= new ErrorId( ErrorOf( ES_SERVER, 340, E_INFO, EV_NONE, 1 , "285220180"),  "Perforce db files in '%root%' will be created if missing..."  ) ;
    public static final ErrorId MsgServer_CurJournalButNotJournaling 	= new ErrorId( ErrorOf( ES_SERVER, 432, E_FAILED, EV_ADMIN, 0 , "807607728"),  "The current journal may not be exported because journaling is disabled."  ) ;
    public static final ErrorId MsgServer_DeltaLine1          	= new ErrorId( ErrorOf( ES_SERVER, 135, E_INFO, 0, 2 , "301997191"),  "%lower%: %data%"  ) ;
    public static final ErrorId MsgServer_DeltaLine2          	= new ErrorId( ErrorOf( ES_SERVER, 136, E_INFO, 0, 3 , "318774408"),  "%lower%-%upper%: %data%"  ) ;
    public static final ErrorId MsgServer_DescribeAffected    	= new ErrorId( ErrorOf( ES_SERVER, 104, E_INFO, 0, 0 , "268442728"),  "Affected files ...\n"  ) ;
    public static final ErrorId MsgServer_DescribeDifferences 	= new ErrorId( ErrorOf( ES_SERVER, 105, E_INFO, 0, 0 , "268442729"),  "\nDifferences ..."  ) ;
    public static final ErrorId MsgServer_DescribeEmpty       	= new ErrorId( ErrorOf( ES_SERVER, 106, E_INFO, 0, 0 , "268442730"),  ""  ) ;
    public static final ErrorId MsgServer_DescribeFixed       	= new ErrorId( ErrorOf( ES_SERVER, 103, E_INFO, 0, 0 , "268442727"),  "Jobs fixed ...\n"  ) ;
    public static final ErrorId MsgServer_DescribeMovedFiles  	= new ErrorId( ErrorOf( ES_SERVER, 377, E_INFO, 0, 0 , "268443001"),  "\nMoved files ...\n"  ) ;
    public static final ErrorId MsgServer_DescribeShelved     	= new ErrorId( ErrorOf( ES_SERVER, 409, E_INFO, 0, 0 , "268443033"),  "Shelved files ...\n"  ) ;
    public static final ErrorId MsgServer_Diff2BadArgs        	= new ErrorId( ErrorOf( ES_SERVER, 292, E_FAILED, EV_USAGE, 0 , "805379364"),  "File argument(s) require filepath(s), see 'p4 help diff2'."  ) ;
    public static final ErrorId MsgServer_Diff2Differ         	= new ErrorId( ErrorOf( ES_SERVER, 107, E_INFO, 0, 0 , "268442731"),  "(... files differ ...)"  ) ;
    public static final ErrorId MsgServer_DiffCmp             	= new ErrorId( ErrorOf( ES_SERVER, 133, E_INFO, 0, 1 , "285219973"),  "%path%"  ) ;
    public static final ErrorId MsgServer_DiffList            	= new ErrorId( ErrorOf( ES_SERVER, 134, E_INFO, 0, 2 , "301997190"),  "%status% %path%"  ) ;
    public static final ErrorId MsgServer_DigestMisMatch      	= new ErrorId( ErrorOf( ES_SERVER, 465, E_FAILED, EV_CLIENT, 3 , "857873873"),  "%clientFile% corrupted during transfer %clientDigest% vs %serverDigest%"  ) ;
    public static final ErrorId MsgServer_DirsWild            	= new ErrorId( ErrorOf( ES_SERVER, 52, E_FAILED, EV_USAGE, 0 , "805379124"),  "Wildcard ... not allowed by 'p4 dirs'.  Use * instead."  ) ;
    public static final ErrorId MsgServer_DumpNameIsADbName   	= new ErrorId( ErrorOf( ES_SERVER, 621, E_FAILED, EV_USAGE, 1 , "822156909"),  "Cannot specify db name %dbname% as a dump file name."  ) ;
    public static final ErrorId MsgServer_EmptyTypeList        	= new ErrorId( ErrorOf( ES_SERVER, 445, E_FAILED, EV_UNKNOWN, 1 , "822222269"),  "The list of fields may not be empty."  ) ;
    public static final ErrorId MsgServer_ErrorInSpec         	= new ErrorId( ErrorOf( ES_SERVER, 323, E_FAILED, EV_ILLEGAL, 1 , "822353219"),  "Error in %domain% specification."  ) ;
    public static final ErrorId MsgServer_ErrorPingParam     	= new ErrorId( ErrorOf( ES_SERVER, 417, E_FAILED, 0, 1 , "822091169"),  "Invalid ping parameter"  ) ;
    public static final ErrorId MsgServer_ErrorPingProtocol   	= new ErrorId( ErrorOf( ES_SERVER, 397, E_FAILED, 0, 1 , "822091149"),  "ping remote buffers requires 9.2"  ) ;
    public static final ErrorId MsgServer_ExtraIDUsage        	= new ErrorId( ErrorOf( ES_SERVER, 567, E_FAILED, EV_USAGE, 0 , "805379639"),  "Usage: p4d -xD [ serverID ]"  ) ;
    public static final ErrorId MsgServer_GotLocked           	= new ErrorId( ErrorOf( ES_SERVER, 10, E_FAILED, EV_FAULT, 3 , "857807882"),  "%depotFile% was just locked by %user% on %client%!"  ) ;
    public static final ErrorId MsgServer_GotUnlocked         	= new ErrorId( ErrorOf( ES_SERVER, 9, E_FAILED, EV_FAULT, 1 , "824253449"),  "%depotFile% became unlocked!"  ) ;
    public static final ErrorId MsgServer_GotUnresolved       	= new ErrorId( ErrorOf( ES_SERVER, 13, E_FATAL, EV_FAULT, 1 , "1092688909"),  "%toFile% got unresolved!"  ) ;
    public static final ErrorId MsgServer_GrepContextTooLarge 	= new ErrorId( ErrorOf( ES_DM, 434, E_FAILED, 0, 2 , "838867378"),  "%context%: larger than maximum of %maxcontext%"  ) ;
    public static final ErrorId MsgServer_GrepIllegalContext  	= new ErrorId( ErrorOf( ES_DM, 433, E_FAILED, 0, 1 , "822090161"),  "%context%: invalid context length argument"  ) ;
    public static final ErrorId MsgServer_HandshakeFailed     	= new ErrorId( ErrorOf( ES_SERVER, 27, E_FAILED, EV_COMM, 0 , "807803931"),  "Handshake failed."  ) ;
    public static final ErrorId MsgServer_HelpSeeRename       	= new ErrorId( ErrorOf( ES_SERVER, 53, E_WARN, EV_USAGE, 0 , "536943669"),  "See 'p4 help rename' for instructions on renaming files."  ) ;
    public static final ErrorId MsgServer_IllegalCommand      	= new ErrorId( ErrorOf( ES_SERVER, 329, E_FAILED, EV_USAGE, 0 , "805379401"),  "Illegal command usage.  Try 'p4 help' for info."  ) ;
    public static final ErrorId MsgServer_ImportReport        	= new ErrorId( ErrorOf( ES_SERVER, 361, E_INFO, EV_NONE, 1 , "285220201"),  "Imported %count% journal record(s)."  ) ;
    public static final ErrorId MsgServer_IndexOutput         	= new ErrorId( ErrorOf( ES_SERVER, 108, E_INFO, 0, 1 , "285219948"),  "%value% words added/deleted."  ) ;
    public static final ErrorId MsgServer_InfoAuthServer      	= new ErrorId( ErrorOf( ES_SERVER, 140, E_INFO, 0, 1 , "285219980"),  "Authorization server: %authServer%"  ) ;
    public static final ErrorId MsgServer_InfoBadClient       	= new ErrorId( ErrorOf( ES_SERVER, 112, E_INFO, 0, 1 , "285219952"),  "Client name: %client% (illegal)"  ) ;
    public static final ErrorId MsgServer_InfoBadUser         	= new ErrorId( ErrorOf( ES_SERVER, 110, E_INFO, 0, 1 , "285219950"),  "User name: %user% (illegal)"  ) ;
    public static final ErrorId MsgServer_InfoCaseHandling    	= new ErrorId( ErrorOf( ES_SERVER, 426, E_INFO, 0, 1 , "285220266"),  "Case Handling: %caseHandling%"  ) ;
    public static final ErrorId MsgServer_InfoChangeServer    	= new ErrorId( ErrorOf( ES_SERVER, 370, E_INFO, 0, 1 , "285220210"),  "Changelist server: %changeServer%"  ) ;
    public static final ErrorId MsgServer_InfoClient          	= new ErrorId( ErrorOf( ES_SERVER, 111, E_INFO, 0, 1 , "285219951"),  "Client name: %client%"  ) ;
    public static final ErrorId MsgServer_InfoClientAddress   	= new ErrorId( ErrorOf( ES_SERVER, 115, E_INFO, 0, 1 , "285219955"),  "Client address: %clientAddr%"  ) ;
    public static final ErrorId MsgServer_InfoClientRoot      	= new ErrorId( ErrorOf( ES_SERVER, 138, E_INFO, 0, 1 , "285219978"),  "Client root: %root%"  ) ;
    public static final ErrorId MsgServer_InfoDirectory       	= new ErrorId( ErrorOf( ES_SERVER, 114, E_INFO, 0, 1 , "285219954"),  "Current directory: %dirName%"  ) ;
    public static final ErrorId MsgServer_InfoDiskSpace       	= new ErrorId( ErrorOf( ES_SERVER, 514, E_INFO, 0, 6 , "369106434"),  "%name% (type %fsType%) : %freeBytes% free, %usedBytes% used, %totalBytes% total (%pctUsed%%% full)"  ) ;
    public static final ErrorId MsgServer_InfoHost            	= new ErrorId( ErrorOf( ES_SERVER, 113, E_INFO, 0, 1 , "285219953"),  "Client host: %host%"  ) ;
    public static final ErrorId MsgServer_InfoMinClient       	= new ErrorId( ErrorOf( ES_SERVER, 431, E_INFO, 0, 1 , "285220271"),  "Minimum Client Level: %minClient%"  ) ;
    public static final ErrorId MsgServer_InfoPeerAddress     	= new ErrorId( ErrorOf( ES_SERVER, 584, E_INFO, 0, 1 , "285220424"),  "Peer address: %peerAddr%"  ) ;
    public static final ErrorId MsgServer_InfoPingCount       	= new ErrorId( ErrorOf( ES_SERVER, 395, E_INFO, 0, 1 , "285220235"),  "%time% for %fileCount%  messages"  ) ;
    public static final ErrorId MsgServer_InfoPingCountB      	= new ErrorId( ErrorOf( ES_SERVER, 396, E_INFO, 0, 1 , "285220236"),  "%time% for %fileCount% messages of %fileSize% characters"  ) ;
    public static final ErrorId MsgServer_InfoPingTime        	= new ErrorId( ErrorOf( ES_SERVER, 393, E_INFO, 0, 1 , "285220233"),  "%fileCount% messages in %time%"  ) ;
    public static final ErrorId MsgServer_InfoPingTimeB       	= new ErrorId( ErrorOf( ES_SERVER, 394, E_INFO, 0, 1 , "285220234"),  "%fileCount% messages of %fileSize% characters in %time%"  ) ;
    public static final ErrorId MsgServer_InfoProxyAddress    	= new ErrorId( ErrorOf( ES_SERVER, 499, E_INFO, 0, 1 , "285220339"),  "Proxy address: %clientAddr%"  ) ;
    public static final ErrorId MsgServer_InfoProxyCertExpire 	= new ErrorId( ErrorOf( ES_SERVER, 585, E_INFO, 0, 1 , "285220425"),  "Proxy cert expires: %proxyCertExpire%"  ) ;
    public static final ErrorId MsgServer_InfoProxyEncryption  	= new ErrorId( ErrorOf( ES_SERVER, 586, E_INFO, 0, 1 , "285220426"),  "Proxy encryption: %proxyEncryption%"  ) ;
    public static final ErrorId MsgServer_InfoProxyVersion    	= new ErrorId( ErrorOf( ES_SERVER, 139, E_INFO, 0, 2 , "301997195"),  "Proxy version: %id% (%idDate%)"  ) ;
    public static final ErrorId MsgServer_InfoServerAddress   	= new ErrorId( ErrorOf( ES_SERVER, 116, E_INFO, 0, 1 , "285219956"),  "Server address: %serverAddr%"  ) ;
    public static final ErrorId MsgServer_InfoServerCertExpire 	= new ErrorId( ErrorOf( ES_SERVER, 585, E_INFO, 0, 1 , "285220425"),  "Server cert expires: %serverCertExpire%"  ) ;
    public static final ErrorId MsgServer_InfoServerDate      	= new ErrorId( ErrorOf( ES_SERVER, 118, E_INFO, 0, 2 , "301997174"),  "Server date: %serverDate% %serverTimeZone%"  ) ;
    public static final ErrorId MsgServer_InfoServerEncryption 	= new ErrorId( ErrorOf( ES_SERVER, 585, E_INFO, 0, 1 , "285220425"),  "Server encryption: %serverEncryption%"  ) ;
    public static final ErrorId MsgServer_InfoServerID        	= new ErrorId( ErrorOf( ES_SERVER, 598, E_INFO, 0, 1 , "285220438"),  "ServerID: %ServerID%"  ) ;
    public static final ErrorId MsgServer_InfoServerLicense   	= new ErrorId( ErrorOf( ES_SERVER, 120, E_INFO, 0, 1 , "285219960"),  "Server license: %license%"  ) ;
    public static final ErrorId MsgServer_InfoServerLicenseIp 	= new ErrorId( ErrorOf( ES_SERVER, 382, E_INFO, 0, 1 , "285220222"),  "Server license-ip: %licenseIp%"  ) ;
    public static final ErrorId MsgServer_InfoServerRoot      	= new ErrorId( ErrorOf( ES_SERVER, 117, E_INFO, 0, 1 , "285219957"),  "Server root: %serverRoot%"  ) ;
    public static final ErrorId MsgServer_InfoServerUptime    	= new ErrorId( ErrorOf( ES_SERVER, 367, E_INFO, 0, 1 , "285220207"),  "Server uptime: %uptime%"  ) ;
    public static final ErrorId MsgServer_InfoServerVersion   	= new ErrorId( ErrorOf( ES_SERVER, 119, E_INFO, 0, 2 , "301997175"),  "Server version: %id% (%idDate%)"  ) ;
    public static final ErrorId MsgServer_InfoStream          	= new ErrorId( ErrorOf( ES_SERVER, 449, E_INFO, 0, 1 , "285220289"),  "Client stream: %stream%"  ) ;
    public static final ErrorId MsgServer_InfoUnknownClient   	= new ErrorId( ErrorOf( ES_SERVER, 137, E_INFO, 0, 0 , "268442761"),  "Client unknown."  ) ;
    public static final ErrorId MsgServer_InfoUser            	= new ErrorId( ErrorOf( ES_SERVER, 109, E_INFO, 0, 1 , "285219949"),  "User name: %user%"  ) ;
    public static final ErrorId MsgServer_IntegIsTask         	= new ErrorId( ErrorOf( ES_SERVER, 631, E_FAILED, EV_USAGE, 1 , "822156919"),  "Target of integration '%stream%' requires an appropriate task stream client."  ) ;
    public static final ErrorId MsgServer_InvalidConfigValue  	= new ErrorId( ErrorOf( ES_SERVER, 440, E_FAILED, EV_USAGE, 0 , "805379512"),  "Configuration variable '%name%' may not be set to '%value%'."  ) ;
    public static final ErrorId MsgServer_InvalidNesting      	= new ErrorId( ErrorOf( ES_SERVER, 528, E_FATAL, EV_FAULT, 2 , "1109466640"),  "Command %outerCommand% was unexpectedly interrupted by command %nestedCommand%"  ) ;
    public static final ErrorId MsgServer_InvalidServerChain  	= new ErrorId( ErrorOf( ES_SERVER, 505, E_FAILED, EV_USAGE, 1 , "822156793"),  "%serverType% servers may not be chained."  ) ;
    public static final ErrorId MsgServer_InvalidStartupCommand 	= new ErrorId( ErrorOf( ES_SERVER, 448, E_FAILED, EV_ADMIN, 1 , "824384960"),  "Startup command '%cmd%' is unknown or invalid."  ) ;
    public static final ErrorId MsgServer_IstatInvalid        	= new ErrorId( ErrorOf( ES_SERVER, 460, E_FAILED, EV_USAGE, 1 , "822156748"),  "Stream '%stream%' is invalid, use -f to force check." ) ;
    public static final ErrorId MsgServer_JobRebuilt          	= new ErrorId( ErrorOf( ES_SERVER, 131, E_INFO, 0, 1 , "285219971"),  "%job% ..."  ) ;
    public static final ErrorId MsgServer_Jobs982Win          	= new ErrorId( ErrorOf( ES_SERVER, 33, E_FAILED, EV_UPGRADE, 0 , "807738401"),  "Must upgrade to 98.2 p4win to access jobs."  ) ;
    public static final ErrorId MsgServer_JobsDashS           	= new ErrorId( ErrorOf( ES_SERVER, 34, E_FAILED, EV_USAGE, 2 , "838933538"),  "'jobs -s %status%' no longer supported; use 'jobs -e status=%status%."  ) ;
    public static final ErrorId MsgServer_JournalCounterMismatch  	= new ErrorId( ErrorOf( ES_SERVER, 531, E_WARN, EV_NONE, 2 , "570433043"),  "Journal Counter Rotation Mismatch counter %counter% should be %journal%"  ) ;
    public static final ErrorId MsgServer_JournalFilterBad    	= new ErrorId( ErrorOf( ES_SERVER, 647, E_FAILED, EV_USAGE, 0 , "805379719"),  "-P filter patterns must take the form: [ic:|xc:|if:|xf:]//pattern"  ) ;
    public static final ErrorId MsgServer_JournalorCheckpointRequired 	= new ErrorId( ErrorOf( ES_SERVER, 388, E_FAILED, EV_ADMIN, 0 , "807607684"),  "A journal or checkpoint number is required (-j or -c)"  ) ;
    public static final ErrorId MsgServer_KeyDelete           	= new ErrorId( ErrorOf( ES_SERVER, 626, E_INFO, 0, 1 , "285220466"),  "Key %counterName% deleted."  ) ;
    public static final ErrorId MsgServer_KeyNotNumeric   	= new ErrorId( ErrorOf( ES_SERVER, 629, E_FAILED, EV_USAGE, 1 , "822156917"),  "Can't increment key '%keyName%' - value is not numeric."  ) ;
    public static final ErrorId MsgServer_KeySet              	= new ErrorId( ErrorOf( ES_SERVER, 627, E_INFO, 0, 1 , "285220467"),  "Key %counterName% set."  ) ;
    public static final ErrorId MsgServer_LbrCheckin          	= new ErrorId( ErrorOf( ES_SERVER, 5, E_FAILED, EV_FAULT, 1 , "824253445"),  "Librarian checkin %lbrFile% failed."  ) ;
    public static final ErrorId MsgServer_LbrCheckout         	= new ErrorId( ErrorOf( ES_SERVER, 1, E_FAILED, EV_FAULT, 1 , "824253441"),  "Librarian checkout %lbrFile% failed."  ) ;
    public static final ErrorId MsgServer_LbrDiff             	= new ErrorId( ErrorOf( ES_SERVER, 2, E_FAILED, EV_FAULT, 1 , "824253442"),  "Librarian diff %lbrFile% failed."  ) ;
    public static final ErrorId MsgServer_LbrDigest           	= new ErrorId( ErrorOf( ES_SERVER, 3, E_FAILED, EV_FAULT, 1 , "824253443"),  "Librarian digest %lbrFile% failed."  ) ;
    public static final ErrorId MsgServer_LbrFileSize         	= new ErrorId( ErrorOf( ES_SERVER, 4, E_FAILED, EV_FAULT, 1 , "824253444"),  "Librarian filesize %lbrFile% failed."  ) ;
    public static final ErrorId MsgServer_LbrMerge            	= new ErrorId( ErrorOf( ES_SERVER, 6, E_FAILED, EV_FAULT, 0 , "807476230"),  "Librarian merge failed."  ) ;
    public static final ErrorId MsgServer_LbrNoTrigger        	= new ErrorId( ErrorOf( ES_SERVER, 390, E_FAILED, EV_ADMIN, 1 , "824384902"),  "No archive trigger defined for %lbrFile%."  ) ;
    public static final ErrorId MsgServer_LogCommand          	= new ErrorId( ErrorOf( ES_SERVER, 55, E_INFO, EV_NONE, 1 , "285219895"),  "%text%"  ) ;
    public static final ErrorId MsgServer_LogEstimates        	= new ErrorId( ErrorOf( ES_SERVER, 632, E_INFO, EV_NONE, 5 , "352329336"),  "Server network estimates: files added/updated/deleted=%filesAdded%/%filesUpdated%/%filesDeleted%, bytes added/updated=%bytesAdded%/%bytesUpdated%"  ) ;
    public static final ErrorId MsgServer_LoggedOut           	= new ErrorId( ErrorOf( ES_SERVER, 318, E_FAILED, EV_ILLEGAL, 0 , "805575998"),  "Your session was logged out, please login again."  ) ;
    public static final ErrorId MsgServer_Login032            	= new ErrorId( ErrorOf( ES_SERVER, 319, E_FAILED, EV_UPGRADE, 0 , "807738687"),  "Only 2003.2 or later clients support 'p4 login' at this server security level."  ) ;
    public static final ErrorId MsgServer_Login042            	= new ErrorId( ErrorOf( ES_SERVER, 335, E_FAILED, EV_UPGRADE, 0 , "807738703"),  "Only 2004.2 or later clients support 'p4 login' for external authentication."  ) ;
    public static final ErrorId MsgServer_Login072            	= new ErrorId( ErrorOf( ES_SERVER, 355, E_FAILED, EV_UPGRADE, 0 , "807738723"),  "Only 2007.2 or later clients support 'p4 login' for single sign-on."  ) ;
    public static final ErrorId MsgServer_LoginExpired       	= new ErrorId( ErrorOf( ES_SERVER, 312, E_FAILED, EV_ILLEGAL, 0 , "805575992"),  "Your session has expired, please login again."  ) ;
    public static final ErrorId MsgServer_LoginGoodTill      	= new ErrorId( ErrorOf( ES_SERVER, 326, E_INFO, EV_NONE, 4 , "335551814"),  "User %user% ticket expires in %hours% hours %minutes% minutes."  ) ;
    public static final ErrorId MsgServer_LoginNoTicket      	= new ErrorId( ErrorOf( ES_SERVER, 327, E_INFO, EV_NONE, 4 , "335551815"),  "User %user% was authenticated by password not ticket."  ) ;
    public static final ErrorId MsgServer_LoginNotRequired     	= new ErrorId( ErrorOf( ES_SERVER, 313, E_INFO, EV_NONE, 0 , "268442937"),  "'login' not necessary, no password set for this user."  ) ;
    public static final ErrorId MsgServer_LoginPrintTicket     	= new ErrorId( ErrorOf( ES_SERVER, 314, E_INFO, EV_NONE, 1 , "285220154"),  "%ticket%"  ) ;
    public static final ErrorId MsgServer_LoginUser          	= new ErrorId( ErrorOf( ES_SERVER, 325, E_INFO, EV_NONE, 1 , "285220165"),  "User %user% logged in."  ) ;
    public static final ErrorId MsgServer_LogoutUser          	= new ErrorId( ErrorOf( ES_SERVER, 315, E_INFO, EV_NONE, 1 , "285220155"),  "User %user% logged out."  ) ;
    public static final ErrorId MsgServer_LogtailNoLog  	= new ErrorId( ErrorOf( ES_SERVER, 389, E_WARN, EV_ADMIN, 0 , "539172229"),  "Perforce server is not logging to an errorLog."  ) ;
    public static final ErrorId MsgServer_MaxLicensedFiles    	= new ErrorId( ErrorOf( ES_SERVER, 463, E_FAILED, EV_ADMIN, 1 , "824384975"),  "Maximum licensed files (%files%) exceeded."  ) ;
    public static final ErrorId MsgServer_MaxUnLicensedFiles  	= new ErrorId( ErrorOf( ES_SERVER, 464, E_FAILED, EV_ADMIN, 1 , "824384976"),  "Maximum users/clients AND maximum files (%files%) exceeded."  ) ;
    public static final ErrorId MsgServer_MergeWrongDirection 	= new ErrorId( ErrorOf( ES_SERVER, 526, E_FAILED, EV_USAGE, 1 , "822156814"),  "Stream %stream% needs 'copy' not 'merge' in this direction."  ) ;
    public static final ErrorId MsgServer_MergesPending       	= new ErrorId( ErrorOf( ES_SERVER, 44, E_FAILED, EV_NOTYET, 0 , "805641260"),  "Merges still pending -- use 'resolve' to merge files."  ) ;
    public static final ErrorId MsgServer_MetaDumpFailed      	= new ErrorId( ErrorOf( ES_SERVER, 19, E_FAILED, EV_FAULT, 1 , "824253459"),  "%file%: metadata dump failed"  ) ;
    public static final ErrorId MsgServer_MimAttack            	= new ErrorId( ErrorOf( ES_SERVER, 429, E_FAILED, EV_ILLEGAL, 1 , "822353325"),  "Problem with TCP connections between client and server"  ) ;
    public static final ErrorId MsgServer_MissingReplicationMode 	= new ErrorId( ErrorOf( ES_SERVER, 469, E_FAILED, EV_FAULT, 1 , "824253909"),  "Missing replication mode: please specify %missingMode%."  ) ;
    public static final ErrorId MsgServer_MonitorBadId        	= new ErrorId( ErrorOf( ES_SERVER, 138, E_FAILED, EV_USAGE, 1 , "822156426"),  "Invalid session identifier: %id%"  ) ;
    public static final ErrorId MsgServer_MonitorDisabled     	= new ErrorId( ErrorOf( ES_SERVER, 137, E_FAILED, EV_ADMIN, 0 , "807607433"),  "Monitor not currently enabled."  ) ;
    public static final ErrorId MsgServer_Move091             	= new ErrorId( ErrorOf( ES_SERVER, 376, E_FAILED, EV_UPGRADE, 0 , "807738744"),  "Only 2009.1 or later clients support 'p4 move'."  ) ;
    public static final ErrorId MsgServer_Move101             	= new ErrorId( ErrorOf( ES_SERVER, 425, E_FAILED, EV_UPGRADE, 0 , "807738793"),  "Only 2010.1 or later clients support 'p4 move -f'."  ) ;
    public static final ErrorId MsgServer_MoveRejected        	= new ErrorId( ErrorOf( ES_SERVER, 542, E_FAILED, EV_ADMIN, 0 , "807607838"),  "Operation 'move' disabled on this server." ) ;
    public static final ErrorId MsgServer_MustSetPassword     	= new ErrorId( ErrorOf( ES_SERVER, 307, E_FAILED, EV_USAGE, 0 , "805379379"),  "Password must be set before access can be granted."  ) ;
    public static final ErrorId MsgServer_NeedFilePath         	= new ErrorId( ErrorOf( ES_SERVER, 532, E_FAILED, EV_USAGE, 1 , "822156820"),  "Empty file path not allowed in '%filespec%'."  ) ;
    public static final ErrorId MsgServer_No973Wingui         	= new ErrorId( ErrorOf( ES_SERVER, 302, E_FAILED, EV_UPGRADE, 0 , "807738670"),  "Must upgrade past 97.3 p4win for this operation."  ) ;
    public static final ErrorId MsgServer_NoAuthFileCount     	= new ErrorId( ErrorOf( ES_SERVER, 476, E_FAILED, EV_ADMIN, 0 , "807607772"),  "Files limited license cannot perform remote authentication."  ) ;
    public static final ErrorId MsgServer_NoAuthServiceOnly   	= new ErrorId( ErrorOf( ES_SERVER, 590, E_FAILED, EV_ADMIN, 0 , "807607886"),  "Service limited license cannot perform remote authentication."  ) ;
    public static final ErrorId MsgServer_NoCentralLicense    	= new ErrorId( ErrorOf( ES_SERVER, 472, E_FAILED, EV_ADMIN, 0 , "807607768"),  "Unlicensed server cannot perform remote authentication."  ) ;
    public static final ErrorId MsgServer_NoCkptName          	= new ErrorId( ErrorOf( ES_SERVER, 16, E_FAILED, EV_USAGE, 0 , "805379088"),  "Must specify checkpoint/journal files."  ) ;
    public static final ErrorId MsgServer_NoClearText         	= new ErrorId( ErrorOf( ES_SERVER, 311, E_FAILED, EV_UPGRADE, 0 , "807738679"),  "This operation is not permitted at this server security level."  ) ;
    public static final ErrorId MsgServer_NoCustomSpec 	= new ErrorId( ErrorOf( ES_SERVER, 475, E_FAILED, EV_ADMIN, 1 , "824384987"),  "Custom spec of type '%specType%' is not allowed. Set spec.custom=1 to override."  ) ;
    public static final ErrorId MsgServer_NoDefaultShelve     	= new ErrorId( ErrorOf( ES_SERVER, 402, E_FAILED, EV_EMPTY, 0 , "806428050"),  "No files to shelve from the default changelist."  ) ;
    public static final ErrorId MsgServer_NoDefaultSubmit     	= new ErrorId( ErrorOf( ES_SERVER, 50, E_FAILED, EV_EMPTY, 0 , "806427698"),  "No files to submit from the default changelist."  ) ;
    public static final ErrorId MsgServer_NoDumpName          	= new ErrorId( ErrorOf( ES_SERVER, 15, E_FAILED, EV_USAGE, 0 , "805379087"),  "Must specify dump file."  ) ;
    public static final ErrorId MsgServer_NoInteg             	= new ErrorId( ErrorOf( ES_SERVER, 11, E_FATAL, EV_FAULT, 1 , "1092688907"),  "%depotFile% missing integration record!"  ) ;
    public static final ErrorId MsgServer_NoProxyAuth          	= new ErrorId( ErrorOf( ES_SERVER, 369, E_FAILED, EV_ILLEGAL, 1 , "822353265"),  "Authentication from resolved port '%port%' not allowed!"  ) ;
    public static final ErrorId MsgServer_NoServerID          	= new ErrorId( ErrorOf( ES_SERVER, 569, E_FAILED, EV_USAGE, 0 , "805379641"),  "Server does not yet have a server ID."  ) ;
    public static final ErrorId MsgServer_NoShelve            	= new ErrorId( ErrorOf( ES_SERVER, 406, E_FAILED, EV_EMPTY, 0 , "806428054"),  "No files to shelve."  ) ;
    public static final ErrorId MsgServer_NoShelveDelete      	= new ErrorId( ErrorOf( ES_SERVER, 411, E_FAILED, EV_EMPTY, 0 , "806428059"),  "No shelved files in changelist to delete."  ) ;
    public static final ErrorId MsgServer_NoSubmit            	= new ErrorId( ErrorOf( ES_SERVER, 46, E_FAILED, EV_EMPTY, 0 , "806427694"),  "No files to submit."  ) ;
    public static final ErrorId MsgServer_NoSuchField          	= new ErrorId( ErrorOf( ES_SERVER, 444, E_FAILED, EV_UNKNOWN, 1 , "822222268"),  "Field %field% doesn't exist."  ) ;
    public static final ErrorId MsgServer_NoSuchTransfer      	= new ErrorId( ErrorOf( ES_SERVER, 644, E_FAILED, EV_ADMIN, 2 , "841162372"),  "File %lbrFile% revision %lbrRev% is not currently scheduled to be transferred."  ) ;
    public static final ErrorId MsgServer_NoSuchUser          	= new ErrorId( ErrorOf( ES_SERVER, 37, E_FAILED, EV_UNKNOWN, 1 , "822221861"),  "User %user% doesn't exist."  ) ;
    public static final ErrorId MsgServer_NoSuppASflag        	= new ErrorId( ErrorOf( ES_SERVER, 40, E_FAILED, EV_UPGRADE, 0 , "807738408"),  "Your client doesn't support the -as flag."  ) ;
    public static final ErrorId MsgServer_NoSuppVflag         	= new ErrorId( ErrorOf( ES_SERVER, 41, E_FAILED, EV_UPGRADE, 0 , "807738409"),  "Your client doesn't support the -v flag."  ) ;
    public static final ErrorId MsgServer_NoTicketSupport     	= new ErrorId( ErrorOf( ES_SERVER, 331, E_WARN, EV_USAGE, 0 , "536943947"),  "Must upgrade to 2004.2 p4 to access tickets."  ) ;
    public static final ErrorId MsgServer_NoUserLogs          	= new ErrorId( ErrorOf( ES_SERVER, 638, E_WARN, EV_ADMIN, 0 , "539172478"),  "No serverlog.file configurables specify logs which capture user log records."  ) ;
    public static final ErrorId MsgServer_NoValidLicense      	= new ErrorId( ErrorOf( ES_SERVER, 58, E_FAILED, EV_ADMIN, 0 , "807607354"),  "Must shutdown unlicensed server to add license."  ) ;
    public static final ErrorId MsgServer_NotAsService      	= new ErrorId( ErrorOf( ES_SERVER, 443, E_FAILED, EV_USAGE, 0 , "805379515"),  "Service user may not login to all hosts."  ) ;
    public static final ErrorId MsgServer_NotStreamOwner       	= new ErrorId( ErrorOf( ES_SERVER, 473, E_FAILED, EV_USAGE, 2 , "838933977"),  "Currently only user '%user%' can submit to stream '%stream%'."  ) ;
    public static final ErrorId MsgServer_NotStreamReady       	= new ErrorId( ErrorOf( ES_SERVER, 447, E_FAILED, EV_USAGE, 1 , "822156735"),  "Client '%client%' requires an application that can fully support streams."  ) ;
    public static final ErrorId MsgServer_NotThisConfigVar    	= new ErrorId( ErrorOf( ES_SERVER, 439, E_FAILED, EV_USAGE, 0 , "805379511"),  "Configuration variable '%name%' may not be changed."  ) ;
    public static final ErrorId MsgServer_OldDiffClient       	= new ErrorId( ErrorOf( ES_SERVER, 31, E_FAILED, EV_UPGRADE, 0 , "807738399"),  "Client doesn't have necessary support for diff -s."  ) ;
    public static final ErrorId MsgServer_OldReconcileClient       	= new ErrorId( ErrorOf( ES_SERVER, 583, E_FAILED, EV_UPGRADE, 0 , "807738951"),  "Client doesn't have necessary support for reconcile."  ) ;
    public static final ErrorId MsgServer_OnlyOneFilter       	= new ErrorId( ErrorOf( ES_SERVER, 533, E_FAILED, EV_USAGE, 0 , "805379605"),  "Specify either -e or -E, not both."  ) ;
    public static final ErrorId MsgServer_OperationDate       	= new ErrorId( ErrorOf( ES_SERVER, 25, E_FAILED, EV_FAULT, 1 , "824253465"),  "Date %date%:"  ) ;
    public static final ErrorId MsgServer_OperationFailed     	= new ErrorId( ErrorOf( ES_SERVER, 24, E_FAILED, EV_FAULT, 1 , "824253464"),  "Operation: %command%"  ) ;
    public static final ErrorId MsgServer_P4TARGETWasSet         	= new ErrorId( ErrorOf( ES_SERVER, 615, E_FAILED, EV_FAULT, 0 , "807476839"),  "It appears that the P4TARGET configurable was set for this server, indicating it is a replica server of some type. If that was incorrect, issue the command 'p4d -cshow' to display configurable settings, and issue the command 'p4d \"-cunset P4TARGET\"' to delete the incorrect P4TARGET setting."  ) ;
    public static final ErrorId MsgServer_Password032         	= new ErrorId( ErrorOf( ES_SERVER, 310, E_FAILED, EV_UPGRADE, 0 , "807738678"),  "Only 2003.2 or later clients support 'p4 passwd' at this server security level."  ) ;
    public static final ErrorId MsgServer_Password982         	= new ErrorId( ErrorOf( ES_SERVER, 20, E_FAILED, EV_UPGRADE, 0 , "807738388"),  "You need a 98.2 or newer client to access as a password-protected user."  ) ;
    public static final ErrorId MsgServer_Password991         	= new ErrorId( ErrorOf( ES_SERVER, 36, E_FAILED, EV_UPGRADE, 0 , "807738404"),  "Only 99.1 or later clients support 'p4 passwd'."  ) ;
    public static final ErrorId MsgServer_PasswordDelete      	= new ErrorId( ErrorOf( ES_SERVER, 122, E_INFO, 0, 0 , "268442746"),  "Password deleted."  ) ;
    public static final ErrorId MsgServer_PasswordExpired    	= new ErrorId( ErrorOf( ES_SERVER, 455, E_FAILED, EV_ILLEGAL, 0 , "805576135"),  "Your password has expired, please change your password."  ) ;
    public static final ErrorId MsgServer_PasswordNoChange    	= new ErrorId( ErrorOf( ES_SERVER, 123, E_INFO, 0, 0 , "268442747"),  "Password not changed."  ) ;
    public static final ErrorId MsgServer_PasswordSave        	= new ErrorId( ErrorOf( ES_SERVER, 121, E_INFO, 0, 0 , "268442745"),  "Password updated."  ) ;
    public static final ErrorId MsgServer_PasswordTooLong      	= new ErrorId( ErrorOf( ES_SERVER, 527, E_FAILED, EV_ILLEGAL, 1 , "822353423"),  "Password should be no longer than %maxLength% bytes in length."  ) ;
    public static final ErrorId MsgServer_PasswordTooShort     	= new ErrorId( ErrorOf( ES_SERVER, 308, E_FAILED, EV_ILLEGAL, 0 , "805575988"),  "Password should be at least 8 characters in length."  ) ;
    public static final ErrorId MsgServer_PasswordTooShort2    	= new ErrorId( ErrorOf( ES_SERVER, 543, E_FAILED, EV_ILLEGAL, 1 , "822353439"),  "Password should be at least %size% characters in length."  ) ;
    public static final ErrorId MsgServer_PasswordTooSimple    	= new ErrorId( ErrorOf( ES_SERVER, 309, E_FAILED, EV_ILLEGAL, 0 , "805575989"),  "Password should be mixed case or contain non alphabetic characters."  ) ;
    public static final ErrorId MsgServer_PopulateAborted     	= new ErrorId( ErrorOf( ES_SERVER, 595, E_FAILED, EV_NOTYET, 0 , "805641811"),  "Populate aborted -- fix problems and retry."  ) ;
    public static final ErrorId MsgServer_PopulateComplete    	= new ErrorId( ErrorOf( ES_SERVER, 591, E_INFO, 0, 2 , "301997647"),  "%fileCount% files branched[ (change %change%)]."  ) ;
    public static final ErrorId MsgServer_PopulateIsVirtual   	= new ErrorId( ErrorOf( ES_SERVER, 633, E_FAILED, EV_USAGE, 0 , "805379705"),  "Target stream is virtual, cannot update."  ) ;
    public static final ErrorId MsgServer_PropertyAdd         	= new ErrorId( ErrorOf( ES_SERVER, 634, E_INFO, 0, 1 , "285220474"),  "Property %settingName% %action%."  ) ;
    public static final ErrorId MsgServer_PropertyDelete      	= new ErrorId( ErrorOf( ES_SERVER, 635, E_INFO, 0, 1 , "285220475"),  "Property %settingName% deleted."  ) ;
    public static final ErrorId MsgServer_ProxyChain          	= new ErrorId( ErrorOf( ES_SERVER, 291, E_FAILED, EV_FAULT, 0 , "807476515"),  "Proxy servers may not be chained together"  ) ;
    public static final ErrorId MsgServer_ProxyDelivered      	= new ErrorId( ErrorOf( ES_SERVER, 293, E_INFO, 0, 1 , "285220133"),  "File %path% delivered from proxy server"  ) ;
    public static final ErrorId MsgServer_ProxyNoRemote       	= new ErrorId( ErrorOf( ES_SERVER, 296, E_FAILED, EV_ADMIN, 0 , "807607592"),  "Proxy Does not support caching remote server access."  ) ;
    public static final ErrorId MsgServer_ProxyUpdateFail     	= new ErrorId( ErrorOf( ES_SERVER, 301, E_WARN, EV_ADMIN, 1 , "555949357"),  "Proxy could not update its cache.  File is %file%"  ) ;
    public static final ErrorId MsgServer_PullJournalDate     	= new ErrorId( ErrorOf( ES_SERVER, 597, E_INFO, EV_NONE, 1 , "285220437"),  "The statefile was last modified at:\t%lastModTime%."  ) ;
    public static final ErrorId MsgServer_PullJournalSummary  	= new ErrorId( ErrorOf( ES_SERVER, 530, E_INFO, EV_NONE, 3 , "318774802"),  "Current %server% journal state is:\tJournal %journal%,\tSequence %sequence%."  ) ;
    public static final ErrorId MsgServer_PullNotReplica 	= new ErrorId( ErrorOf( ES_SERVER, 442, E_FAILED, EV_ADMIN, 0 , "807607738"),  "Pull only allowed on replica servers."  ) ;
    public static final ErrorId MsgServer_PullOnDemand   	= new ErrorId( ErrorOf( ES_SERVER, 645, E_FAILED, EV_ADMIN, 0 , "807607941"),  "This command is not used with an ondemand replica server."  ) ;
    public static final ErrorId MsgServer_PullTransferPending 	= new ErrorId( ErrorOf( ES_SERVER, 457, E_INFO, EV_NONE, 0 , "268443081"),  "%file% %rev% %type% %state% %process% %timestamp%"  ) ;
    public static final ErrorId MsgServer_PullTransferSummary 	= new ErrorId( ErrorOf( ES_SERVER, 519, E_INFO, EV_NONE, 4 , "335552007"),  "File transfers: %transfersActive% active/%transfersTotal% total, bytes: %bytesActive% active/%bytesTotal% total."  ) ;
    public static final ErrorId MsgServer_PurgeBadOption      	= new ErrorId( ErrorOf( ES_SERVER, 471, E_FAILED, EV_USAGE, 1 , "822156759"),  "'%path%' has revision range (not compatible with -b)."  ) ;
    public static final ErrorId MsgServer_PurgeOptGone        	= new ErrorId( ErrorOf( ES_SERVER, 347, E_FAILED, EV_USAGE, 0 , "805379419"),  "Obliterate -z option deprecated - use 'p4 snap' instead"  ) ;
    public static final ErrorId MsgServer_PurgeReport         	= new ErrorId( ErrorOf( ES_SERVER, 54, E_WARN, EV_NONE, 0 , "536878134"),  "This was report mode.  Use -y to remove files."  ) ;
    public static final ErrorId MsgServer_PurgeWarning        	= new ErrorId( ErrorOf( ES_SERVER, 303, E_WARN, EV_NONE, 2 , "570432815"),  "Warning: could not undo lazy copy link '%target%' -> '%source%"  ) ;
    public static final ErrorId MsgServer_QuiesceFailed       	= new ErrorId( ErrorOf( ES_SERVER, 649, E_INFO, EV_NONE, 4 , "335552137"),  "Perforce Server quiesce %date% pid %pid%, failed after 30 seconds."  ) ;
    public static final ErrorId MsgServer_Quiescing           	= new ErrorId( ErrorOf( ES_SERVER, 648, E_INFO, EV_NONE, 4 , "335552136"),  "Perforce Server quiescing %date% pid %pid%, %cnt% thread(s)."  ) ;
    public static final ErrorId MsgServer_ReDowngrade         	= new ErrorId( ErrorOf( ES_SERVER, 650, E_WARN, EV_NONE, 4 , "603987594"),  "Perforce Server %date% pid %pid%, downgrading restart to a shutdown."  ) ;
    public static final ErrorId MsgServer_RemoteInvalidCmd    	= new ErrorId( ErrorOf( ES_SERVER, 306, E_FAILED, EV_USAGE, 0 , "805379378"),  "User 'remote' is not allowed direct access to commands."  ) ;
    public static final ErrorId MsgServer_ReplicaBadOption    	= new ErrorId( ErrorOf( ES_SERVER, 422, E_FAILED, EV_FAULT, 0 , "807476646"),  "Unknown Replica Option."  ) ;
    public static final ErrorId MsgServer_ReplicaNoUpgrade    	= new ErrorId( ErrorOf( ES_SERVER, 421, E_FAILED, EV_FAULT, 0 , "807476645"),  "Replica can not upgrade automatically."  ) ;
    public static final ErrorId MsgServer_ReplicaRestricted   	= new ErrorId( ErrorOf( ES_SERVER, 420, E_FAILED, EV_FAULT, 0 , "807476644"),  "Replica does not support this command."  ) ;
    public static final ErrorId MsgServer_ReplicaServerTime  	= new ErrorId( ErrorOf( ES_SERVER, 653, E_INFO, EV_NONE, 2 , "301997709"),  "The replica server time is currently:\t%serverDate% %serverTimeZone%"  ) ;
    public static final ErrorId MsgServer_ReplicaWrongClient  	= new ErrorId( ErrorOf( ES_SERVER, 616, E_FAILED, EV_FAULT, 1 , "824254056"),  "Client '%client%' is not restricted to this replica."  ) ;
    public static final ErrorId MsgServer_ReplicaXferFailed   	= new ErrorId( ErrorOf( ES_SERVER, 474, E_FAILED, EV_FAULT, 0 , "807476698"),  "Transfer of librarian file '%file%' failed."  ) ;
    public static final ErrorId MsgServer_ResolveOptAuto      	= new ErrorId( ErrorOf( ES_SERVER, 486, E_INFO, 0, 0 , "268443110"),  "a"  ) ;
    public static final ErrorId MsgServer_ResolveOptHelp      	= new ErrorId( ErrorOf( ES_SERVER, 487, E_INFO, 0, 0 , "268443111"),  "?"  ) ;
    public static final ErrorId MsgServer_ResolveOptMerge     	= new ErrorId( ErrorOf( ES_SERVER, 488, E_INFO, 0, 0 , "268443112"),  "am"  ) ;
    public static final ErrorId MsgServer_ResolveOptSkip      	= new ErrorId( ErrorOf( ES_SERVER, 489, E_INFO, 0, 0 , "268443113"),  "s"  ) ;
    public static final ErrorId MsgServer_ResolveOptTheirs    	= new ErrorId( ErrorOf( ES_SERVER, 490, E_INFO, 0, 0 , "268443114"),  "at"  ) ;
    public static final ErrorId MsgServer_ResolveOptYours     	= new ErrorId( ErrorOf( ES_SERVER, 491, E_INFO, 0, 0 , "268443115"),  "ay"  ) ;
    public static final ErrorId MsgServer_ResolveOrRevert     	= new ErrorId( ErrorOf( ES_SERVER, 45, E_FAILED, EV_NOTYET, 0 , "805641261"),  "Out of date files must be resolved or reverted."  ) ;
    public static final ErrorId MsgServer_ResolvePromptMerge  	= new ErrorId( ErrorOf( ES_SERVER, 492, E_INFO, 0, 1 , "285220332"),  "am: %resolveAction%"  ) ;
    public static final ErrorId MsgServer_ResolvePromptTheirs 	= new ErrorId( ErrorOf( ES_SERVER, 493, E_INFO, 0, 1 , "285220333"),  "at: %resolveAction%"  ) ;
    public static final ErrorId MsgServer_ResolvePromptType   	= new ErrorId( ErrorOf( ES_SERVER, 494, E_INFO, 0, 1 , "285220334"),  "%resolveType%:"  ) ;
    public static final ErrorId MsgServer_ResolvePromptYours  	= new ErrorId( ErrorOf( ES_SERVER, 495, E_INFO, 0, 1 , "285220335"),  "ay: %resolveAction%"  ) ;
    public static final ErrorId MsgServer_ResolveTampered      	= new ErrorId( ErrorOf( ES_SERVER, 452, E_FAILED, 0, 1 , "822091204"),  "%clientFile% tampered with before resolve - edit or revert."  ) ;
    public static final ErrorId MsgServer_ResolveUserError    	= new ErrorId( ErrorOf( ES_SERVER, 496, E_INFO, 0, 1 , "285220336"),  "'%option%' is not an option."  ) ;
    public static final ErrorId MsgServer_ResolveUserPrompt   	= new ErrorId( ErrorOf( ES_SERVER, 497, E_INFO, 0, 1 , "285220337"),  "Accept(a) Skip(s) Help(?) %option%: "  ) ;
    public static final ErrorId MsgServer_ResolveUserPrompt2  	= new ErrorId( ErrorOf( ES_SERVER, 517, E_INFO, 0, 1 , "285220357"),  "Accept(at/ay) Skip(s) Help(?) %option%: "  ) ;
    public static final ErrorId MsgServer_ResolvedFile        	= new ErrorId( ErrorOf( ES_SERVER, 129, E_INFO, 0, 3 , "318774401"),  "%toFile% - %how% %fromFile%"  ) ;
    public static final ErrorId MsgServer_ResolvedSkipped     	= new ErrorId( ErrorOf( ES_SERVER, 130, E_INFO, 0, 1 , "285219970"),  "%toFile% - resolve skipped."  ) ;
    public static final ErrorId MsgServer_Restarted           	= new ErrorId( ErrorOf( ES_SERVER, 515, E_INFO, EV_NONE, 2 , "301997571"),  "Perforce Server restarted %date% pid %pid%."  ) ;
    public static final ErrorId MsgServer_Restarting	       	= new ErrorId( ErrorOf( ES_SERVER, 516, E_INFO, EV_NONE, 4 , "335552004"),  "Perforce Server restarting %date% pid %pid% %ver%[ %mode% mode]."  ) ;
    public static final ErrorId MsgServer_RetypeInvalidTempobj 	= new ErrorId( ErrorOf( ES_SERVER, 374, E_FAILED, 0, 0 , "805313910"),  "Invalid +S modifier or xtempobj type used for changing librarian filetype.\nSee 'p4 help retype'."  ) ;
    public static final ErrorId MsgServer_RmtAuthFailed       	= new ErrorId( ErrorOf( ES_SERVER, 294, E_FAILED, EV_FAULT, 0 , "807476518"),  "Remote authorization server access failed."  ) ;
    public static final ErrorId MsgServer_SSONoEnv            	= new ErrorId( ErrorOf( ES_SERVER, 357, E_FAILED, EV_UNKNOWN, 0 , "805444965"),  "Single sign-on on client failed: 'P4LOGINSSO' not set."  ) ;
    public static final ErrorId MsgServer_SSOfailed           	= new ErrorId( ErrorOf( ES_SERVER, 356, E_FAILED, EV_UNKNOWN, 1 , "822222180"),  "Single sign-on on client failed: %result%"  ) ;
    public static final ErrorId MsgServer_SearchResult        	= new ErrorId( ErrorOf( ES_SERVER, 132, E_INFO, 0, 1 , "285219972"),  "%word%"  ) ;
    public static final ErrorId MsgServer_ServerID            	= new ErrorId( ErrorOf( ES_SERVER, 570, E_INFO, EV_NONE, 1 , "285220410"),  "Server ID: %serverID%"  ) ;
    public static final ErrorId MsgServer_ServerIDAlreadySet  	= new ErrorId( ErrorOf( ES_SERVER, 568, E_FAILED, EV_USAGE, 1 , "822156856"),  "Server already has a server ID: %serverID%"  ) ;
    public static final ErrorId MsgServer_ServerTooOld        	= new ErrorId( ErrorOf( ES_SERVER, 290, E_FAILED, EV_FAULT, 0 , "807476514"),  "Server is too old for use with Proxy"  ) ;
    public static final ErrorId MsgServer_ServiceNotProvided  	= new ErrorId( ErrorOf( ES_SERVER, 572, E_FAILED, EV_USAGE, 0 , "805379644"),  "Server does not provide this service."  ) ;
    public static final ErrorId MsgServer_ShelveAborted       	= new ErrorId( ErrorOf( ES_SERVER, 405, E_FAILED, EV_NOTYET, 1 , "822418837"),  "Shelve aborted -- fix problems then use 'p4 shelve -c %change%'."  ) ;
    public static final ErrorId MsgServer_ShelveBegin         	= new ErrorId( ErrorOf( ES_SERVER, 401, E_INFO, 0, 1 , "285220241"),  "Shelving files for change %change%."  ) ;
    public static final ErrorId MsgServer_ShelveComplete        	= new ErrorId( ErrorOf( ES_SERVER, 412, E_INFO, 0, 1 , "285220252"),  "%change% files shelved."  ) ;
    public static final ErrorId MsgServer_ShelveDelete        	= new ErrorId( ErrorOf( ES_SERVER, 408, E_INFO, 0, 2 , "301997464"),  "Shelved change %change% [partially deleted, still contains %count% file(s).|deleted.]"  ) ;
    public static final ErrorId MsgServer_ShelveMaxSize       	= new ErrorId( ErrorOf( ES_SERVER, 413, E_FAILED, EV_USAGE, 2 , "838933917"),  "%clientFile% size greater than shelve allows (max %maxFiles%)."  ) ;
    public static final ErrorId MsgServer_ShelveTriggersFailed       	= new ErrorId( ErrorOf( ES_SERVER, 418, E_FAILED, EV_NOTYET, 0 , "805641634"),  "Shelve validation failed -- fix problems then try again."  ) ;
    public static final ErrorId MsgServer_ShelveXOpen          	= new ErrorId( ErrorOf( ES_DM, 430, E_INFO, 1, 1 , "285284782"),  "%depotFile% - warning: shelve of +l file"  ) ;
    public static final ErrorId MsgServer_Shutdown	       	= new ErrorId( ErrorOf( ES_SERVER, 338, E_INFO, EV_NONE, 3 , "318774610"),  "Perforce Server shutdown %date% pid %pid%."  ) ;
    public static final ErrorId MsgServer_SkippedJnls	       	= new ErrorId( ErrorOf( ES_SERVER, 368, E_FAILED, EV_ADMIN, 1 , "824384880"),  "%count% out of sequence journals were not replayed"  ) ;
    public static final ErrorId MsgServer_SnapReport         	= new ErrorId( ErrorOf( ES_SERVER, 346, E_WARN, EV_NONE, 0 , "536878426"),  "This was report mode (-n),  no files were snapped (copied)."  ) ;
    public static final ErrorId MsgServer_SpecArchiveWarning  	= new ErrorId( ErrorOf( ES_SERVER, 333, E_INFO, 0, 0 , "268442957"),  "Warning: couldn't archive to spec depot (%lbrFile%)"  ) ;
    public static final ErrorId MsgServer_SpecCheckTriggers   	= new ErrorId( ErrorOf( ES_SERVER, 350, E_INFO, 0, 0 , "268442974"),  "Error parsing form text; check form-out triggers?"  ) ;
    public static final ErrorId MsgServer_SpecNotCorrect      	= new ErrorId( ErrorOf( ES_SERVER, 124, E_INFO, 0, 0 , "268442748"),  "Specification not corrected -- giving up."  ) ;
    public static final ErrorId MsgServer_Startup	       	= new ErrorId( ErrorOf( ES_SERVER, 337, E_INFO, EV_NONE, 3 , "318774609"),  "Perforce Server starting %date% pid %pid% %ver%[ %mode% mode]."  ) ;
    public static final ErrorId MsgServer_StartupCommandError 	= new ErrorId( ErrorOf( ES_SERVER, 458, E_FAILED, EV_ADMIN, 1 , "824384970"),  "Startup command failed: %message%"  ) ;
    public static final ErrorId MsgServer_SubmitAborted       	= new ErrorId( ErrorOf( ES_SERVER, 49, E_FAILED, EV_NOTYET, 1 , "822418481"),  "Submit aborted -- fix problems then use 'p4 submit -c %change%'."  ) ;
    public static final ErrorId MsgServer_SubmitBegin         	= new ErrorId( ErrorOf( ES_SERVER, 128, E_INFO, 0, 1 , "285219968"),  "Submitting change %change%."  ) ;
    public static final ErrorId MsgServer_SubmitComplete      	= new ErrorId( ErrorOf( ES_SERVER, 126, E_INFO, 0, 1 , "285219966"),  "%change% submitted."  ) ;
    public static final ErrorId MsgServer_SubmitDataChanged   	= new ErrorId( ErrorOf( ES_SERVER, 324, E_FAILED, EV_EMPTY, 0 , "806427972"),  "Files newly opened or reverted during submission."  ) ;
    public static final ErrorId MsgServer_SubmitFailed        	= new ErrorId( ErrorOf( ES_SERVER, 42, E_FAILED, EV_NOTYET, 1 , "822418474"),  "Submit failed -- fix problems above then use 'p4 submit -c %change%'."  ) ;
    public static final ErrorId MsgServer_SubmitIsShelved     	= new ErrorId( ErrorOf( ES_SERVER, 410, E_FAILED, EV_NOTYET, 1 , "822418842"),  "Change %change% has shelved files --  cannot submit." ) ;
    public static final ErrorId MsgServer_SubmitLocking       	= new ErrorId( ErrorOf( ES_SERVER, 125, E_INFO, 0, 1 , "285219965"),  "Locking %unlockedCount% files ..."  ) ;
    public static final ErrorId MsgServer_SubmitNeedsShelved     	= new ErrorId( ErrorOf( ES_SERVER, 640, E_FAILED, EV_NOTYET, 1 , "822419072"),  "Change %change% does not have shelved files --  cannot submit." ) ;
    public static final ErrorId MsgServer_SubmitRenamed       	= new ErrorId( ErrorOf( ES_SERVER, 127, E_INFO, 0, 2 , "301997183"),  "%change% renamed %newChange% and submitted."  ) ;
    public static final ErrorId MsgServer_SubmitShelvedAborted       	= new ErrorId( ErrorOf( ES_SERVER, 642, E_FAILED, EV_NOTYET, 1 , "822419074"),  "Submit aborted -- fix problems then use 'p4 submit -e %change%'."  ) ;
    public static final ErrorId MsgServer_SubmitShelvedFailed        	= new ErrorId( ErrorOf( ES_SERVER, 641, E_FAILED, EV_NOTYET, 1 , "822419073"),  "Submit failed -- fix problems above then use 'p4 submit -e %change%'."  ) ;
    public static final ErrorId MsgServer_SubmitShelvedHasTask     	= new ErrorId( ErrorOf( ES_SERVER, 646, E_FAILED, EV_NOTYET, 1 , "822419078"),  "Change %change% has shelved files from a task stream --  cannot submit." ) ;
    public static final ErrorId MsgServer_SubmitTampered      	= new ErrorId( ErrorOf( ES_SERVER, 342, E_FAILED, 0, 2 , "838868310"),  "%clientFile% tampered with after resolve - edit or revert."  ) ;
    public static final ErrorId MsgServer_TZMismatch	       	= new ErrorId( ErrorOf( ES_SERVER, 538, E_WARN, EV_ADMIN, 0 , "539172378"),  "Replica Timezone does not match master.  This will cause problems with keywords."  ) ;
    public static final ErrorId MsgServer_TemporaryLabelInfo  	= new ErrorId( ErrorOf( ES_SERVER, 588, E_INFO, EV_NONE, 2 , "301997644"),  "Temporary label '%label%' updated %count% total file(s)."  ) ;
    public static final ErrorId MsgServer_TicketOnly          	= new ErrorId( ErrorOf( ES_SERVER, 322, E_FAILED, EV_USAGE, 0 , "805379394"),  "Password not allowed at this server security level, use 'p4 login'."  ) ;
    public static final ErrorId MsgServer_TooManyCommands     	= new ErrorId( ErrorOf( ES_SERVER, 637, E_FAILED, EV_USAGE, 1 , "822156925"),  "Request refused: this server is configured to run a maximum of %maxCommands% simultaneous commands. Please try again later when the load is lower."  ) ;
    public static final ErrorId MsgServer_TooManySortTraits    	= new ErrorId( ErrorOf( ES_SERVER, 462, E_FAILED, EV_USAGE, 0 , "805379534"),  "Too many sort attributes (only 2 allowed)."  ) ;
    public static final ErrorId MsgServer_TrackCommand        	= new ErrorId( ErrorOf( ES_SERVER, 57, E_INFO, EV_NONE, 2 , "301997113"),  "%command%\n%text%"  ) ;
    public static final ErrorId MsgServer_TransferCancelled   	= new ErrorId( ErrorOf( ES_SERVER, 643, E_INFO, EV_NONE, 0 , "268443267"),  "The file content transfer was cancelled."  ) ;
    public static final ErrorId MsgServer_TransferNotReplica 	= new ErrorId( ErrorOf( ES_SERVER, 500, E_FAILED, EV_ADMIN, 0 , "807607796"),  "Verify -t only allowed on replica servers."  ) ;
    public static final ErrorId MsgServer_TriggerFailed       	= new ErrorId( ErrorOf( ES_SERVER, 47, E_FAILED, EV_NOTYET, 2 , "839195695"),  "'%trigger%' validation failed: %result%"  ) ;
    public static final ErrorId MsgServer_TriggerOutput       	= new ErrorId( ErrorOf( ES_SERVER, 362, E_INFO, EV_NOTYET, 1 , "285547882"),  "%result%"  ) ;
    public static final ErrorId MsgServer_TriggersFailed      	= new ErrorId( ErrorOf( ES_SERVER, 48, E_FAILED, EV_NOTYET, 1 , "822418480"),  "Submit validation failed -- fix problems then use 'p4 submit -c %change%'."  ) ;
    public static final ErrorId MsgServer_Unicode             	= new ErrorId( ErrorOf( ES_SERVER, 22, E_FAILED, EV_CONFIG, 0 , "807672854"),  "Unicode server permits only unicode enabled clients."  ) ;
    public static final ErrorId MsgServer_Unicode2            	= new ErrorId( ErrorOf( ES_SERVER, 23, E_FAILED, EV_CONFIG, 0 , "807672855"),  "Unicode clients require a unicode enabled server."  ) ;
    public static final ErrorId MsgServer_UnknownReplicationMode 	= new ErrorId( ErrorOf( ES_SERVER, 468, E_FAILED, EV_FAULT, 1 , "824253908"),  "Unknown replication mode '%mode%'."  ) ;
    public static final ErrorId MsgServer_UnknownReplicationTarget 	= new ErrorId( ErrorOf( ES_SERVER, 470, E_FAILED, EV_FAULT, 1 , "824253910"),  "Unknown replication target '%target%'."  ) ;
    public static final ErrorId MsgServer_Unlicensed          	= new ErrorId( ErrorOf( ES_SERVER, 56, E_FAILED, EV_ADMIN, 0 , "807607352"),  "Unlicensed server cannot start while over user/client quota."  ) ;
    public static final ErrorId MsgServer_UnloadDepotMissing  	= new ErrorId( ErrorOf( ES_SERVER, 612, E_FAILED, EV_USAGE, 0 , "805379684"),  "No unload depot has been defined for this server."  ) ;
    public static final ErrorId MsgServer_UnloadOtherUser     	= new ErrorId( ErrorOf( ES_SERVER, 617, E_FAILED, EV_USAGE, 0 , "805379689"),  "Specify the '-f' flag in order to unload clients or labels owned by another user."  ) ;
    public static final ErrorId MsgServer_UnshelveFileChanged 	= new ErrorId( ErrorOf( ES_SERVER, 407, E_FAILED, EV_EMPTY, 1 , "823205271"),  "%depotFile% - warning: shelved file was modified during transfer!"  ) ;
    public static final ErrorId MsgServer_UnshelveNotOwner    	= new ErrorId( ErrorOf( ES_SERVER, 404, E_FAILED, EV_ILLEGAL, 1 , "822353300"),  "Only user '%user%' can purge this shelved changelist."  ) ;
    public static final ErrorId MsgServer_Usage               	= new ErrorId( ErrorOf( ES_SERVER, 30, E_FAILED, EV_USAGE, 1 , "822156318"),  "Usage: %usage%"  ) ;
    public static final ErrorId MsgServer_UseAdmin            	= new ErrorId( ErrorOf( ES_SERVER, 200, E_FAILED, EV_USAGE, 0 , "805379272"),  "Usage: admin { checkpoint | journal | resetpassword | restart | stop | updatespecdepot }"  ) ;
    public static final ErrorId MsgServer_UseAdminCheckpoint  	= new ErrorId( ErrorOf( ES_SERVER, 203, E_FAILED, EV_USAGE, 0 , "805379275"),  "Usage: admin checkpoint [ -z | -Z ] [ prefix ] "  ) ;
    public static final ErrorId MsgServer_UseAdminCopyin      	= new ErrorId( ErrorOf( ES_SERVER, 201, E_FAILED, EV_USAGE, 0 , "805379273"),  "Usage: admin copyin prefix"  ) ;
    public static final ErrorId MsgServer_UseAdminCopyout     	= new ErrorId( ErrorOf( ES_SERVER, 202, E_FAILED, EV_USAGE, 0 , "805379274"),  "Usage: admin copyout prefix"  ) ;
    public static final ErrorId MsgServer_UseAdminDBSigs      	= new ErrorId( ErrorOf( ES_SERVER, 502, E_FAILED, EV_USAGE, 0 , "805379574"),  "Usage: journaldbchecksums [ -t table ]"  ) ;
    public static final ErrorId MsgServer_UseAdminImport      	= new ErrorId( ErrorOf( ES_SERVER, 360, E_FAILED, EV_USAGE, 0 , "805379432"),  "Usage: admin import [ -l ] [ -b batchsize ]"  ) ;
    public static final ErrorId MsgServer_UseAdminJournal     	= new ErrorId( ErrorOf( ES_SERVER, 204, E_FAILED, EV_USAGE, 0 , "805379276"),  "Usage: admin journal [ -z ] [ prefix ] "  ) ;
    public static final ErrorId MsgServer_UseAdminResetPassword   	= new ErrorId( ErrorOf( ES_SERVER, 620, E_FAILED, EV_USAGE, 0 , "805379692"),  "Usage: admin resetpassword -a | -u user"  ) ;
    public static final ErrorId MsgServer_UseAdminSpecDepot   	= new ErrorId( ErrorOf( ES_SERVER, 352, E_FAILED, EV_USAGE, 0 , "805379424"),  "Usage: admin updatespecdepot [ -a | -s type ]"  ) ;
    public static final ErrorId MsgServer_UseAnnotate         	= new ErrorId( ErrorOf( ES_SERVER, 289, E_FAILED, EV_USAGE, 0 , "805379361"),  "Usage: annotate [ -aciIqt -d<flags> ] files..."  ) ;
    public static final ErrorId MsgServer_UseArchive          	= new ErrorId( ErrorOf( ES_SERVER, 453, E_FAILED, EV_USAGE, 0 , "805379525"),  "Usage: archive -D depot [-n -h -p -q -t ] files..."  ) ;
    public static final ErrorId MsgServer_UseBranch           	= new ErrorId( ErrorOf( ES_SERVER, 205, E_FAILED, EV_USAGE, 0 , "805379277"),  "Usage: branch [ -d -f -i -S stream -P parent -o ] branchname"  ) ;
    public static final ErrorId MsgServer_UseBranchd          	= new ErrorId( ErrorOf( ES_SERVER, 207, E_FAILED, EV_USAGE, 0 , "805379279"),  "Usage: branch -d [ -f ] branchname"  ) ;
    public static final ErrorId MsgServer_UseBranches         	= new ErrorId( ErrorOf( ES_SERVER, 534, E_FAILED, EV_USAGE, 0 , "805379606"),  "Usage: branches [ -t ] [ -u user ] [ [-e|-E] query -m max ]"  ) ;
    public static final ErrorId MsgServer_UseBranchi          	= new ErrorId( ErrorOf( ES_SERVER, 208, E_FAILED, EV_USAGE, 0 , "805379280"),  "Usage: branch -i"  ) ;
    public static final ErrorId MsgServer_UseBrancho          	= new ErrorId( ErrorOf( ES_SERVER, 206, E_FAILED, EV_USAGE, 0 , "805379278"),  "Usage: branch [ -S stream [ -P parent ] ] -o branchname"  ) ;
    public static final ErrorId MsgServer_UseChange           	= new ErrorId( ErrorOf( ES_SERVER, 209, E_FAILED, EV_USAGE, 0 , "805379281"),  "Usage: change [ -d -i -o -s -t<type> -U<user>] [ -f | -u ] [ [ -O ] changelist# ]"  ) ;
    public static final ErrorId MsgServer_UseChangeU          	= new ErrorId( ErrorOf( ES_SERVER, 651, E_FAILED, EV_USAGE, 0 , "805379723"),  "Usage: change -U user [ -t restricted | public ] [ -f ] changelist#"  ) ;
    public static final ErrorId MsgServer_UseChangeUt          	= new ErrorId( ErrorOf( ES_SERVER, 652, E_FAILED, EV_USAGE, 0 , "805379724"),  "Usage: change -U user -t restricted | public [ -f ] changelist#"  ) ;
    public static final ErrorId MsgServer_UseChanged          	= new ErrorId( ErrorOf( ES_SERVER, 210, E_FAILED, EV_USAGE, 0 , "805379282"),  "Usage: change -d [ -f ] [ -O ] changelist#"  ) ;
    public static final ErrorId MsgServer_UseChangei          	= new ErrorId( ErrorOf( ES_SERVER, 212, E_FAILED, EV_USAGE, 0 , "805379284"),  "Usage: change -i [ -s ] [ -f | -u ]"  ) ;
    public static final ErrorId MsgServer_UseChangeo          	= new ErrorId( ErrorOf( ES_SERVER, 211, E_FAILED, EV_USAGE, 0 , "805379283"),  "Usage: change -o [ -s ] [ -f ] [ [ -O ] changelist# ]"  ) ;
    public static final ErrorId MsgServer_UseChanges          	= new ErrorId( ErrorOf( ES_SERVER, 213, E_FAILED, EV_USAGE, 0 , "805379285"),  "Usage: changes [-i -t -l -L -f -c client -m count -s status -u user] [files...]"  ) ;
    public static final ErrorId MsgServer_UseChanget          	= new ErrorId( ErrorOf( ES_SERVER, 456, E_FAILED, EV_USAGE, 0 , "805379528"),  "Usage: change -t restricted | public [ -U user ] [ -f | -u | -O ] changelist#"  ) ;
    public static final ErrorId MsgServer_UseClient           	= new ErrorId( ErrorOf( ES_SERVER, 214, E_FAILED, EV_USAGE, 0 , "805379286"),  "Usage: client [ -d -f -i -o -s ] [ -t template | -S stream ] [ -c change ] [ clientname ]"  ) ;
    public static final ErrorId MsgServer_UseClientS          	= new ErrorId( ErrorOf( ES_SERVER, 510, E_FAILED, EV_USAGE, 0 , "805379582"),  "Usage: client -S stream [ [ -c change ] -o ] [ clientname ]"  ) ;
    public static final ErrorId MsgServer_UseClientd          	= new ErrorId( ErrorOf( ES_SERVER, 216, E_FAILED, EV_USAGE, 0 , "805379288"),  "Usage: client -d [ -f ] clientname"  ) ;
    public static final ErrorId MsgServer_UseClienti          	= new ErrorId( ErrorOf( ES_SERVER, 217, E_FAILED, EV_USAGE, 0 , "805379289"),  "Usage: client -i [ -f ]"  ) ;
    public static final ErrorId MsgServer_UseCliento          	= new ErrorId( ErrorOf( ES_SERVER, 215, E_FAILED, EV_USAGE, 0 , "805379287"),  "Usage: client -o [ -t template ] clientname"  ) ;
    public static final ErrorId MsgServer_UseClients          	= new ErrorId( ErrorOf( ES_SERVER, 504, E_FAILED, EV_USAGE, 0 , "805379576"),  "Usage: client -s [ -f ] -t template | -S stream [ clientname ]"  ) ;
    public static final ErrorId MsgServer_UseConfigure        	= new ErrorId( ErrorOf( ES_SERVER, 436, E_FAILED, EV_USAGE, 0 , "805379508"),  "Usage: configure { show [ allservers | <P4NAME> | <variable> ] | set [<P4NAME>#]variable=value | unset [<P4NAME>#]variable }"  ) ;
    public static final ErrorId MsgServer_UseCopy             	= new ErrorId( ErrorOf( ES_SERVER, 450, E_FAILED, EV_USAGE, 0 , "805379522"),  "Usage: copy [ -c changelist# -F -m max -n -q -r -s from -v ] [ -b branch to... | -S stream [ -P parent ] [ file... ] | from to ]"  ) ;
    public static final ErrorId MsgServer_UseCopyS            	= new ErrorId( ErrorOf( ES_SERVER, 508, E_FAILED, EV_USAGE, 0 , "805379580"),  "Usage: copy [ -c changelist# -F -m max -n -q -r -s from -v ] -S stream [ -P parent ] [ file... ]"  ) ;
    public static final ErrorId MsgServer_UseCopyb            	= new ErrorId( ErrorOf( ES_SERVER, 451, E_FAILED, EV_USAGE, 0 , "805379523"),  "Usage: copy [ -c changelist# -F -m max -n -q -r -s from -v ] -b branch [ to... ]"  ) ;
    public static final ErrorId MsgServer_UseCounter          	= new ErrorId( ErrorOf( ES_SERVER, 218, E_FAILED, EV_USAGE, 0 , "805379290"),  "Usage: counter [ -f ] [ -d -i ] counter_name [ value ]"  ) ;
    public static final ErrorId MsgServer_UseCounteri         	= new ErrorId( ErrorOf( ES_SERVER, 424, E_FAILED, EV_USAGE, 0 , "805379496"),  "Usage: counter [ -f ] -i counter_name"  ) ;
    public static final ErrorId MsgServer_UseCounters         	= new ErrorId( ErrorOf( ES_SERVER, 219, E_FAILED, EV_USAGE, 0 , "805379291"),  "Usage: counters [ -e nameFilter ]"  ) ;
    public static final ErrorId MsgServer_UseCstat            	= new ErrorId( ErrorOf( ES_SERVER, 419, E_FAILED, EV_USAGE, 0 , "805379491"),  "Usage: cstat [files...]"  ) ;
    public static final ErrorId MsgServer_UseDbpack           	= new ErrorId( ErrorOf( ES_SERVER, 359, E_FAILED, EV_USAGE, 0 , "805379431"),  "Usage: dbpack [ -c pages -l 0|1|2 ] { -a | dbtable ... }"  ) ;
    public static final ErrorId MsgServer_UseDbstat           	= new ErrorId( ErrorOf( ES_SERVER, 344, E_FAILED, EV_USAGE, 0 , "805379416"),  "Usage: dbstat [ -h ] { -a | dbtable ... }\n       dbstat -s"  ) ;
    public static final ErrorId MsgServer_UseDbverify         	= new ErrorId( ErrorOf( ES_SERVER, 573, E_FAILED, EV_USAGE, 0 , "805379645"),  "Usage: dbverify [ -t db.table ] [ -U ]"  ) ;
    public static final ErrorId MsgServer_UseDepot            	= new ErrorId( ErrorOf( ES_SERVER, 220, E_FAILED, EV_USAGE, 0 , "805379292"),  "Usage: depot [ -i -o ] [ -d [ -f ] ] depotname"  ) ;
    public static final ErrorId MsgServer_UseDepotd           	= new ErrorId( ErrorOf( ES_SERVER, 222, E_FAILED, EV_USAGE, 0 , "805379294"),  "Usage: depot -d depotname"  ) ;
    public static final ErrorId MsgServer_UseDepoti           	= new ErrorId( ErrorOf( ES_SERVER, 223, E_FAILED, EV_USAGE, 0 , "805379295"),  "Usage: depot -i"  ) ;
    public static final ErrorId MsgServer_UseDepoto           	= new ErrorId( ErrorOf( ES_SERVER, 221, E_FAILED, EV_USAGE, 0 , "805379293"),  "Usage: depot -o depotname"  ) ;
    public static final ErrorId MsgServer_UseDepots           	= new ErrorId( ErrorOf( ES_SERVER, 224, E_FAILED, EV_USAGE, 0 , "805379296"),  "Usage: depots"  ) ;
    public static final ErrorId MsgServer_UseDescribe         	= new ErrorId( ErrorOf( ES_SERVER, 225, E_FAILED, EV_USAGE, 0 , "805379297"),  "Usage: describe [-d<flags> -s -S -f -O] changelist# ..."  ) ;
    public static final ErrorId MsgServer_UseDiff             	= new ErrorId( ErrorOf( ES_SERVER, 226, E_FAILED, EV_USAGE, 0 , "805379298"),  "Usage: diff [ -d<flags> -f -m max -s<flag> -t ] [files...]"  ) ;
    public static final ErrorId MsgServer_UseDiff2            	= new ErrorId( ErrorOf( ES_SERVER, 227, E_FAILED, EV_USAGE, 0 , "805379299"),  "Usage: diff2 [ -d<flags> -q -t -u ] [ -b branchName ] [ -S stream ] [ -P parent ] file file2"  ) ;
    public static final ErrorId MsgServer_UseDiff2S           	= new ErrorId( ErrorOf( ES_SERVER, 506, E_FAILED, EV_USAGE, 0 , "805379578"),  "Usage: diff2 [ -d<flags> -q -t -u ] -S stream [ -P parent ] [ [ file ] file2 ]"  ) ;
    public static final ErrorId MsgServer_UseDiff2b           	= new ErrorId( ErrorOf( ES_SERVER, 228, E_FAILED, EV_USAGE, 0 , "805379300"),  "Usage: diff2 [ -d<flags> -q -t -u ] -b branchName [ [ file ] file2 ]"  ) ;
    public static final ErrorId MsgServer_UseDiff2n           	= new ErrorId( ErrorOf( ES_SERVER, 229, E_FAILED, EV_USAGE, 0 , "805379301"),  "Usage: diff2 [ -d<flags> -q -t -u ] file file2"  ) ;
    public static final ErrorId MsgServer_UseDirs             	= new ErrorId( ErrorOf( ES_SERVER, 230, E_FAILED, EV_USAGE, 0 , "805379302"),  "Usage: dirs [-C -D -H] [-S stream] dirs..."  ) ;
    public static final ErrorId MsgServer_UseDiskspace        	= new ErrorId( ErrorOf( ES_SERVER, 513, E_FAILED, EV_USAGE, 0 , "805379585"),  "Usage: diskspace [ P4ROOT | P4JOURNAL | P4LOG | TEMP | depot ]"  ) ;
    public static final ErrorId MsgServer_UseDomainClients    	= new ErrorId( ErrorOf( ES_SERVER, 481, E_FAILED, EV_USAGE, 0 , "805379553"),  "Usage: clients [ -t ] [ -u user ] [ -U ] [ [-e|-E] query -m max ] [ -S stream ]"  ) ;
    public static final ErrorId MsgServer_UseDomains          	= new ErrorId( ErrorOf( ES_SERVER, 231, E_FAILED, EV_USAGE, 0 , "805379303"),  "Usage: branches/labels [ -t ] [ -u user ] [ [-e|-E] query -m max ]"  ) ;
    public static final ErrorId MsgServer_UseDup              	= new ErrorId( ErrorOf( ES_SERVER, 351, E_FAILED, EV_USAGE, 0 , "805379423"),  "Usage: duplicate [ -n -q ] from[revRange] to"  ) ;
    public static final ErrorId MsgServer_UseExport           	= new ErrorId( ErrorOf( ES_SERVER, 378, E_FAILED, EV_USAGE, 0 , "805379450"),  "Usage: export [ -f -r -F <filter> -j <journal> -c <checkpoint> -l <lines> -J <prefix> -T <tableexcludelist> -P <filterpattern>]"  ) ;
    public static final ErrorId MsgServer_UseFilelog          	= new ErrorId( ErrorOf( ES_SERVER, 232, E_FAILED, EV_USAGE, 0 , "805379304"),  "Usage: filelog [ -c changelist# -h -i -l -L -t -m maxRevs -s ] files..."  ) ;
    public static final ErrorId MsgServer_UseFiles            	= new ErrorId( ErrorOf( ES_SERVER, 233, E_FAILED, EV_USAGE, 0 , "805379305"),  "Usage: files [-a -A -e -m max] [-U] files..."  ) ;
    public static final ErrorId MsgServer_UseFix              	= new ErrorId( ErrorOf( ES_SERVER, 234, E_FAILED, EV_USAGE, 0 , "805379306"),  "Usage: fix [ -d ] [ -s status ] -c changelist# jobName ..."  ) ;
    public static final ErrorId MsgServer_UseFixes            	= new ErrorId( ErrorOf( ES_SERVER, 235, E_FAILED, EV_USAGE, 0 , "805379307"),  "Usage: fixes [ -i -m max -c changelist# -j jobName ] [files...] "  ) ;
    public static final ErrorId MsgServer_UseFstat            	= new ErrorId( ErrorOf( ES_SERVER, 236, E_FAILED, EV_USAGE, 0 , "805379308"),  "Usage: fstat [ -F filter -T fields -m max -r ] [ -c | -e changelist# ] [ -Ox -Rx -Sx ] [-A pattern] [-U] file[rev]..."  ) ;
    public static final ErrorId MsgServer_UseGrep             	= new ErrorId( ErrorOf( ES_SERVER, 427, E_FAILED, EV_USAGE, 0 , "805379499"),  "Usage: grep [ -a -i -n -A after -B before -C context -t -s ] [ -v | -l | -L ] [ -F | -G ] -e pattern files..."  ) ;
    public static final ErrorId MsgServer_UseGroup            	= new ErrorId( ErrorOf( ES_SERVER, 237, E_FAILED, EV_USAGE, 0 , "805379309"),  "Usage: group [ -a -A -d -i -o ] groupname"  ) ;
    public static final ErrorId MsgServer_UseGroupd           	= new ErrorId( ErrorOf( ES_SERVER, 239, E_FAILED, EV_USAGE, 0 , "805379311"),  "Usage: group [ -a ] -d groupname"  ) ;
    public static final ErrorId MsgServer_UseGroupi           	= new ErrorId( ErrorOf( ES_SERVER, 240, E_FAILED, EV_USAGE, 0 , "805379312"),  "Usage: group [ -a -A ] -i"  ) ;
    public static final ErrorId MsgServer_UseGroupo           	= new ErrorId( ErrorOf( ES_SERVER, 238, E_FAILED, EV_USAGE, 0 , "805379310"),  "Usage: group -o groupname"  ) ;
    public static final ErrorId MsgServer_UseGroups           	= new ErrorId( ErrorOf( ES_SERVER, 241, E_FAILED, EV_USAGE, 0 , "805379313"),  "Usage: groups [ -m max ] [ [ [ -i [ -v ] ] user | group ] | [ -v [ group ] ]  | [ -g | -u | -o name ] ]"  ) ;
    public static final ErrorId MsgServer_UseHave             	= new ErrorId( ErrorOf( ES_SERVER, 242, E_FAILED, EV_USAGE, 0 , "805379314"),  "Usage: have [files...]"  ) ;
    public static final ErrorId MsgServer_UseHelp             	= new ErrorId( ErrorOf( ES_SERVER, 243, E_FAILED, EV_USAGE, 0 , "805379315"),  "Usage: help [command ...]"  ) ;
    public static final ErrorId MsgServer_UseIndex            	= new ErrorId( ErrorOf( ES_SERVER, 244, E_FAILED, EV_USAGE, 0 , "805379316"),  "Usage: index [ -a attrib ] [ -d ] name"  ) ;
    public static final ErrorId MsgServer_UseInfo             	= new ErrorId( ErrorOf( ES_SERVER, 245, E_FAILED, EV_USAGE, 0 , "805379317"),  "Usage: info [-s]"  ) ;
    public static final ErrorId MsgServer_UseInteg            	= new ErrorId( ErrorOf( ES_SERVER, 246, E_FAILED, EV_USAGE, 0 , "805379318"),  "Usage: integrate [ -c changelist# -D<flags> -f -h -m max -n -Obr -q -r -s from -v ] [ -b branch to... | from to ] [ -S stream [ -P parent ] files... ]"  ) ;
    public static final ErrorId MsgServer_UseIntegS           	= new ErrorId( ErrorOf( ES_SERVER, 507, E_FAILED, EV_USAGE, 0 , "805379579"),  "Usage: integrate [ -c changelist# -D<flags> -f -h -m max -n -Obr -q -r -s from -v ] -S stream [ -P parent ] [ files... ] "  ) ;
    public static final ErrorId MsgServer_UseIntegb           	= new ErrorId( ErrorOf( ES_SERVER, 247, E_FAILED, EV_USAGE, 0 , "805379319"),  "Usage: integrate [ -c changelist# -D<flags> -f -h -m max -n -Obr -q -r -s from -v ] -b branch [ to... ]"  ) ;
    public static final ErrorId MsgServer_UseInteged          	= new ErrorId( ErrorOf( ES_SERVER, 248, E_FAILED, EV_USAGE, 0 , "805379320"),  "Usage: integrated [ -r ] [ -b branch ] [ files... ]"  ) ;
    public static final ErrorId MsgServer_UseInterChanges     	= new ErrorId( ErrorOf( ES_SERVER, 304, E_FAILED, EV_USAGE, 0 , "805379376"),  "Usage: interchanges -f -l -t -r [ -b branch to... | -S stream [ -P parent ] [ files... ] | from to ]"  ) ;
    public static final ErrorId MsgServer_UseInterChangesS    	= new ErrorId( ErrorOf( ES_SERVER, 509, E_FAILED, EV_USAGE, 0 , "805379581"),  "Usage: interchanges -f -l -t -r -S stream [ -P parent ] [ files... ]"  ) ;
    public static final ErrorId MsgServer_UseInterChangesb    	= new ErrorId( ErrorOf( ES_SERVER, 305, E_FAILED, EV_USAGE, 0 , "805379377"),  "Usage: interchanges -f -l -t -r [ -b branch to... ]"  ) ;
    public static final ErrorId MsgServer_UseIstat            	= new ErrorId( ErrorOf( ES_SERVER, 459, E_FAILED, EV_USAGE, 0 , "805379531"),  "Usage: istat [ -a -f -r ] stream"  ) ;
    public static final ErrorId MsgServer_UseJob              	= new ErrorId( ErrorOf( ES_SERVER, 249, E_FAILED, EV_USAGE, 0 , "805379321"),  "Usage: job [ -d -f -i -o ] [ jobName ]"  ) ;
    public static final ErrorId MsgServer_UseJobSpec          	= new ErrorId( ErrorOf( ES_SERVER, 254, E_FAILED, EV_USAGE, 0 , "805379326"),  "Usage: jobspec [ -i -o ]"  ) ;
    public static final ErrorId MsgServer_UseJobd             	= new ErrorId( ErrorOf( ES_SERVER, 250, E_FAILED, EV_USAGE, 0 , "805379322"),  "Usage: job -d jobName"  ) ;
    public static final ErrorId MsgServer_UseJobi             	= new ErrorId( ErrorOf( ES_SERVER, 252, E_FAILED, EV_USAGE, 0 , "805379324"),  "Usage: job -i [ -f ]"  ) ;
    public static final ErrorId MsgServer_UseJobo             	= new ErrorId( ErrorOf( ES_SERVER, 251, E_FAILED, EV_USAGE, 0 , "805379323"),  "Usage: job -o [ jobName ]"  ) ;
    public static final ErrorId MsgServer_UseJobs             	= new ErrorId( ErrorOf( ES_SERVER, 253, E_FAILED, EV_USAGE, 0 , "805379325"),  "Usage: jobs [-e query -i -l -m count -r] [files...]"  ) ;
    public static final ErrorId MsgServer_UseKey              	= new ErrorId( ErrorOf( ES_SERVER, 624, E_FAILED, EV_USAGE, 0 , "805379696"),  "Usage: key [ -d -i ] key_name [ value ]"  ) ;
    public static final ErrorId MsgServer_UseKeyi             	= new ErrorId( ErrorOf( ES_SERVER, 625, E_FAILED, EV_USAGE, 0 , "805379697"),  "Usage: key -i key_name"  ) ;
    public static final ErrorId MsgServer_UseKeys             	= new ErrorId( ErrorOf( ES_SERVER, 628, E_FAILED, EV_USAGE, 0 , "805379700"),  "Usage: keys [ -e nameFilter ]"  ) ;
    public static final ErrorId MsgServer_UseLabel            	= new ErrorId( ErrorOf( ES_SERVER, 255, E_FAILED, EV_USAGE, 0 , "805379327"),  "Usage: label [ -d -f -i -o -t template ] labelname"  ) ;
    public static final ErrorId MsgServer_UseLabelSync        	= new ErrorId( ErrorOf( ES_SERVER, 259, E_FAILED, EV_USAGE, 0 , "805379331"),  "Usage: labelsync [-a -d -n -q] -l label [files...]"  ) ;
    public static final ErrorId MsgServer_UseLabeld           	= new ErrorId( ErrorOf( ES_SERVER, 257, E_FAILED, EV_USAGE, 0 , "805379329"),  "Usage: label -d [ -f ] labelname"  ) ;
    public static final ErrorId MsgServer_UseLabeli           	= new ErrorId( ErrorOf( ES_SERVER, 258, E_FAILED, EV_USAGE, 0 , "805379330"),  "Usage: label -i [ -f ]"  ) ;
    public static final ErrorId MsgServer_UseLabelo           	= new ErrorId( ErrorOf( ES_SERVER, 256, E_FAILED, EV_USAGE, 0 , "805379328"),  "Usage: label -o [ -t template ] labelname"  ) ;
    public static final ErrorId MsgServer_UseLabels           	= new ErrorId( ErrorOf( ES_SERVER, 535, E_FAILED, EV_USAGE, 0 , "805379607"),  "Usage: labels [ -t ] [ -u user ] [ -U ] [ [-e|-E] query -m max ]"  ) ;
    public static final ErrorId MsgServer_UseLicense          	= new ErrorId( ErrorOf( ES_SERVER, 343, E_FAILED, EV_USAGE, 0 , "805379415"),  "Usage: license [ -i | -o | -u ]"  ) ;
    public static final ErrorId MsgServer_UseList             	= new ErrorId( ErrorOf( ES_SERVER, 587, E_FAILED, EV_USAGE, 0 , "805379659"),  "Usage: list [-l label] [-M] files..."  ) ;
    public static final ErrorId MsgServer_UseLock             	= new ErrorId( ErrorOf( ES_SERVER, 260, E_FAILED, EV_USAGE, 0 , "805379332"),  "Usage: lock [-c changelist#] [files...]"  ) ;
    public static final ErrorId MsgServer_UseLockstat         	= new ErrorId( ErrorOf( ES_SERVER, 610, E_FAILED, EV_USAGE, 0 , "805379682"),  "Usage: lockstat [-c client | -C]"  ) ;
    public static final ErrorId MsgServer_UseLogAppend        	= new ErrorId( ErrorOf( ES_SERVER, 560, E_FAILED, EV_USAGE, 0 , "805379632"),  "Usage: logappend -a args..."  ) ;
    public static final ErrorId MsgServer_UseLogParse         	= new ErrorId( ErrorOf( ES_SERVER, 574, E_FAILED, EV_USAGE, 0 , "805379646"),  "Usage: logparse [ -e ] [-T field...] [-F filter] [-s offset] [-m max] logfilename"  ) ;
    public static final ErrorId MsgServer_UseLogRotate        	= new ErrorId( ErrorOf( ES_SERVER, 561, E_FAILED, EV_USAGE, 0 , "805379633"),  "Usage: logrotate [ -l log ]"  ) ;
    public static final ErrorId MsgServer_UseLogSchema        	= new ErrorId( ErrorOf( ES_SERVER, 575, E_FAILED, EV_USAGE, 0 , "805379647"),  "Usage: logschema [-a | recordtype]"  ) ;
    public static final ErrorId MsgServer_UseLogger           	= new ErrorId( ErrorOf( ES_SERVER, 261, E_FAILED, EV_USAGE, 0 , "805379333"),  "Usage: logger [ -c sequence# ] [ -t counter_name ]"  ) ;
    public static final ErrorId MsgServer_UseLogin            	= new ErrorId( ErrorOf( ES_SERVER, 316, E_FAILED, EV_USAGE, 0 , "805379388"),  "Usage: login [ -a -p ] [ -s ] [ -h host username ]"  ) ;
    public static final ErrorId MsgServer_UseLogout           	= new ErrorId( ErrorOf( ES_SERVER, 317, E_FAILED, EV_USAGE, 0 , "805379389"),  "Usage: logout [ -a ]"  ) ;
    public static final ErrorId MsgServer_UseLogstat          	= new ErrorId( ErrorOf( ES_SERVER, 579, E_FAILED, EV_USAGE, 0 , "805379651"),  "Usage: logstat [ -l log ]"  ) ;
    public static final ErrorId MsgServer_UseLogtail          	= new ErrorId( ErrorOf( ES_SERVER, 381, E_FAILED, EV_USAGE, 0 , "805379453"),  "Usage: logtail [ -b blocksize ] [ -s starting offset ] [ -m maxBlocks ] [ -l log ]"  ) ;
    public static final ErrorId MsgServer_UseMain             	= new ErrorId( ErrorOf( ES_SERVER, 262, E_FAILED, EV_USAGE, 0 , "805379334"),  "Usage: p4d -h for usage."  ) ;
    public static final ErrorId MsgServer_UseMerge            	= new ErrorId( ErrorOf( ES_SERVER, 523, E_FAILED, EV_USAGE, 0 , "805379595"),  "Usage: merge [ -c changelist# -F -m max -n -Obr -q -r -s from ] [ -b branch to... | -S stream [ -P parent ] [ file... ] | from to ]"  ) ;
    public static final ErrorId MsgServer_UseMergeS           	= new ErrorId( ErrorOf( ES_SERVER, 525, E_FAILED, EV_USAGE, 0 , "805379597"),  "Usage: merge [ -c changelist# -F -m max -n -Obr -q -r -s from ] -S stream [ -P parent ] [ file... ]"  ) ;
    public static final ErrorId MsgServer_UseMergeb           	= new ErrorId( ErrorOf( ES_SERVER, 524, E_FAILED, EV_USAGE, 0 , "805379596"),  "Usage: merge [ -c changelist# -F -m max -n -Obr -q -r -s from ] -b branch [ to... ]"  ) ;
    public static final ErrorId MsgServer_UseMonitor          	= new ErrorId( ErrorOf( ES_SERVER, 297, E_FAILED, EV_USAGE, 0 , "805379369"),  "Usage: monitor { show | terminate | clear | pause | resume }"  ) ;
    public static final ErrorId MsgServer_UseMonitorP         	= new ErrorId( ErrorOf( ES_SERVER, 511, E_FAILED, EV_USAGE, 0 , "805379583"),  "Usage: monitor pause [arg]"  ) ;
    public static final ErrorId MsgServer_UseMonitorR         	= new ErrorId( ErrorOf( ES_SERVER, 512, E_FAILED, EV_USAGE, 0 , "805379584"),  "Usage: monitor resume [arg]"  ) ;
    public static final ErrorId MsgServer_UseMonitorc         	= new ErrorId( ErrorOf( ES_SERVER, 298, E_FAILED, EV_USAGE, 0 , "805379370"),  "Usage: monitor terminate [arg]"  ) ;
    public static final ErrorId MsgServer_UseMonitorf         	= new ErrorId( ErrorOf( ES_SERVER, 299, E_FAILED, EV_USAGE, 0 , "805379371"),  "Usage: monitor clear [arg]"  ) ;
    public static final ErrorId MsgServer_UseMonitors         	= new ErrorId( ErrorOf( ES_SERVER, 300, E_FAILED, EV_USAGE, 0 , "805379372"),  "Usage: monitor show [ -a -l -e -s [ R | T | P | I ] ]"  ) ;
    public static final ErrorId MsgServer_UseMove             	= new ErrorId( ErrorOf( ES_SERVER, 375, E_FAILED, EV_USAGE, 0 , "805379447"),  "Usage: move [-c changelist#] [ -f ] [ -k ] [-t type] from to"  ) ;
    public static final ErrorId MsgServer_UseOpen             	= new ErrorId( ErrorOf( ES_SERVER, 263, E_FAILED, EV_USAGE, 0 , "805379335"),  "Usage: add/edit/delete [-c changelist#] [ -d -f -I -k -n -v ] [-t type] files..."  ) ;
    public static final ErrorId MsgServer_UseOpen2            	= new ErrorId( ErrorOf( ES_SERVER, 398, E_FAILED, EV_USAGE, 0 , "805379470"),  "Usage: add/delete [-c changelist#] [ -d -f -I -n -v ] [-t type] files..."  ) ;
    public static final ErrorId MsgServer_UseOpened           	= new ErrorId( ErrorOf( ES_SERVER, 264, E_FAILED, EV_USAGE, 0 , "805379336"),  "Usage: opened [ -a -c changelist# -C client -u user -m max -s ] [ files... ]"  ) ;
    public static final ErrorId MsgServer_UsePasswd           	= new ErrorId( ErrorOf( ES_SERVER, 265, E_FAILED, EV_USAGE, 0 , "805379337"),  "Usage: passwd [ -O oldPasswd -P newPasswd ] [ username ]"  ) ;
    public static final ErrorId MsgServer_UsePing             	= new ErrorId( ErrorOf( ES_SERVER, 391, E_FAILED, EV_USAGE, 0 , "805379463"),  "Usage: ping [ -f -p ] [ -i iterations ] [ -t seconds ] [ -c messages] [ -s server_message_size ] [-r client_message_size]"  ) ;
    public static final ErrorId MsgServer_UsePopulate	       	= new ErrorId( ErrorOf( ES_SERVER, 592, E_FAILED, EV_USAGE, 0 , "805379664"),  "Usage: populate [ -d desc -f -m max -n -o -r -s from ] [ -b branch to... | -S stream [ -P parent ] [ file... ] | from to ]"  ) ;
    public static final ErrorId MsgServer_UsePopulateS        	= new ErrorId( ErrorOf( ES_SERVER, 508, E_FAILED, EV_USAGE, 0 , "805379580"),  "Usage: populate [ -d desc -f -m max -n -o -r -s from ] -S stream [ -P parent ] [ file... ]"  ) ;
    public static final ErrorId MsgServer_UsePopulateb        	= new ErrorId( ErrorOf( ES_SERVER, 451, E_FAILED, EV_USAGE, 0 , "805379523"),  "Usage: populate [ -d desc -f -m max -n -o -r -s from ] -b branch [ to... ]"  ) ;
    public static final ErrorId MsgServer_UsePrint            	= new ErrorId( ErrorOf( ES_SERVER, 623, E_FAILED, EV_USAGE, 0 , "805379695"),  "Usage: print [-a -A -k -o localFile -q -m max] files..."  ) ;
    public static final ErrorId MsgServer_UseProperty         	= new ErrorId( ErrorOf( ES_SERVER, 636, E_FAILED, EV_USAGE, 0 , "805379708"),  "Usage: property [ -a -n name -v value | -d -n name | -l [ -n name ] ] [ -s sequence ] [ -u user | -g group ] [ -A ] [ -F filter -T taglist -m max ]"  ) ;
    public static final ErrorId MsgServer_UseProtect          	= new ErrorId( ErrorOf( ES_SERVER, 266, E_FAILED, EV_USAGE, 0 , "805379338"),  "Usage: protect [ -i | -o ]"  ) ;
    public static final ErrorId MsgServer_UseProtects         	= new ErrorId( ErrorOf( ES_SERVER, 339, E_FAILED, EV_USAGE, 0 , "805379411"),  "Usage: protects [ -a | -g group | -u user ] [ -h host ] [ -m ] [ file ... ]"  ) ;
    public static final ErrorId MsgServer_UseProxy            	= new ErrorId( ErrorOf( ES_SERVER, 288, E_FAILED, EV_USAGE, 0 , "805379360"),  "Usage: p4p -h for usage."  ) ;
    public static final ErrorId MsgServer_UseProxyInfo        	= new ErrorId( ErrorOf( ES_SERVER, 541, E_FAILED, EV_USAGE, 0 , "805379613"),  "Usage: proxy"  ) ;
    public static final ErrorId MsgServer_UsePull             	= new ErrorId( ErrorOf( ES_SERVER, 441, E_FAILED, EV_USAGE, 0 , "805379513"),  "Usage: pull [ -u | -l [ -s | -j ] | -d -f file -r rev ] [ -J prefix -P filterpattern -T tableexcludelist ] [ -i <N> ]"  ) ;
    public static final ErrorId MsgServer_UsePurge            	= new ErrorId( ErrorOf( ES_SERVER, 267, E_FAILED, EV_USAGE, 0 , "805379339"),  "Usage: obliterate [-y -A -b -a -h] files..."  ) ;
    public static final ErrorId MsgServer_UseReconcile        	= new ErrorId( ErrorOf( ES_SERVER, 582, E_FAILED, EV_USAGE, 0 , "805379654"),  "Usage: reconcile [ -c changelist# ] [ -a -e -d -l -f -I -n ] [files...]"  ) ;
    public static final ErrorId MsgServer_UseRelease          	= new ErrorId( ErrorOf( ES_SERVER, 268, E_FAILED, EV_USAGE, 0 , "805379340"),  "Usage: revert [ -a -n -k -c changelist# ] files..."  ) ;
    public static final ErrorId MsgServer_UseReload           	= new ErrorId( ErrorOf( ES_SERVER, 613, E_FAILED, EV_USAGE, 0 , "805379685"),  "Usage: reload [ -f ] [ -c client ] | [ -l label ] | [ -s stream ]"  ) ;
    public static final ErrorId MsgServer_UseReopen           	= new ErrorId( ErrorOf( ES_SERVER, 269, E_FAILED, EV_USAGE, 0 , "805379341"),  "Usage: reopen [-c changelist#] [-t type] files..."  ) ;
    public static final ErrorId MsgServer_UseResolve          	= new ErrorId( ErrorOf( ES_SERVER, 270, E_FAILED, EV_USAGE, 0 , "805379342"),  "Usage: resolve [ -af -am -as -at -ay -A<flags> -c changelist# -d<flags> -f -n -N -o -t -v ] [ files... ]"  ) ;
    public static final ErrorId MsgServer_UseResolved         	= new ErrorId( ErrorOf( ES_SERVER, 271, E_FAILED, EV_USAGE, 0 , "805379343"),  "Usage: resolved [ -o ] [files...]"  ) ;
    public static final ErrorId MsgServer_UseRestore          	= new ErrorId( ErrorOf( ES_SERVER, 454, E_FAILED, EV_USAGE, 0 , "805379526"),  "Usage: restore -D depot [-n] files..."  ) ;
    public static final ErrorId MsgServer_UseRetype           	= new ErrorId( ErrorOf( ES_SERVER, 349, E_FAILED, EV_USAGE, 0 , "805379421"),  "Usage: retype [ -l -n ] -t type files..."  ) ;
    public static final ErrorId MsgServer_UseReview           	= new ErrorId( ErrorOf( ES_SERVER, 272, E_FAILED, EV_USAGE, 0 , "805379344"),  "Usage: review [ -c start_changelist# ] [ -t counter_name ]"  ) ;
    public static final ErrorId MsgServer_UseReviews          	= new ErrorId( ErrorOf( ES_SERVER, 273, E_FAILED, EV_USAGE, 0 , "805379345"),  "Usage: reviews [ -c changelist# ] [ files... ]"  ) ;
    public static final ErrorId MsgServer_UseSearch           	= new ErrorId( ErrorOf( ES_SERVER, 274, E_FAILED, EV_USAGE, 0 , "805379346"),  "Usage: search words ..."  ) ;
    public static final ErrorId MsgServer_UseServer           	= new ErrorId( ErrorOf( ES_SERVER, 562, E_FAILED, EV_USAGE, 0 , "805379634"),  "Usage: server [ -i | -o | -d | -g ] [ serverID ]"  ) ;
    public static final ErrorId MsgServer_UseServerd          	= new ErrorId( ErrorOf( ES_SERVER, 565, E_FAILED, EV_USAGE, 0 , "805379637"),  "Usage: server -d serverID"  ) ;
    public static final ErrorId MsgServer_UseServeri          	= new ErrorId( ErrorOf( ES_SERVER, 566, E_FAILED, EV_USAGE, 0 , "805379638"),  "Usage: server -i"  ) ;
    public static final ErrorId MsgServer_UseServerid         	= new ErrorId( ErrorOf( ES_SERVER, 571, E_FAILED, EV_USAGE, 0 , "805379643"),  "Usage: serverid [ serverID ]"  ) ;
    public static final ErrorId MsgServer_UseServero          	= new ErrorId( ErrorOf( ES_SERVER, 564, E_FAILED, EV_USAGE, 0 , "805379636"),  "Usage: server -o serverID"  ) ;
    public static final ErrorId MsgServer_UseServers          	= new ErrorId( ErrorOf( ES_SERVER, 563, E_FAILED, EV_USAGE, 0 , "805379635"),  "Usage: servers"  ) ;
    public static final ErrorId MsgServer_UseShelve           	= new ErrorId( ErrorOf( ES_SERVER, 399, E_FAILED, EV_USAGE, 0 , "805379471"),  "Usage: shelve [ -i [ -f | -r ] | -r -c changelist | -c changelist [ -d ] [ -f ] [ file ... ] ] [ files ] "  ) ;
    public static final ErrorId MsgServer_UseShelveNoOpts          	= new ErrorId( ErrorOf( ES_SERVER, 416, E_FAILED, EV_USAGE, 0 , "805379488"),  "Usage: shelve [ files ]"  ) ;
    public static final ErrorId MsgServer_UseShelvec          	= new ErrorId( ErrorOf( ES_SERVER, 400, E_FAILED, EV_USAGE, 0 , "805379472"),  "Usage: shelve -c changelist# [ -d [ -f ] [ file ... ] | -r | [ -f ] [ file ... ] ]"  ) ;
    public static final ErrorId MsgServer_UseShelvei          	= new ErrorId( ErrorOf( ES_SERVER, 414, E_FAILED, EV_USAGE, 0 , "805379486"),  "Usage: shelve -i [ -f | -r ]"  ) ;
    public static final ErrorId MsgServer_UseShelver          	= new ErrorId( ErrorOf( ES_SERVER, 415, E_FAILED, EV_USAGE, 0 , "805379487"),  "Usage: shelve -r -c changelist#"  ) ;
    public static final ErrorId MsgServer_UseSizes            	= new ErrorId( ErrorOf( ES_SERVER, 341, E_FAILED, EV_USAGE, 0 , "805379413"),  "Usage: sizes [ -a -S ] [ -s | -z ] [ -b blocksize ] [ -m max ] [ -U ] files..."  ) ;
    public static final ErrorId MsgServer_UseSnap             	= new ErrorId( ErrorOf( ES_SERVER, 345, E_FAILED, EV_USAGE, 0 , "805379417"),  "Usage: snap [ -n ] source target"  ) ;
    public static final ErrorId MsgServer_UseSpec             	= new ErrorId( ErrorOf( ES_SERVER, 302, E_FAILED, EV_USAGE, 0 , "805379374"),  "Usage: spec [ -d | -i | -o ] type"  ) ;
    public static final ErrorId MsgServer_UseStatus        	= new ErrorId( ErrorOf( ES_SERVER, 596, E_FAILED, EV_USAGE, 0 , "805379668"),  "Usage: status [ -c changelist# ] [ -A | [ -a -e -d ] ] [ -f -I ] [files...]"  ) ;
    public static final ErrorId MsgServer_UseStream           	= new ErrorId( ErrorOf( ES_SERVER, 383, E_FAILED, EV_USAGE, 0 , "805379455"),  "Usage: stream [ -d -i -o -P parent -t type -v ] [ -f ] [ streamname ]"  ) ;
    public static final ErrorId MsgServer_UseStreamc          	= new ErrorId( ErrorOf( ES_SERVER, 540, E_FAILED, EV_USAGE, 0 , "805379612"),  "Usage: stream [ -P parent ] -t type streamname"  ) ;
    public static final ErrorId MsgServer_UseStreamd          	= new ErrorId( ErrorOf( ES_SERVER, 384, E_FAILED, EV_USAGE, 0 , "805379456"),  "Usage: stream -d [ -f ] streamname"  ) ;
    public static final ErrorId MsgServer_UseStreami          	= new ErrorId( ErrorOf( ES_SERVER, 385, E_FAILED, EV_USAGE, 0 , "805379457"),  "Usage: stream -i [ -f ]"  ) ;
    public static final ErrorId MsgServer_UseStreamo          	= new ErrorId( ErrorOf( ES_SERVER, 386, E_FAILED, EV_USAGE, 0 , "805379458"),  "Usage: stream [ -P parent -t type ] -o streamname"  ) ;
    public static final ErrorId MsgServer_UseStreams          	= new ErrorId( ErrorOf( ES_SERVER, 387, E_FAILED, EV_USAGE, 0 , "805379459"),  "Usage: streams [ -U -F filter -T fields -m max ] [ streamPath... ]"  ) ;
    public static final ErrorId MsgServer_UseSubmit           	= new ErrorId( ErrorOf( ES_SERVER, 275, E_FAILED, EV_USAGE, 0 , "805379347"),  "Usage: submit [ -i -s -r -f option ] [ -c changelist# | -e shelvedChange# | -d description ] [file] "  ) ;
    public static final ErrorId MsgServer_UseSubmitc          	= new ErrorId( ErrorOf( ES_SERVER, 276, E_FAILED, EV_USAGE, 0 , "805379348"),  "Usage: submit [ -r -f option ] -c changelist#"  ) ;
    public static final ErrorId MsgServer_UseSubmitd          	= new ErrorId( ErrorOf( ES_SERVER, 446, E_FAILED, EV_USAGE, 0 , "805379518"),  "Usage: submit [ -r -f option ] -d description [ file ]\n"  ) ;
    public static final ErrorId MsgServer_UseSubmite          	= new ErrorId( ErrorOf( ES_SERVER, 639, E_FAILED, EV_USAGE, 0 , "805379711"),  "Usage: submit -e shelvedChange#"  ) ;
    public static final ErrorId MsgServer_UseSync             	= new ErrorId( ErrorOf( ES_SERVER, 277, E_FAILED, EV_USAGE, 0 , "805379349"),  "Usage: sync [ -f -k -n -N -p -q -s ] [-m max] [files...]"  ) ;
    public static final ErrorId MsgServer_UseSyncp            	= new ErrorId( ErrorOf( ES_SERVER, 348, E_FAILED, EV_USAGE, 0 , "805379420"),  "Usage: sync [ -n -N -p -q ] [-m max] [files...]"  ) ;
    public static final ErrorId MsgServer_UseSyncs            	= new ErrorId( ErrorOf( ES_SERVER, 503, E_FAILED, EV_USAGE, 0 , "805379575"),  "Usage: sync [ -n -N -q -s ] [-m max] [files...]"  ) ;
    public static final ErrorId MsgServer_UseTag              	= new ErrorId( ErrorOf( ES_SERVER, 328, E_FAILED, EV_USAGE, 0 , "805379400"),  "Usage: tag [-d -n -U] -l label files..."  ) ;
    public static final ErrorId MsgServer_UseTrait            	= new ErrorId( ErrorOf( ES_SERVER, 330, E_FAILED, EV_USAGE, 0 , "805379402"),  "Usage: attribute [-e -f -p] -n name [-v value] files..."  ) ;
    public static final ErrorId MsgServer_UseTraiti           	= new ErrorId( ErrorOf( ES_SERVER, 435, E_FAILED, EV_USAGE, 0 , "805379507"),  "Usage: attribute -i [-e -f -p] -n name [file]"  ) ;
    public static final ErrorId MsgServer_UseTriggers         	= new ErrorId( ErrorOf( ES_SERVER, 278, E_FAILED, EV_USAGE, 0 , "805379350"),  "Usage: triggers [ -i | -o ]"  ) ;
    public static final ErrorId MsgServer_UseTunables    	= new ErrorId( ErrorOf( ES_SERVER, 371, E_FAILED, EV_USAGE, 0 , "805379443"),  "Usage: tunables [ -a ]"  ) ;
    public static final ErrorId MsgServer_UseTypeMap          	= new ErrorId( ErrorOf( ES_SERVER, 279, E_FAILED, EV_USAGE, 0 , "805379351"),  "Usage: typemap [ -i | -o ]"  ) ;
    public static final ErrorId MsgServer_UseUnload           	= new ErrorId( ErrorOf( ES_SERVER, 611, E_FAILED, EV_USAGE, 0 , "805379683"),  "Usage: unload [ -f -L -z ] [ -c client | -l label | -s stream ] | [-a|-al|-ac] [-d date | -u user]"  ) ;
    public static final ErrorId MsgServer_UseUnlock           	= new ErrorId( ErrorOf( ES_SERVER, 280, E_FAILED, EV_USAGE, 0 , "805379352"),  "Usage: unlock [ -f ] [-c changelist#] [files...]"  ) ;
    public static final ErrorId MsgServer_UseUnshelve         	= new ErrorId( ErrorOf( ES_SERVER, 403, E_FAILED, EV_USAGE, 0 , "805379475"),  "Usage: unshelve -s changelist# [ -f -n ] [-c changelist#] [-b branch|-S stream] [file ...]"  ) ;
    public static final ErrorId MsgServer_UseUser             	= new ErrorId( ErrorOf( ES_SERVER, 281, E_FAILED, EV_USAGE, 0 , "805379353"),  "Usage: user [ -f -d -i -o ] [ username ]"  ) ;
    public static final ErrorId MsgServer_UseUserd            	= new ErrorId( ErrorOf( ES_SERVER, 283, E_FAILED, EV_USAGE, 0 , "805379355"),  "Usage: user -d [ -f ] username"  ) ;
    public static final ErrorId MsgServer_UseUseri            	= new ErrorId( ErrorOf( ES_SERVER, 284, E_FAILED, EV_USAGE, 0 , "805379356"),  "Usage: user -i [ -f ]"  ) ;
    public static final ErrorId MsgServer_UseUsero            	= new ErrorId( ErrorOf( ES_SERVER, 282, E_FAILED, EV_USAGE, 0 , "805379354"),  "Usage: user -o username"  ) ;
    public static final ErrorId MsgServer_UseUsers            	= new ErrorId( ErrorOf( ES_SERVER, 285, E_FAILED, EV_USAGE, 0 , "805379357"),  "Usage: users [ -l -a -r -c ] [ -m max ] [ user ... ]"  ) ;
    public static final ErrorId MsgServer_UseVerify           	= new ErrorId( ErrorOf( ES_SERVER, 286, E_FAILED, EV_USAGE, 0 , "805379358"),  "Usage: verify [ -m maxRevs ] [ -q ] [ -t | -u | -v | -z ] [ -X ] [ -U ] [ -b batch ] files..."  ) ;
    public static final ErrorId MsgServer_UseWhere            	= new ErrorId( ErrorOf( ES_SERVER, 287, E_FAILED, EV_USAGE, 0 , "805379359"),  "Usage: where [files...]"  ) ;
    public static final ErrorId MsgServer_UsersCRNotBoth 	= new ErrorId( ErrorOf( ES_SERVER, 539, E_FAILED, EV_ADMIN, 0 , "807607835"),  "Users -c and -r may not be used together."  ) ;
    public static final ErrorId MsgServer_UsersCRNotReplica 	= new ErrorId( ErrorOf( ES_SERVER, 536, E_FAILED, EV_ADMIN, 0 , "807607832"),  "Users -c and -r only allowed on replica servers."  ) ;
    public static final ErrorId MsgServer_VersionedStream      	= new ErrorId( ErrorOf( ES_SERVER, 599, E_FAILED, EV_USAGE, 1 , "822156887"),  "Can't submit from a noncurrent stream client '%stream%'."  ) ;
    public static final ErrorId MsgServer_WeakPassword        	= new ErrorId( ErrorOf( ES_SERVER, 321, E_FAILED, EV_USAGE, 0 , "805379393"),  "The security level of this server requires the password to be reset."  ) ;
    public static final ErrorId MsgServer_ZFlagsConflict      	= new ErrorId( ErrorOf( ES_SERVER, 537, E_FAILED, EV_USAGE, 0 , "805379609"),  "Must not use both 'z' and 'Z' flags"  ) ;
    public static final ErrorId MsgSupp_BadMangleParams       	= new ErrorId( ErrorOf( ES_SUPP, 22, E_FATAL, EV_FAULT, 0 , "1075905558"),  "Bad parameters passed to mangler!" ) ;
    public static final ErrorId MsgSupp_BadOS                 	= new ErrorId( ErrorOf( ES_SUPP, 15, E_FATAL, EV_FAULT, 1 , "1092682767"),  "Don't know how to translate paths for OS '%arg%'!"  ) ;
    public static final ErrorId MsgSupp_Deflate               	= new ErrorId( ErrorOf( ES_SUPP, 16, E_FATAL, EV_FAULT, 0 , "1075905552"),  "Deflate failed!"  ) ;
    public static final ErrorId MsgSupp_DeflateEnd            	= new ErrorId( ErrorOf( ES_SUPP, 17, E_FATAL, EV_FAULT, 0 , "1075905553"),  "DeflateEnd failed!"  ) ;
    public static final ErrorId MsgSupp_DeflateInit           	= new ErrorId( ErrorOf( ES_SUPP, 18, E_FATAL, EV_FAULT, 0 , "1075905554"),  "DeflateInit failed!"  ) ;
    public static final ErrorId MsgSupp_ExtraArg              	= new ErrorId( ErrorOf( ES_SUPP, 6, E_FAILED, EV_USAGE, 0 , "805372934"),  "Unexpected arguments."  ) ;
    public static final ErrorId MsgSupp_HidesVar              	= new ErrorId( ErrorOf( ES_SUPP, 11, E_WARN, EV_NONE, 1 , "553649163"),  "Warning: environment variable hides registry definition of %name%."  ) ;
    public static final ErrorId MsgSupp_Inflate               	= new ErrorId( ErrorOf( ES_SUPP, 19, E_FATAL, EV_FAULT, 0 , "1075905555"),  "Inflate failed!"  ) ;
    public static final ErrorId MsgSupp_InflateInit           	= new ErrorId( ErrorOf( ES_SUPP, 20, E_FATAL, EV_FAULT, 0 , "1075905556"),  "InflateInit failed!"  ) ;
    public static final ErrorId MsgSupp_Invalid               	= new ErrorId( ErrorOf( ES_SUPP, 4, E_FAILED, EV_USAGE, 1 , "822150148"),  "Invalid option: -%option%."  ) ;
    public static final ErrorId MsgSupp_InvalidDate           	= new ErrorId( ErrorOf( ES_SUPP, 2, E_FAILED, EV_USAGE, 1 , "822150146"),  "Invalid date '%date%'."  ) ;
    public static final ErrorId MsgSupp_MagicHeader           	= new ErrorId( ErrorOf( ES_SUPP, 21, E_FATAL, EV_FAULT, 0 , "1075905557"),  "Gzip magic header wrong!"  ) ;
    public static final ErrorId MsgSupp_Needs2Arg              	= new ErrorId( ErrorOf( ES_SUPP, 23, E_FAILED, EV_USAGE, 1 , "822150167"),  "Option: -%option% needs a flag and an argument."  ) ;
    public static final ErrorId MsgSupp_NeedsArg              	= new ErrorId( ErrorOf( ES_SUPP, 5, E_FAILED, EV_USAGE, 1 , "822150149"),  "Option: -%option% needs argument."  ) ;
    public static final ErrorId MsgSupp_NeedsNonNegArg        	= new ErrorId( ErrorOf( ES_SUPP, 33, E_FAILED, EV_USAGE, 1 , "822150177"),  "Option: -%option% needs a non-negative integer argument."  ) ;
    public static final ErrorId MsgSupp_NoP4Config            	= new ErrorId( ErrorOf( ES_SUPP, 12, E_WARN, EV_NONE, 0 , "536871948"),  "Can't save in config if P4CONFIG not set."  ) ;
    public static final ErrorId MsgSupp_NoParm                	= new ErrorId( ErrorOf( ES_SUPP, 9, E_FATAL, EV_FAULT, 1 , "1092682761"),  "Required parameter '%arg%' not set!"  ) ;
    public static final ErrorId MsgSupp_NoSuchVariable        	= new ErrorId( ErrorOf( ES_SUPP, 34, E_WARN, EV_NONE, 1 , "553649186"),  "Unrecognized variable name %varName%. Comment lines should contain '#' in column 1."  ) ;
    public static final ErrorId MsgSupp_NoTrans               	= new ErrorId( ErrorOf( ES_SUPP, 14, E_WARN, EV_ILLEGAL, 2 , "570688526"),  "Translation of file content failed near line %arg%[ file %name%]"  ) ;
    public static final ErrorId MsgSupp_NoTransVar            	= new ErrorId( ErrorOf( ES_SUPP, 1, E_WARN, EV_ILLEGAL, 2 , "570688513"),  "No Translation for parameter '%arg%' value '%value%'!"  ) ;
    public static final ErrorId MsgSupp_NoUnixReg             	= new ErrorId( ErrorOf( ES_SUPP, 10, E_WARN, EV_NONE, 0 , "536871946"),  "Can't set registry on UNIX."  ) ;
    public static final ErrorId MsgSupp_OptionData            	= new ErrorId( ErrorOf( ES_SUPP, 31, E_INFO, 0, 3 , "318768159"),  "-%flag%%flag2%='%value%'"  ) ;
    public static final ErrorId MsgSupp_PartialChar           	= new ErrorId( ErrorOf( ES_SUPP, 13, E_INFO, EV_ILLEGAL, 0 , "268698637"),  "Partial character in translation"  ) ;
    public static final ErrorId MsgSupp_RegexError             	= new ErrorId( ErrorOf( ES_SUPP, 30, E_FAILED, EV_USAGE, 1 , "822150174"),  "Regular expression error: %text%"  ) ;
    public static final ErrorId MsgSupp_TooMany               	= new ErrorId( ErrorOf( ES_SUPP, 3, E_FATAL, EV_FAULT, 0 , "1075905539"),  "Too many options on command!"  ) ;
    public static final ErrorId MsgSupp_Usage                 	= new ErrorId( ErrorOf( ES_SUPP, 8, E_FAILED, EV_USAGE, 1 , "822150152"),  "Usage: %text%"  ) ;
    public static final ErrorId MsgSupp_VariableData          	= new ErrorId( ErrorOf( ES_SUPP, 32, E_INFO, 0, 3 , "318768160"),  "%name%=%value% %source%"  ) ;
    public static final ErrorId MsgSupp_WrongArg              	= new ErrorId( ErrorOf( ES_SUPP, 7, E_FAILED, EV_USAGE, 0 , "805372935"),  "Missing/wrong number of arguments."  ) ;
    public static final ErrorId MsgSupp_ZCBrowseFailed        	= new ErrorId( ErrorOf( ES_SUPP, 29, E_WARN, EV_ADMIN, 2 , "572720157"),  "Perforce could not browse zeroconf/%implementation%: error is %err%"  ) ;
    public static final ErrorId MsgSupp_ZCInvalidName         	= new ErrorId( ErrorOf( ES_SUPP, 25, E_FAILED, EV_USAGE, 1 , "822150169"),  "Invalid name '%name%'."  ) ;
    public static final ErrorId MsgSupp_ZCLoadLibFailed       	= new ErrorId( ErrorOf( ES_SUPP, 24, E_WARN, EV_ADMIN, 0 , "539165720"),  "Perforce failed to load zeroconf dynamic libraries."  ) ;
    public static final ErrorId MsgSupp_ZCNameConflict        	= new ErrorId( ErrorOf( ES_SUPP, 27, E_FATAL, EV_ADMIN, 3 , "1126368283"),  "*** WARNING duplicate of '%name%' at '%host%:%port%' ***"  ) ;
    public static final ErrorId MsgSupp_ZCRegistryFailed      	= new ErrorId( ErrorOf( ES_SUPP, 28, E_WARN, EV_ADMIN, 1 , "555942940"),  "Perforce could not register with zeroconf: error is %err%"  ) ;
    public static final ErrorId MsgSupp_ZCRequireName         	= new ErrorId( ErrorOf( ES_SUPP, 26, E_FAILED, EV_USAGE, 0 , "805372954"),  "Perforce requires IDname '-In' to register with zeroconf."  ) ;
}